// --------------------------------------------------------------------------

// ==========================================================================
// File:         TD3DClipStatus.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons)
// Description:  This file contains the code for the TD3DClipStatus Component 
//
// "TDx_Draw3D_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TD3DClipStatus.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Draw3D_Library_Defns"
#pragma link "TDx_Draw3D_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TD3DClipStatus*)
{
    new TD3DClipStatus(NULL);
}
// --------------------------------------------------------------------------
namespace Td3dclipstatus
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TD3DClipStatus)};
        RegisterComponents("TDx_Draw3D", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TD3DClipStatus::TD3DClipStatus()
// Description: The default constructor for the TD3DClipStatus object.
// --------------------------------------------------------------------------
__fastcall TD3DClipStatus::TD3DClipStatus(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
fFlags_Strings=NULL;
fStatus_Strings=NULL;
}
// --------------------------------------------------------------------------
// Destructor:  TD3DClipStatus::~TD3DClipStatus()
// Description: The destructor for the TD3DClipStatus object.
// --------------------------------------------------------------------------
__fastcall TD3DClipStatus::~TD3DClipStatus()
{
if (fFlags_Strings!=NULL) delete fFlags_Strings;
if (fStatus_Strings!=NULL) delete fStatus_Strings;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TD3DClipStatus method or fget/fset. 
//              eg. D3D_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TD3DClipStatus::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TD3DClipStatus::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Flags
// Description: The Flags property defines the type of information the 
//              component is holding. 
//              The described effect applies when the flag is set. 
// Flags:       D3DCLIPSTATUS_EXTENTS2 -
//                The component is describing the current extent, in two 
//                dimensions, of the clipping region. 
//                
//                The MaxX, MaxY, MinX and MinY properties will contain valid 
//                information. 
//                
//                Both this flag and the D3DCLIPSTATUS_EXTENTS3 flag cannot 
//                be set at the same time, they are mutually exclusive. 
//              D3DCLIPSTATUS_EXTENTS3 -
//                The component is describing the current extent, in three 
//                dimensions, of the clipping region. 
//                
//                The MaxX, MaxY, MaxZ, MinX, MinY and MinZ properties will 
//                contain valid information. 
//                
//                Both this flag and the D3DCLIPSTATUS_EXTENTS2 flag cannot 
//                be set at the same time, they are mutually exclusive. 
//                
//                Note: This flag was not yet implemented by Microsoft in 
//                DirectX 7. 
//              D3DCLIPSTATUS_STATUS -
//                The Status property of this component will contain valid 
//                information. 
// --------------------------------------------------------------------------
dword __fastcall TD3DClipStatus::FGetFlags()
{
return fD3DCLIPSTATUS.dwFlags;
}
// --------------------------------------------------------------------------
void __fastcall TD3DClipStatus::FSetFlags( dword pFlags )
{
fD3DCLIPSTATUS.dwFlags = pFlags;
}
// --------------------------------------------------------------------------
// Property:    MaxX
// Description: The MaxX property defines the maximum X axis value of the 
//              current clipping region. 
// --------------------------------------------------------------------------
float __fastcall TD3DClipStatus::FGetMaxX()
{
return fD3DCLIPSTATUS.maxx;
}
// --------------------------------------------------------------------------
void __fastcall TD3DClipStatus::FSetMaxX( float pMaxX )
{
fD3DCLIPSTATUS.maxx = pMaxX;
}
// --------------------------------------------------------------------------
// Property:    MaxY
// Description: The MaxY property defines the maximum Y axis value of the 
//              current clipping region. 
// --------------------------------------------------------------------------
float __fastcall TD3DClipStatus::FGetMaxY()
{
return fD3DCLIPSTATUS.maxy;
}
// --------------------------------------------------------------------------
void __fastcall TD3DClipStatus::FSetMaxY( float pMaxY )
{
fD3DCLIPSTATUS.maxy = pMaxY;
}
// --------------------------------------------------------------------------
// Property:    MaxZ
// Description: The MaxZ property defines the maximum Z axis value of the 
//              current clipping region. 
// --------------------------------------------------------------------------
float __fastcall TD3DClipStatus::FGetMaxZ()
{
return fD3DCLIPSTATUS.maxz;
}
// --------------------------------------------------------------------------
void __fastcall TD3DClipStatus::FSetMaxZ( float pMaxZ )
{
fD3DCLIPSTATUS.maxz = pMaxZ;
}
// --------------------------------------------------------------------------
// Property:    MinX
// Description: The MinX property defines the minimum X axis value of the 
//              current clipping region. 
// --------------------------------------------------------------------------
float __fastcall TD3DClipStatus::FGetMinX()
{
return fD3DCLIPSTATUS.minx;
}
// --------------------------------------------------------------------------
void __fastcall TD3DClipStatus::FSetMinX( float pMinX )
{
fD3DCLIPSTATUS.minx = pMinX;
}
// --------------------------------------------------------------------------
// Property:    MinY
// Description: The MinY property defines the minimum Y axis value of the 
//              current clipping region. 
// --------------------------------------------------------------------------
float __fastcall TD3DClipStatus::FGetMinY()
{
return fD3DCLIPSTATUS.miny;
}
// --------------------------------------------------------------------------
void __fastcall TD3DClipStatus::FSetMinY( float pMinY )
{
fD3DCLIPSTATUS.miny = pMinY;
}
// --------------------------------------------------------------------------
// Property:    MinZ
// Description: The MinZ property defines the minimum Z axis value of the 
//              current clipping region. 
// --------------------------------------------------------------------------
float __fastcall TD3DClipStatus::FGetMinZ()
{
return fD3DCLIPSTATUS.minz;
}
// --------------------------------------------------------------------------
void __fastcall TD3DClipStatus::FSetMinZ( float pMinZ )
{
fD3DCLIPSTATUS.minz = pMinZ;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of the internal 
//              D3DCLIPSTATUS structure. 
// --------------------------------------------------------------------------
dword __fastcall TD3DClipStatus::FGetSize()
{
return fSize;
}
// --------------------------------------------------------------------------
void __fastcall TD3DClipStatus::FSetSize( dword pSize )
{
fSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    Status
// Description: The Status property defines the current clip status and which 
//              clipping planes are active. 
//              The described effect applies when the flag is set. 
//              
//              By default, both D3DSTATUS_CLIPINTERSECTIONALL and 
//              D3DSTATUS_ZNOTVISIBLE are set. 
// Flags:       D3DCLIP_BACK -
//                All vertices are clipped by the back clipping plane of the 
//                viewing frustrum. 
//                This plane is delimited by the points (MinX, MinY, MaxZ), 
//                (MaxX, MinY, MaxZ), (MaxX, MinY, MaxZ) and (MaxX, MaxY, 
//                MaxZ). 
//              D3DCLIP_BOTTOM -
//                All vertices are clipped by the bottom clipping plane of 
//                the viewing frustum. 
//                This plane is delimited by the points (MinX, MinY, MinZ), 
//                (MaxX, MinY, MinZ), (MinX, MinY, MaxZ) and (MaxX, MinY, 
//                MaxZ). 
//              D3DCLIP_FRONT -
//                All vertices are clipped by the front clipping plane of the 
//                viewing frustum. 
//                This plane is delimited by the points (MinX, MinY, MinZ), 
//                (MaxX, MinY, MinZ), (MaxX, MinY, MinZ) and (MaxX, MaxY, 
//                MinZ). 
//              D3DCLIP_GEN0 -
//                A clipping plane that is defined by the application. 
//              D3DCLIP_GEN1 -
//                A clipping plane that is defined by the application. 
//              D3DCLIP_GEN2 -
//                A clipping plane that is defined by the application. 
//              D3DCLIP_GEN3 -
//                A clipping plane that is defined by the application. 
//              D3DCLIP_GEN4 -
//                A clipping plane that is defined by the application. 
//              D3DCLIP_GEN5 -
//                A clipping plane that is defined by the application. 
//              D3DCLIP_LEFT -
//                All vertices are clipped by the left clipping plane of the 
//                viewing frustum. 
//                This plane is delimited by the points (MinX, MinY, MinZ), 
//                (MinX, MaxY, MinZ), (MinX, MinY, MaxZ) and (MinX, MaxY, 
//                MaxZ). 
//              D3DCLIP_RIGHT -
//                All vertices are clipped by the right clipping plane of the 
//                viewing frustum. 
//                This plane is delimited by the points (MaxX, MinY, MinZ), 
//                (MaxX, MaxY, MinZ), (MaxX, MinY, MaxZ) and (MaxX, MaxY, 
//                MaxZ). 
//              D3DCLIP_TOP -
//                All vertices are clipped by the top clipping plane of the 
//                viewing frustum. 
//                This plane is delimited by the points (MinX, MaxY, MinZ), 
//                (MaxX, MaxY, MinZ), (MinX, MaxY, MaxZ) and (MaxX, MaxY, 
//                MaxZ). 
//              D3DSTATUS_CLIPINTERSECTIONALL -
//                Equivilent to setting all the clip intersection flags. 
//                This flag plus D3DSTATUS_ZNOTVISIBLE form the default 
//                setting. 
//              D3DSTATUS_CLIPINTERSECTIONBACK -
//                Compares (logical AND) the back clipping plane with the 
//                clip flags of the vertices. 
//              D3DSTATUS_CLIPINTERSECTIONBOTTOM -
//                Compares (logical AND) the bottom clipping plane with the 
//                clip flags of the vertices. 
//              D3DSTATUS_CLIPINTERSECTIONFRONT -
//                Compares (logical AND) the front clipping plane with the 
//                clip flags of the vertices. 
//              D3DSTATUS_CLIPINTERSECTIONGEN0 -
//                Compares (logical AND) an application defined clipping 
//                plane with the clip flags of the vertices. 
//              D3DSTATUS_CLIPINTERSECTIONGEN1 -
//                Compares (logical AND) an application defined clipping 
//                plane with the clip flags of the vertices. 
//              D3DSTATUS_CLIPINTERSECTIONGEN2 -
//                Compares (logical AND) an application defined clipping 
//                plane with the clip flags of the vertices. 
//              D3DSTATUS_CLIPINTERSECTIONGEN3 -
//                Compares (logical AND) an application defined clipping 
//                plane with the clip flags of the vertices. 
//              D3DSTATUS_CLIPINTERSECTIONGEN4 -
//                Compares (logical AND) an application defined clipping 
//                plane with the clip flags of the vertices. 
//              D3DSTATUS_CLIPINTERSECTIONGEN5 -
//                Compares (logical AND) an application defined clipping 
//                plane with the clip flags of the vertices. 
//              D3DSTATUS_CLIPINTERSECTIONLEFT -
//                Compares (logical AND) the left clipping plane with the 
//                clip flags of the vertices. 
//              D3DSTATUS_CLIPINTERSECTIONRIGHT -
//                Compares (logical AND) the right clipping plane with the 
//                clip flags of the vertices. 
//              D3DSTATUS_CLIPINTERSECTIONTOP -
//                Compares (logical AND) the top clipping plane with the clip 
//                flags of the vertices. 
//              D3DSTATUS_CLIPUNIONALL -
//                Equivilent to setting all the clip union flags. 
//                Since the CLIPUNION flags are equivilent to the basic flags 
//                (top,bottom,left, right,back,front, gen0-gen5), this flag 
//                can be used to essentially set all the basic flags at once. 
//              D3DSTATUS_CLIPUNIONBACK -
//                All vertices are clipped by the back clipping plane of the 
//                viewing frustum. 
//                Equivilent to D3DCLIP_BACK. 
//              D3DSTATUS_CLIPUNIONBOTTOM -
//                All vertices are clipped by the bottom clipping plane of 
//                the viewing frustum. 
//                Equivilent to D3DCLIP_BOTTOM. 
//              D3DSTATUS_CLIPUNIONFRONT -
//                All vertices are clipped by the front clipping plane of the 
//                viewing frustum. 
//                Equivilent to D3DCLIP_FRONT. 
//              D3DSTATUS_CLIPUNIONGEN0 -
//                All vertices are clipped by an application defined clipping 
//                plane. 
//                Equivilent to D3DCLIP_GEN0. 
//              D3DSTATUS_CLIPUNIONGEN1 -
//                All vertices are clipped by an application defined clipping 
//                plane. 
//                Equivilent to D3DCLIP_GEN1. 
//              D3DSTATUS_CLIPUNIONGEN2 -
//                All vertices are clipped by an application defined clipping 
//                plane. 
//                Equivilent to D3DCLIP_GEN2. 
//              D3DSTATUS_CLIPUNIONGEN3 -
//                All vertices are clipped by an application defined clipping 
//                plane. 
//                Equivilent to D3DCLIP_GEN3. 
//              D3DSTATUS_CLIPUNIONGEN4 -
//                All vertices are clipped by an application defined clipping 
//                plane. 
//                Equivilent to D3DCLIP_GEN3. 
//              D3DSTATUS_CLIPUNIONGEN5 -
//                All vertices are clipped by an application defined clipping 
//                plane. 
//                Equivilent to D3DCLIP_GEN5. 
//              D3DSTATUS_CLIPUNIONLEFT -
//                All vertices are clipped by the left clipping plane of the 
//                viewing frustum. 
//                Equivilent to D3DCLIP_LEFT. 
//              D3DSTATUS_CLIPUNIONRIGHT -
//                All vertices are clipped by the right clipping plane of the 
//                viewing frustum. 
//                Equivilent to D3DCLIP_RIGHT. 
//              D3DSTATUS_CLIPUNIONTOP -
//                All vertices are clipped by the top clipping plane of the 
//                viewing frustum. 
//                Equivilent to D3DCLIP_TOP. 
//              D3DSTATUS_DEFAULT -
//                Equivilent to setting D3DSTATUS_CLIPINTERSECTIONALL and 
//                D3DSTATUS_ZNOTVISIBLE. 
//                This is the default setting. 
//              D3DSTATUS_ZNOTVISIBLE -
//                The primative is not visible. 
//                The system sets or clears this flag when z-checking is 
//                enabled. 
// --------------------------------------------------------------------------
dword __fastcall TD3DClipStatus::FGetStatus()
{
return fD3DCLIPSTATUS.dwStatus;
}
// --------------------------------------------------------------------------
void __fastcall TD3DClipStatus::FSetStatus( dword pStatus )
{
fD3DCLIPSTATUS.dwStatus = pStatus;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TD3DClipStatus's internal D3DCLIPSTATUS structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TD3DClipStatus::Clear()
{
fErrorValue = D3D_OK;
fD3DCLIPSTATUS.dwFlags = 0;
fD3DCLIPSTATUS.maxx = 0;
fD3DCLIPSTATUS.maxy = 0;
fD3DCLIPSTATUS.maxz = 0;
fD3DCLIPSTATUS.minx = 0;
fD3DCLIPSTATUS.miny = 0;
fD3DCLIPSTATUS.minz = 0;
fSize = sizeof(D3DCLIPSTATUS);
fD3DCLIPSTATUS.dwStatus = 0;
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
D3DCLIPSTATUS* __fastcall TD3DClipStatus::FGetInternal_D3DCLIPSTATUS_Ptr()
{
return &fD3DCLIPSTATUS;
}
// --------------------------------------------------------------------------
void __fastcall TD3DClipStatus::FSetInternal_D3DCLIPSTATUS( D3DCLIPSTATUS* pD3DCLIPSTATUS )
{
if (pD3DCLIPSTATUS==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TD3DClipStatus::FSetInternal_D3DCLIPSTATUS()", "TDX_ERROR", "The supplied D3DCLIPSTATUS* was NULL" );
    return;
    }

CopyMemory( &fD3DCLIPSTATUS, pD3DCLIPSTATUS, sizeof(D3DCLIPSTATUS) );
Internal_D3DCLIPSTATUS_Update();
}
// --------------------------------------------------------------------------
void __fastcall TD3DClipStatus::Internal_D3DCLIPSTATUS_Update()
{
}

// --------------------------------------------------------------------------
// Method:      FGetFlags_
// Description: This method returns a TD3DClipStatus_Flags_Set<> of the flags 
//              in the current fD3DCLIPSTATUS.dwFlags. 
// Note:        Wrapper components use the following method to modify flags 
//              via the BCB Object Inspector. 
// --------------------------------------------------------------------------
TD3DClipStatus_Flags_Set __fastcall TD3DClipStatus::FGetFlags_()
{
TD3DClipStatus_Flags_Set TempFlags_;
TempFlags_.Clear();
if (fD3DCLIPSTATUS.dwFlags & D3DCLIPSTATUS_EXTENTS2) TempFlags_ = TempFlags_ << d3dclipstatus_extents2;
if (fD3DCLIPSTATUS.dwFlags & D3DCLIPSTATUS_EXTENTS3) TempFlags_ = TempFlags_ << d3dclipstatus_extents3;
if (fD3DCLIPSTATUS.dwFlags & D3DCLIPSTATUS_STATUS) TempFlags_ = TempFlags_ << d3dclipstatus_status;
return TempFlags_;
}
// --------------------------------------------------------------------------
void __fastcall TD3DClipStatus::FSetFlags_( TD3DClipStatus_Flags_Set pFlags_ )
{
fD3DCLIPSTATUS.dwFlags = 0;
if (pFlags_.Contains(d3dclipstatus_extents2)) fD3DCLIPSTATUS.dwFlags |= D3DCLIPSTATUS_EXTENTS2;
if (pFlags_.Contains(d3dclipstatus_extents3)) fD3DCLIPSTATUS.dwFlags |= D3DCLIPSTATUS_EXTENTS3;
if (pFlags_.Contains(d3dclipstatus_status)) fD3DCLIPSTATUS.dwFlags |= D3DCLIPSTATUS_STATUS;
}
// --------------------------------------------------------------------------
// Method:      FGetFlags_Strings()
//              This method creates and then returns a TStringList containing 
//              the current set of 'Flags' flags. 
// Note:        You must manually delete the retrieved TStringList after use 
//              to avoid memory corruption. 
// --------------------------------------------------------------------------
TStringList* __fastcall TD3DClipStatus::FGetFlags_Strings()
{
// if the strings have not been allocated
if (fFlags_Strings==NULL)
    {
    // attempt to allocate the strings
    fFlags_Strings = new TStringList();
    // if the allocation failed
    if (fFlags_Strings==NULL)
        {
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TD3DClipStatus::FGetFlags_Strings()", "TDX_ERROR", "Could not allocate memory used to retrieve various Flags_Strings" );
        return NULL;
        }
    }
fFlags_Strings->Clear();
if (fD3DCLIPSTATUS.dwFlags & D3DCLIPSTATUS_EXTENTS2) fFlags_Strings->Add("D3DCLIPSTATUS_EXTENTS2");
if (fD3DCLIPSTATUS.dwFlags & D3DCLIPSTATUS_EXTENTS3) fFlags_Strings->Add("D3DCLIPSTATUS_EXTENTS3");
if (fD3DCLIPSTATUS.dwFlags & D3DCLIPSTATUS_STATUS) fFlags_Strings->Add("D3DCLIPSTATUS_STATUS");
return fFlags_Strings;
}
// --------------------------------------------------------------------------
// Method:      FGetStatus_
// Description: This method returns a TD3DClipStatus_Status_Set<> of the 
//              flags in the current fD3DCLIPSTATUS.dwStatus. 
// Note:        Wrapper components use the following method to modify flags 
//              via the BCB Object Inspector. 
// --------------------------------------------------------------------------
TD3DClipStatus_Status_Set __fastcall TD3DClipStatus::FGetStatus_()
{
TD3DClipStatus_Status_Set TempStatus_;
TempStatus_.Clear();
if (fD3DCLIPSTATUS.dwStatus & D3DCLIP_BACK) TempStatus_ = TempStatus_ << d3dclip_back;
if (fD3DCLIPSTATUS.dwStatus & D3DCLIP_BOTTOM) TempStatus_ = TempStatus_ << d3dclip_bottom;
if (fD3DCLIPSTATUS.dwStatus & D3DCLIP_FRONT) TempStatus_ = TempStatus_ << d3dclip_front;
if (fD3DCLIPSTATUS.dwStatus & D3DCLIP_GEN0) TempStatus_ = TempStatus_ << d3dclip_gen0;
if (fD3DCLIPSTATUS.dwStatus & D3DCLIP_GEN1) TempStatus_ = TempStatus_ << d3dclip_gen1;
if (fD3DCLIPSTATUS.dwStatus & D3DCLIP_GEN2) TempStatus_ = TempStatus_ << d3dclip_gen2;
if (fD3DCLIPSTATUS.dwStatus & D3DCLIP_GEN3) TempStatus_ = TempStatus_ << d3dclip_gen3;
if (fD3DCLIPSTATUS.dwStatus & D3DCLIP_GEN4) TempStatus_ = TempStatus_ << d3dclip_gen4;
if (fD3DCLIPSTATUS.dwStatus & D3DCLIP_GEN5) TempStatus_ = TempStatus_ << d3dclip_gen5;
if (fD3DCLIPSTATUS.dwStatus & D3DCLIP_LEFT) TempStatus_ = TempStatus_ << d3dclip_left;
if (fD3DCLIPSTATUS.dwStatus & D3DCLIP_RIGHT) TempStatus_ = TempStatus_ << d3dclip_right;
if (fD3DCLIPSTATUS.dwStatus & D3DCLIP_TOP) TempStatus_ = TempStatus_ << d3dclip_top;
if (fD3DCLIPSTATUS.dwStatus & D3DSTATUS_CLIPINTERSECTIONALL) TempStatus_ = TempStatus_ << d3dstatus_clipintersectionall;
if (fD3DCLIPSTATUS.dwStatus & D3DSTATUS_CLIPINTERSECTIONBACK) TempStatus_ = TempStatus_ << d3dstatus_clipintersectionback;
if (fD3DCLIPSTATUS.dwStatus & D3DSTATUS_CLIPINTERSECTIONBOTTOM) TempStatus_ = TempStatus_ << d3dstatus_clipintersectionbottom;
if (fD3DCLIPSTATUS.dwStatus & D3DSTATUS_CLIPINTERSECTIONFRONT) TempStatus_ = TempStatus_ << d3dstatus_clipintersectionfront;
if (fD3DCLIPSTATUS.dwStatus & D3DSTATUS_CLIPINTERSECTIONGEN0) TempStatus_ = TempStatus_ << d3dstatus_clipintersectiongen0;
if (fD3DCLIPSTATUS.dwStatus & D3DSTATUS_CLIPINTERSECTIONGEN1) TempStatus_ = TempStatus_ << d3dstatus_clipintersectiongen1;
if (fD3DCLIPSTATUS.dwStatus & D3DSTATUS_CLIPINTERSECTIONLEFT) TempStatus_ = TempStatus_ << d3dstatus_clipintersectionleft;
if (fD3DCLIPSTATUS.dwStatus & D3DSTATUS_CLIPINTERSECTIONRIGHT) TempStatus_ = TempStatus_ << d3dstatus_clipintersectionright;
if (fD3DCLIPSTATUS.dwStatus & D3DSTATUS_CLIPINTERSECTIONTOP) TempStatus_ = TempStatus_ << d3dstatus_clipintersectiontop;
if (fD3DCLIPSTATUS.dwStatus & D3DSTATUS_CLIPUNIONALL) TempStatus_ = TempStatus_ << d3dstatus_clipunionall;
if (fD3DCLIPSTATUS.dwStatus & D3DSTATUS_CLIPUNIONBACK) TempStatus_ = TempStatus_ << d3dstatus_clipunionback;
if (fD3DCLIPSTATUS.dwStatus & D3DSTATUS_CLIPUNIONBOTTOM) TempStatus_ = TempStatus_ << d3dstatus_clipunionbottom;
if (fD3DCLIPSTATUS.dwStatus & D3DSTATUS_CLIPUNIONFRONT) TempStatus_ = TempStatus_ << d3dstatus_clipunionfront;
if (fD3DCLIPSTATUS.dwStatus & D3DSTATUS_CLIPUNIONGEN0) TempStatus_ = TempStatus_ << d3dstatus_clipuniongen0;
if (fD3DCLIPSTATUS.dwStatus & D3DSTATUS_CLIPUNIONGEN1) TempStatus_ = TempStatus_ << d3dstatus_clipuniongen1;
if (fD3DCLIPSTATUS.dwStatus & D3DSTATUS_CLIPUNIONLEFT) TempStatus_ = TempStatus_ << d3dstatus_clipunionleft;
if (fD3DCLIPSTATUS.dwStatus & D3DSTATUS_CLIPUNIONRIGHT) TempStatus_ = TempStatus_ << d3dstatus_clipunionright;
if (fD3DCLIPSTATUS.dwStatus & D3DSTATUS_CLIPUNIONTOP) TempStatus_ = TempStatus_ << d3dstatus_clipuniontop;
if (fD3DCLIPSTATUS.dwStatus & D3DSTATUS_DEFAULT) TempStatus_ = TempStatus_ << d3dstatus_default;
if (fD3DCLIPSTATUS.dwStatus & D3DSTATUS_ZNOTVISIBLE) TempStatus_ = TempStatus_ << d3dstatus_znotvisible;
return TempStatus_;
}
// --------------------------------------------------------------------------
void __fastcall TD3DClipStatus::FSetStatus_( TD3DClipStatus_Status_Set pStatus_ )
{
fD3DCLIPSTATUS.dwStatus = 0;
if (pStatus_.Contains(d3dclip_back)) fD3DCLIPSTATUS.dwStatus |= D3DCLIP_BACK;
if (pStatus_.Contains(d3dclip_bottom)) fD3DCLIPSTATUS.dwStatus |= D3DCLIP_BOTTOM;
if (pStatus_.Contains(d3dclip_front)) fD3DCLIPSTATUS.dwStatus |= D3DCLIP_FRONT;
if (pStatus_.Contains(d3dclip_gen0)) fD3DCLIPSTATUS.dwStatus |= D3DCLIP_GEN0;
if (pStatus_.Contains(d3dclip_gen1)) fD3DCLIPSTATUS.dwStatus |= D3DCLIP_GEN1;
if (pStatus_.Contains(d3dclip_gen2)) fD3DCLIPSTATUS.dwStatus |= D3DCLIP_GEN2;
if (pStatus_.Contains(d3dclip_gen3)) fD3DCLIPSTATUS.dwStatus |= D3DCLIP_GEN3;
if (pStatus_.Contains(d3dclip_gen4)) fD3DCLIPSTATUS.dwStatus |= D3DCLIP_GEN4;
if (pStatus_.Contains(d3dclip_gen5)) fD3DCLIPSTATUS.dwStatus |= D3DCLIP_GEN5;
if (pStatus_.Contains(d3dclip_left)) fD3DCLIPSTATUS.dwStatus |= D3DCLIP_LEFT;
if (pStatus_.Contains(d3dclip_right)) fD3DCLIPSTATUS.dwStatus |= D3DCLIP_RIGHT;
if (pStatus_.Contains(d3dclip_top)) fD3DCLIPSTATUS.dwStatus |= D3DCLIP_TOP;
if (pStatus_.Contains(d3dstatus_clipintersectionall)) fD3DCLIPSTATUS.dwStatus |= D3DSTATUS_CLIPINTERSECTIONALL;
if (pStatus_.Contains(d3dstatus_clipintersectionback)) fD3DCLIPSTATUS.dwStatus |= D3DSTATUS_CLIPINTERSECTIONBACK;
if (pStatus_.Contains(d3dstatus_clipintersectionbottom)) fD3DCLIPSTATUS.dwStatus |= D3DSTATUS_CLIPINTERSECTIONBOTTOM;
if (pStatus_.Contains(d3dstatus_clipintersectionfront)) fD3DCLIPSTATUS.dwStatus |= D3DSTATUS_CLIPINTERSECTIONFRONT;
if (pStatus_.Contains(d3dstatus_clipintersectiongen0)) fD3DCLIPSTATUS.dwStatus |= D3DSTATUS_CLIPINTERSECTIONGEN0;
if (pStatus_.Contains(d3dstatus_clipintersectiongen1)) fD3DCLIPSTATUS.dwStatus |= D3DSTATUS_CLIPINTERSECTIONGEN1;
if (pStatus_.Contains(d3dstatus_clipintersectionleft)) fD3DCLIPSTATUS.dwStatus |= D3DSTATUS_CLIPINTERSECTIONLEFT;
if (pStatus_.Contains(d3dstatus_clipintersectionright)) fD3DCLIPSTATUS.dwStatus |= D3DSTATUS_CLIPINTERSECTIONRIGHT;
if (pStatus_.Contains(d3dstatus_clipintersectiontop)) fD3DCLIPSTATUS.dwStatus |= D3DSTATUS_CLIPINTERSECTIONTOP;
if (pStatus_.Contains(d3dstatus_clipunionall)) fD3DCLIPSTATUS.dwStatus |= D3DSTATUS_CLIPUNIONALL;
if (pStatus_.Contains(d3dstatus_clipunionback)) fD3DCLIPSTATUS.dwStatus |= D3DSTATUS_CLIPUNIONBACK;
if (pStatus_.Contains(d3dstatus_clipunionbottom)) fD3DCLIPSTATUS.dwStatus |= D3DSTATUS_CLIPUNIONBOTTOM;
if (pStatus_.Contains(d3dstatus_clipunionfront)) fD3DCLIPSTATUS.dwStatus |= D3DSTATUS_CLIPUNIONFRONT;
if (pStatus_.Contains(d3dstatus_clipuniongen0)) fD3DCLIPSTATUS.dwStatus |= D3DSTATUS_CLIPUNIONGEN0;
if (pStatus_.Contains(d3dstatus_clipuniongen1)) fD3DCLIPSTATUS.dwStatus |= D3DSTATUS_CLIPUNIONGEN1;
if (pStatus_.Contains(d3dstatus_clipunionleft)) fD3DCLIPSTATUS.dwStatus |= D3DSTATUS_CLIPUNIONLEFT;
if (pStatus_.Contains(d3dstatus_clipunionright)) fD3DCLIPSTATUS.dwStatus |= D3DSTATUS_CLIPUNIONRIGHT;
if (pStatus_.Contains(d3dstatus_clipuniontop)) fD3DCLIPSTATUS.dwStatus |= D3DSTATUS_CLIPUNIONTOP;
if (pStatus_.Contains(d3dstatus_default)) fD3DCLIPSTATUS.dwStatus |= D3DSTATUS_DEFAULT;
if (pStatus_.Contains(d3dstatus_znotvisible)) fD3DCLIPSTATUS.dwStatus |= D3DSTATUS_ZNOTVISIBLE;
}
// --------------------------------------------------------------------------
// Method:      FGetStatus_Strings()
//              This method creates and then returns a TStringList containing 
//              the current set of 'Status' flags. 
// Note:        You must manually delete the retrieved TStringList after use 
//              to avoid memory corruption. 
// --------------------------------------------------------------------------
TStringList* __fastcall TD3DClipStatus::FGetStatus_Strings()
{
// if the strings have not been allocated
if (fStatus_Strings==NULL)
    {
    // attempt to allocate the strings
    fStatus_Strings = new TStringList();
    // if the allocation failed
    if (fStatus_Strings==NULL)
        {
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TD3DClipStatus::FGetStatus_Strings()", "TDX_ERROR", "Could not allocate memory used to retrieve various Status_Strings" );
        return NULL;
        }
    }
fStatus_Strings->Clear();
if (fD3DCLIPSTATUS.dwStatus & D3DCLIP_BACK) fStatus_Strings->Add("D3DCLIP_BACK");
if (fD3DCLIPSTATUS.dwStatus & D3DCLIP_BOTTOM) fStatus_Strings->Add("D3DCLIP_BOTTOM");
if (fD3DCLIPSTATUS.dwStatus & D3DCLIP_FRONT) fStatus_Strings->Add("D3DCLIP_FRONT");
if (fD3DCLIPSTATUS.dwStatus & D3DCLIP_GEN0) fStatus_Strings->Add("D3DCLIP_GEN0");
if (fD3DCLIPSTATUS.dwStatus & D3DCLIP_GEN1) fStatus_Strings->Add("D3DCLIP_GEN1");
if (fD3DCLIPSTATUS.dwStatus & D3DCLIP_GEN2) fStatus_Strings->Add("D3DCLIP_GEN2");
if (fD3DCLIPSTATUS.dwStatus & D3DCLIP_GEN3) fStatus_Strings->Add("D3DCLIP_GEN3");
if (fD3DCLIPSTATUS.dwStatus & D3DCLIP_GEN4) fStatus_Strings->Add("D3DCLIP_GEN4");
if (fD3DCLIPSTATUS.dwStatus & D3DCLIP_GEN5) fStatus_Strings->Add("D3DCLIP_GEN5");
if (fD3DCLIPSTATUS.dwStatus & D3DCLIP_LEFT) fStatus_Strings->Add("D3DCLIP_LEFT");
if (fD3DCLIPSTATUS.dwStatus & D3DCLIP_RIGHT) fStatus_Strings->Add("D3DCLIP_RIGHT");
if (fD3DCLIPSTATUS.dwStatus & D3DCLIP_TOP) fStatus_Strings->Add("D3DCLIP_TOP");
if (fD3DCLIPSTATUS.dwStatus & D3DSTATUS_CLIPINTERSECTIONALL) fStatus_Strings->Add("D3DSTATUS_CLIPINTERSECTIONALL");
if (fD3DCLIPSTATUS.dwStatus & D3DSTATUS_CLIPINTERSECTIONBACK) fStatus_Strings->Add("D3DSTATUS_CLIPINTERSECTIONBACK");
if (fD3DCLIPSTATUS.dwStatus & D3DSTATUS_CLIPINTERSECTIONBOTTOM) fStatus_Strings->Add("D3DSTATUS_CLIPINTERSECTIONBOTTOM");
if (fD3DCLIPSTATUS.dwStatus & D3DSTATUS_CLIPINTERSECTIONFRONT) fStatus_Strings->Add("D3DSTATUS_CLIPINTERSECTIONFRONT");
if (fD3DCLIPSTATUS.dwStatus & D3DSTATUS_CLIPINTERSECTIONGEN0) fStatus_Strings->Add("D3DSTATUS_CLIPINTERSECTIONGEN0");
if (fD3DCLIPSTATUS.dwStatus & D3DSTATUS_CLIPINTERSECTIONGEN1) fStatus_Strings->Add("D3DSTATUS_CLIPINTERSECTIONGEN1");
if (fD3DCLIPSTATUS.dwStatus & D3DSTATUS_CLIPINTERSECTIONLEFT) fStatus_Strings->Add("D3DSTATUS_CLIPINTERSECTIONLEFT");
if (fD3DCLIPSTATUS.dwStatus & D3DSTATUS_CLIPINTERSECTIONRIGHT) fStatus_Strings->Add("D3DSTATUS_CLIPINTERSECTIONRIGHT");
if (fD3DCLIPSTATUS.dwStatus & D3DSTATUS_CLIPINTERSECTIONTOP) fStatus_Strings->Add("D3DSTATUS_CLIPINTERSECTIONTOP");
if (fD3DCLIPSTATUS.dwStatus & D3DSTATUS_CLIPUNIONALL) fStatus_Strings->Add("D3DSTATUS_CLIPUNIONALL");
if (fD3DCLIPSTATUS.dwStatus & D3DSTATUS_CLIPUNIONBACK) fStatus_Strings->Add("D3DSTATUS_CLIPUNIONBACK");
if (fD3DCLIPSTATUS.dwStatus & D3DSTATUS_CLIPUNIONBOTTOM) fStatus_Strings->Add("D3DSTATUS_CLIPUNIONBOTTOM");
if (fD3DCLIPSTATUS.dwStatus & D3DSTATUS_CLIPUNIONFRONT) fStatus_Strings->Add("D3DSTATUS_CLIPUNIONFRONT");
if (fD3DCLIPSTATUS.dwStatus & D3DSTATUS_CLIPUNIONGEN0) fStatus_Strings->Add("D3DSTATUS_CLIPUNIONGEN0");
if (fD3DCLIPSTATUS.dwStatus & D3DSTATUS_CLIPUNIONGEN1) fStatus_Strings->Add("D3DSTATUS_CLIPUNIONGEN1");
if (fD3DCLIPSTATUS.dwStatus & D3DSTATUS_CLIPUNIONLEFT) fStatus_Strings->Add("D3DSTATUS_CLIPUNIONLEFT");
if (fD3DCLIPSTATUS.dwStatus & D3DSTATUS_CLIPUNIONRIGHT) fStatus_Strings->Add("D3DSTATUS_CLIPUNIONRIGHT");
if (fD3DCLIPSTATUS.dwStatus & D3DSTATUS_CLIPUNIONTOP) fStatus_Strings->Add("D3DSTATUS_CLIPUNIONTOP");
if (fD3DCLIPSTATUS.dwStatus & D3DSTATUS_DEFAULT) fStatus_Strings->Add("D3DSTATUS_DEFAULT");
if (fD3DCLIPSTATUS.dwStatus & D3DSTATUS_ZNOTVISIBLE) fStatus_Strings->Add("D3DSTATUS_ZNOTVISIBLE");
return fStatus_Strings;
}
// --------------------------------------------------------------------------
