#ifndef TD3DDeviceDescH
#define TD3DDeviceDescH

// ==========================================================================
// File:         TD3DDeviceDesc.H
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons)
// Description:  This file defines the TD3DDeviceDesc Component 
//
// "TDx_Draw3D_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
#include "TDx_Library_Defns.H"
#include "TDx_Library_Functions.H"
// --------------------------------------------------------------------------
#include "TDx_Draw3D_Library_Defns.H"
#include "TDx_Draw3D_Library_Functions.H"
// --------------------------------------------------------------------------
// external classes used by TD3DDeviceDesc properties.
#include "TD3DPrimCaps.H"

// ==========================================================================
// Set:         TD3DDeviceDescDevCaps_Set
// Description: A set of mangled DirectX flag names that are used to set the 
//              TD3DDeviceDesc::DevCaps property using the BCB Object 
//              Inspector. For detailed descriptions of each flag, see the 
//              DevCaps property description below. 
// ==========================================================================
enum TD3DDeviceDesc_DevCaps_Flags
    {
    d3ddevcaps_canbltsystononlocal,
    d3ddevcaps_canrenderafterflip,
    d3ddevcaps_drawprimtlvertex,
    d3ddevcaps_floattlvertex,
    d3ddevcaps_hwrasterization,
    d3ddevcaps_hwtransformandlight,
    d3ddevcaps_separatetexturememories,
    d3ddevcaps_sortdecreasingz,
    d3ddevcaps_sortexact,
    d3ddevcaps_sortincreasingz,
    d3ddevcaps_texturenonlocalvidmem,
    d3ddevcaps_texturesystemmemory,
    d3ddevcaps_texturevideomemory,
    d3ddevcaps_tlvertexsystemmemory,
    d3ddevcaps_tlvertexvideomemory
    };
typedef Set< TD3DDeviceDesc_DevCaps_Flags, 
             d3ddevcaps_canbltsystononlocal, 
             d3ddevcaps_tlvertexvideomemory >  TD3DDeviceDesc_DevCaps_Set;
// ==========================================================================
// Set:         TD3DDeviceDescFVFCaps_Set
// Description: A set of mangled DirectX flag names that are used to set the 
//              TD3DDeviceDesc::FVFCaps property using the BCB Object 
//              Inspector. For detailed descriptions of each flag, see the 
//              FVFCaps property description below. 
// ==========================================================================
enum TD3DDeviceDesc_FVFCaps_Flags
    {
    d3dfvfcaps_donotstripelements,
    d3dfvfcaps_texcoordcountmask
    };
typedef Set< TD3DDeviceDesc_FVFCaps_Flags, 
             d3dfvfcaps_donotstripelements, 
             d3dfvfcaps_texcoordcountmask >  TD3DDeviceDesc_FVFCaps_Set;
// ==========================================================================
// Set:         TD3DDeviceDescStencilCaps_Set
// Description: A set of mangled DirectX flag names that are used to set the 
//              TD3DDeviceDesc::StencilCaps property using the BCB Object 
//              Inspector. For detailed descriptions of each flag, see the 
//              StencilCaps property description below. 
// ==========================================================================
enum TD3DDeviceDesc_StencilCaps_Flags
    {
    d3dstencilcaps_decr,
    d3dstencilcaps_decrsat,
    d3dstencilcaps_incrsat,
    d3dstencilcaps_invert,
    d3dstencilcaps_keep,
    d3dstencilcaps_replace,
    d3dstencilcaps_zero,
    d3dstencilop_incr
    };
typedef Set< TD3DDeviceDesc_StencilCaps_Flags, 
             d3dstencilcaps_decr, 
             d3dstencilop_incr >  TD3DDeviceDesc_StencilCaps_Set;
// ==========================================================================
// Set:         TD3DDeviceDescTextureOpCaps_Set
// Description: A set of mangled DirectX flag names that are used to set the 
//              TD3DDeviceDesc::TextureOpCaps property using the BCB Object 
//              Inspector. For detailed descriptions of each flag, see the 
//              TextureOpCaps property description below. 
// ==========================================================================
enum TD3DDeviceDesc_TextureOpCaps_Flags
    {
    d3dtexopcaps_add,
    d3dtexopcaps_addsigned,
    d3dtexopcaps_addsigned2x,
    d3dtexopcaps_addsmooth,
    d3dtexopcaps_blendcurrentalpha,
    d3dtexopcaps_blenddiffusealpha,
    d3dtexopcaps_blendfactoralpha,
    d3dtexopcaps_blendtexturealpha,
    d3dtexopcaps_blendtexturealphapm,
    d3dtexopcaps_bumpenvmap,
    d3dtexopcaps_bumpenvmapluminance,
    d3dtexopcaps_disable,
    d3dtexopcaps_dotproduct3,
    d3dtexopcaps_modulate,
    d3dtexopcaps_modulate2x,
    d3dtexopcaps_modulate4x,
    d3dtexopcaps_modulatealpha_addcolor,
    d3dtexopcaps_modulatecolor_addalpha,
    d3dtexopcaps_modulateinvalpha_addcolor,
    d3dtexopcaps_modulateinvcolor_addalpha,
    d3dtexopcaps_premodulate,
    d3dtexopcaps_selectarg1,
    d3dtexopcaps_selectarg2,
    d3dtexopcaps_subtract
    };
typedef Set< TD3DDeviceDesc_TextureOpCaps_Flags, 
             d3dtexopcaps_add, 
             d3dtexopcaps_subtract >  TD3DDeviceDesc_TextureOpCaps_Set;
// ==========================================================================
// Set:         TD3DDeviceDescVertexProcessingCaps_Set
// Description: A set of mangled DirectX flag names that are used to set the 
//              TD3DDeviceDesc::VertexProcessingCaps property using the BCB 
//              Object Inspector. For detailed descriptions of each flag, see 
//              the VertexProcessingCaps property description below. 
// ==========================================================================
enum TD3DDeviceDesc_VertexProcessingCaps_Flags
    {
    d3dvtxpcaps_directionallights,
    d3dvtxpcaps_materialsource7,
    d3dvtxpcaps_positionallights,
    d3dvtxpcaps_texgen,
    d3dvtxpcaps_vertexfog
    };
typedef Set< TD3DDeviceDesc_VertexProcessingCaps_Flags, 
             d3dvtxpcaps_directionallights, 
             d3dvtxpcaps_vertexfog >  TD3DDeviceDesc_VertexProcessingCaps_Set;

// --------------------------------------------------------------------------
// ==========================================================================
// Class:       TD3DDeviceDesc
// Description: The TD3DDeviceDesc component wraps the DirectX D3DDEVICEDESC7 
//              structure which describes the current device. 
//              
//              This component is used by the TDx_3DDevice::GetCaps() method 
//              to hold the current device's hardware and software 
//              capabilities and by the TDx_3D::OnEnumDevicesCallback() event 
//              to report the hardware and software capabilities of the 
//              currently enumerated device. 
// ==========================================================================
#if (__BORLANDC__ >= 0x0530) // BCB Version 3 +
class PACKAGE TD3DDeviceDesc : public TComponent
{
// --------------------------------------------------------------------------
#else // BCB Version 1
class TD3DDeviceDesc : public TComponent
{
#endif
// ==========================================================================
__published:
// ==========================================================================

    // ----------------------------------------------------------------------
    // Property:    DevCaps_
    // Description: The DevCaps property defines the capabilities supported 
    //              by the device. 
    //              The described effect applies when the flag is set. 
    // Note:        This property is used to set the various DirectX Flags 
    //              for the 'DevCaps' property via the BCB Object Inspector. 
    //               For detailed descriptions of each flag, see the DevCaps 
    //              property description below. 
    // ----------------------------------------------------------------------
    __property TD3DDeviceDesc_DevCaps_Set DevCaps_ = { read=FGetDevCaps_, 
    write=FSetDevCaps_, nodefault }; 

    // ----------------------------------------------------------------------
    // Property:    FVFCaps_
    // Description: The FVFCaps property defines the flexible vertex format 
    //              capabilities of the device. 
    //              The described effect applies when the flag is set. 
    // Note:        This property is used to set the various DirectX Flags 
    //              for the 'FVFCaps' property via the BCB Object Inspector. 
    //               For detailed descriptions of each flag, see the FVFCaps 
    //              property description below. 
    // ----------------------------------------------------------------------
    __property TD3DDeviceDesc_FVFCaps_Set FVFCaps_ = { read=FGetFVFCaps_, 
    write=FSetFVFCaps_, nodefault }; 

    // ----------------------------------------------------------------------
    // Property:    StencilCaps_
    // Description: The StencilCaps property defines the stencil-buffer 
    //              capabilities of the device. 
    //              The described effect applies when the flag is set. 
    //              
    //              Stencil buffer entries are integer values between 0 
    //              through 2n-1, where n is the bit depth of the stencil 
    //              buffer. 
    //              All stencil operations are assumed valid for the 
    //              D3DRENDERSTATE_STENCILFAIL, D3DRENDERSTATE_STENCILPASS 
    //              and D3DRENDERSTATE_STENCILFAILZFAIL render states. 
    // Note:        This property is used to set the various DirectX Flags 
    //              for the 'StencilCaps' property via the BCB Object 
    //              Inspector.  For detailed descriptions of each flag, see 
    //              the StencilCaps property description below. 
    // ----------------------------------------------------------------------
    __property TD3DDeviceDesc_StencilCaps_Set StencilCaps_ = { 
    read=FGetStencilCaps_, write=FSetStencilCaps_, nodefault }; 

    // ----------------------------------------------------------------------
    // Property:    TextureOpCaps_
    // Description: The TextureOpCaps property defines the texture operation 
    //              capabilities supported by the device. 
    //              The described effect applies when the flag is set. 
    // Note:        This property is used to set the various DirectX Flags 
    //              for the 'TextureOpCaps' property via the BCB Object 
    //              Inspector.  For detailed descriptions of each flag, see 
    //              the TextureOpCaps property description below. 
    // ----------------------------------------------------------------------
    __property TD3DDeviceDesc_TextureOpCaps_Set TextureOpCaps_ = { 
    read=FGetTextureOpCaps_, write=FSetTextureOpCaps_, nodefault }; 

    // ----------------------------------------------------------------------
    // Property:    VertexProcessingCaps_
    // Description: The VertexProcessingCaps property defines the vertex 
    //              processing capabilities supported by the device. 
    //              The described effect applies when the flag is set. 
    // Note:        This property is used to set the various DirectX Flags 
    //              for the 'VertexProcessingCaps' property via the BCB 
    //              Object Inspector.  For detailed descriptions of each 
    //              flag, see the VertexProcessingCaps property description 
    //              below. 
    // ----------------------------------------------------------------------
    __property TD3DDeviceDesc_VertexProcessingCaps_Set VertexProcessingCaps_ 
    = { read=FGetVertexProcessingCaps_, write=FSetVertexProcessingCaps_, 
    nodefault }; 

    // ----------------------------------------------------------------------
    // Property:    DeviceRenderBitDepth
    // Description: The DeviceRenderBitDepth property defines the device's 
    //              rendering bit depth. 
    //              
    //              Possible values are one or more of the DirectDraw bit 
    //              depth constants: 
    //              
    //              DDBD_8 
    //              DDBD_16 
    //              DDBD_24 
    //              DDBD_32 
    // ----------------------------------------------------------------------
    __property dword DeviceRenderBitDepth = { read=FGetDeviceRenderBitDepth, 
    write=FSetDeviceRenderBitDepth, default=0 }; 

    // ----------------------------------------------------------------------
    // Property:    DeviceZBufferBitDepth
    // Description: The DeviceZBufferBitDepth property defines the device's 
    //              z-buffer bit depth. 
    //              
    //              Possible values are one or more of the DirectDraw bit 
    //              depth constants: 
    //              
    //              DDBD_8 
    //              DDBD_16 
    //              DDBD_24 
    //              DDBD_32 
    // ----------------------------------------------------------------------
    __property dword DeviceZBufferBitDepth = { 
    read=FGetDeviceZBufferBitDepth, write=FSetDeviceZBufferBitDepth, 
    default=0 }; 

    // ----------------------------------------------------------------------
    // Property:    LineCaps
    // Description: The LineCaps property references a TD3DPrimCaps component 
    //              defining the line drawing capabilities of the device. 
    // ----------------------------------------------------------------------
    __property TD3DPrimCaps* LineCaps = { read=FGetLineCaps, 
    write=FSetLineCaps, default=NULL }; 

    // ----------------------------------------------------------------------
    // Property:    MaxActiveLights
    // Description: The MaxActiveLights property defines the maximum number 
    //              of lights the hardware can support simultaneously. 
    // ----------------------------------------------------------------------
    __property dword MaxActiveLights = { read=FGetMaxActiveLights, 
    write=FSetMaxActiveLights, default=0 }; 

    // ----------------------------------------------------------------------
    // Property:    MaxAnisotropy
    // Description: The MaxAnisotropy property defines the maximum value 
    //              allowed for the D3DTSS_MAXANISOTROPY texture stage state. 
    // ----------------------------------------------------------------------
    __property dword MaxAnisotropy = { read=FGetMaxAnisotropy, 
    write=FSetMaxAnisotropy, default=0 }; 

    // ----------------------------------------------------------------------
    // Property:    MaxSimultaneousTextures
    // Description: The MaxSimultaneousTextures property defines the maximum 
    //              number of texture blending stages that can have textures 
    //              bound to them by the TDDirect3DDevice::SetTexture() 
    //              method. 
    // ----------------------------------------------------------------------
    __property word MaxSimultaneousTextures = { 
    read=FGetMaxSimultaneousTextures, write=FSetMaxSimultaneousTextures, 
    default=0 }; 

    // ----------------------------------------------------------------------
    // Property:    MaxTextureAspectRatio
    // Description: The MaxTextureAspectRatio property defines the maximum 
    //              texture scaling supported and is usually a power of two. 
    // ----------------------------------------------------------------------
    __property dword MaxTextureAspectRatio = { 
    read=FGetMaxTextureAspectRatio, write=FSetMaxTextureAspectRatio, 
    default=0 }; 

    // ----------------------------------------------------------------------
    // Property:    MaxTextureBlendStages
    // Description: The MaxTextureBlendStages property defines the maximum 
    //              number of texture blending stages the hardware supports. 
    // ----------------------------------------------------------------------
    __property word MaxTextureBlendStages = { read=FGetMaxTextureBlendStages, 
    write=FSetMaxTextureBlendStages, default=0 }; 

    // ----------------------------------------------------------------------
    // Property:    MaxTextureHeight
    // Description: The MaxTextureHeight property defines the maximum texture 
    //              height the device supports. 
    // ----------------------------------------------------------------------
    __property dword MaxTextureHeight = { read=FGetMaxTextureHeight, 
    write=FSetMaxTextureHeight, default=0 }; 

    // ----------------------------------------------------------------------
    // Property:    MaxTextureRepeat
    // Description: The MaxTextureRepeat property defines the integer range 
    //              of post normalised texture indices. 
    //              
    //              If D3DPTEXTURECAPS_TEXREPEATNOTSCALEDBYSIZE is set, 
    //              texture size scaling is deferred until after the texture 
    //              address mode is applied. 
    //              If D3DPTEXTURECAPS_TEXREPEATNOTSCALEDBYSIZE is not set, 
    //              texture indices are scaled by the largest level of detail 
    //              prior to interpolation. 
    // ----------------------------------------------------------------------
    __property dword MaxTextureRepeat = { read=FGetMaxTextureRepeat, 
    write=FSetMaxTextureRepeat, default=0 }; 

    // ----------------------------------------------------------------------
    // Property:    MaxTextureWidth
    // Description: The MaxTextureWidth property defines the maximum texture 
    //              width the device supports. 
    // ----------------------------------------------------------------------
    __property dword MaxTextureWidth = { read=FGetMaxTextureWidth, 
    write=FSetMaxTextureWidth, default=0 }; 

    // ----------------------------------------------------------------------
    // Property:    MaxUserClipPlanes
    // Description: The MaxUserClipPlanes property defines the maximum number 
    //              of user-defined cliiping planes that are supported. 
    //              
    //              Values can range from 0 to D3DMAXUSERCLIPPLANES. 
    //              User defined clip planes are manipulated using the 
    //              TDx_3DDevice::GetClipPlane() and 
    //              TDx_3DDevice::SetClipPlane() methods. 
    // ----------------------------------------------------------------------
    __property word MaxUserClipPlanes = { read=FGetMaxUserClipPlanes, 
    write=FSetMaxUserClipPlanes, default=0 }; 

    // ----------------------------------------------------------------------
    // Property:    MaxVertexBlendMatrices
    // Description: The MaxVertexBlendMatrices property defines the maximum 
    //              number of matrices the devicec can apply to multimatrix 
    //              vertex blending. 
    // ----------------------------------------------------------------------
    __property word MaxVertexBlendMatrices = { 
    read=FGetMaxVertexBlendMatrices, write=FSetMaxVertexBlendMatrices, 
    default=0 }; 

    // ----------------------------------------------------------------------
    // Property:    MinTextureHeight
    // Description: The MinTextureHeight property defines the minimum texture 
    //              height the device supports. 
    // ----------------------------------------------------------------------
    __property dword MinTextureHeight = { read=FGetMinTextureHeight, 
    write=FSetMinTextureHeight, default=0 }; 

    // ----------------------------------------------------------------------
    // Property:    MinTextureWidth
    // Description: The MinTextureWidth property defines the minimum texture 
    //              width the device supports. 
    // ----------------------------------------------------------------------
    __property dword MinTextureWidth = { read=FGetMinTextureWidth, 
    write=FSetMinTextureWidth, default=0 }; 

    // ----------------------------------------------------------------------
    // Property:    TriCaps
    // Description: The TriCaps property references a TD3DPrimCaps component 
    //              defining the triangle drawing capabilities of the device. 
    // ----------------------------------------------------------------------
    __property TD3DPrimCaps* TriCaps = { read=FGetTriCaps, write=FSetTriCaps, 
    default=NULL }; 

    // ----------------------------------------------------------------------
    // Event:       OnError()
    // Description: The OnError event is called when an error occurs in the 
    //              TD3DDeviceDesc component. 
    // ----------------------------------------------------------------------
    __property TDx_Error OnError = {read=FOnError, write=FOnError, 
    nodefault}; 

// ==========================================================================
public:
// ==========================================================================

    // ----------------------------------------------------------------------
    // Property:    DevCaps
    // Description: The DevCaps property defines the capabilities supported 
    //              by the device. 
    //              The described effect applies when the flag is set. 
    // Flags:       D3DDEVCAPS_CANBLTSYSTONONLOCAL -
    //                Support for blitting from system memory textures to 
    //                non-local video memory textures is available. 
    //              D3DDEVCAPS_CANRENDERAFTERFLIP -
    //                Support for queuing rendering commands after a page 
    //                flip is available.   
    //              D3DDEVCAPS_DRAWPRIMTLVERTEX -
    //                This device exports a DrawPrimitive aware hardware 
    //                abstraction layer (HAL). 
    //              D3DDEVCAPS_FLOATTLVERTEX -
    //                Support for floating point values of post transform 
    //                vertex data is available 
    //              D3DDEVCAPS_HWRASTERIZATION -
    //                Support for hardware based scene rasterization is 
    //                available. 
    //              D3DDEVCAPS_HWTRANSFORMANDLIGHT -
    //                Support for hardware based transformations and lighting 
    //                calculations is available. 
    //              D3DDEVCAPS_SEPARATETEXTUREMEMORIES -
    //                Support for multitexture cascading in hardware is 
    //                available. 
    //                A multitexture cascade device has discrete texture 
    //                memory pools for each stage of the texturising process. 
    //                The appropriate stage identifier must be set in the 
    //                TDDSurfaceDesc->TextureStage property at creation time. 
    //              D3DDEVCAPS_SORTDECREASINGZ -
    //                This device needs to have its data sorted in order of 
    //                decreasing depth. 
    //              D3DDEVCAPS_SORTEXACT -
    //                This device needs to have its data sorted exactly. 
    //              D3DDEVCAPS_SORTINCREASINGZ -
    //                This device needs to have its data sorted in order of 
    //                increasing depth. 
    //              D3DDEVCAPS_TEXTURENONLOCALVIDMEM -
    //                Support for retrieving textures from nonlocal video 
    //                memory is available. 
    //              D3DDEVCAPS_TEXTURESYSTEMMEMORY -
    //                Support for retrieving textures from system memory is 
    //                available. 
    //              D3DDEVCAPS_TEXTUREVIDEOMEMORY -
    //                Support for retrieving textures from device memory is 
    //                available. 
    //              D3DDEVCAPS_TLVERTEXSYSTEMMEMORY -
    //                Support for using system memory buffers for transformed 
    //                and lit vertices is available. 
    //              D3DDEVCAPS_TLVERTEXVIDEOMEMORY -
    //                Support for using video memory buffers for transformed 
    //                and lit vertices is available. 
    // ----------------------------------------------------------------------
    __property dword DevCaps = { read=FGetDevCaps, write=FSetDevCaps, 
    default=0 }; 

    // ----------------------------------------------------------------------
    // Property:    DeviceGuid
    // Description: The DirectX GUID of the device. 
    //              
    //              Possible values are: 
    //              
    //              IID_IDirect3DHALDevice 
    //              IID_IDirect3DTnLHalDevice 
    //              IID_IDirect3DRGBDevice 
    // ----------------------------------------------------------------------
    __property GUID DeviceGuid = { read=FGetDeviceGuid, write=FSetDeviceGuid, 
    nodefault }; 

    // ----------------------------------------------------------------------
    // Property:    ErrorValue
    // Description: The ErrorValue property contains the last error value 
    //              returned from a call to a TD3DDeviceDesc method or 
    //              fget/fset. eg. D3D_OK or DDERR_SURFACELOST or TDX_ERROR 
    // ----------------------------------------------------------------------
    __property HRESULT ErrorValue = { read=FGetErrorValue, 
    write=FSetErrorValue, default=D3D_OK }; 

    // ----------------------------------------------------------------------
    // Property:    ExtentsAdjust
    // Description: The ExtentsAdjust property defines how much outward 
    //              adjustment, in pixels, the extents rectangle needs to 
    //              accomodate antialiasing kernels. 
    // ----------------------------------------------------------------------
    __property D3DVALUE ExtentsAdjust = { read=FGetExtentsAdjust, 
    write=FSetExtentsAdjust, nodefault }; 

    // ----------------------------------------------------------------------
    // Property:    FVFCaps
    // Description: The FVFCaps property defines the flexible vertex format 
    //              capabilities of the device. 
    //              The described effect applies when the flag is set. 
    // Flags:       D3DFVFCAPS_DONOTSTRIPELEMENTS -
    //                Stripping extraneous elements from the vertex format is 
    //                not neccessary to improve performance. 
    //              D3DFVFCAPS_TEXCOORDCOUNTMASK -
    //                This flag masks the low word of the FVFCaps property. 
    //                Cast these bits to a WORD to give the number of texture 
    //                coordinate sets that the device can simultaneously use 
    //                for multiple texture blending. 
    // ----------------------------------------------------------------------
    __property dword FVFCaps = { read=FGetFVFCaps, write=FSetFVFCaps, 
    default=0 }; 

    // ----------------------------------------------------------------------
    // Property:    GuardBandBottom
    // Description: The GuardBandBottom property defines the screen 
    //              coordinate lower limit of the guard-band clipping region. 
    //              Coordinates inside the guard band rectangle but outside 
    //              the viewport rectangle are automatically clipped. 
    // ----------------------------------------------------------------------
    __property D3DVALUE GuardBandBottom = { read=FGetGuardBandBottom, 
    write=FSetGuardBandBottom, nodefault }; 

    // ----------------------------------------------------------------------
    // Property:    GuardBandLeft
    // Description: The GuardBandLeft property defines the screen coordinate 
    //              left hand limit of the guard-band clipping region. 
    //              Coordinates inside the guard band rectangle but outside 
    //              the viewport rectangle are automatically clipped. 
    // ----------------------------------------------------------------------
    __property D3DVALUE GuardBandLeft = { read=FGetGuardBandLeft, 
    write=FSetGuardBandLeft, nodefault }; 

    // ----------------------------------------------------------------------
    // Property:    GuardBandRight
    // Description: The GuardBandRight property defines the screen coordinate 
    //              right hand limit of the guard-band clipping region. 
    //              Coordinates inside the guard band rectangle but outside 
    //              the viewport rectangle are automatically clipped. 
    // ----------------------------------------------------------------------
    __property D3DVALUE GuardBandRight = { read=FGetGuardBandRight, 
    write=FSetGuardBandRight, nodefault }; 

    // ----------------------------------------------------------------------
    // Property:    GuardBandTop
    // Description: The GuardBandTop property defines the screen coordinate 
    //              upper limit of the guard-band clipping region. 
    //              Coordinates inside the guard band rectangle but outside 
    //              the viewport rectangle are automatically clipped. 
    // ----------------------------------------------------------------------
    __property D3DVALUE GuardBandTop = { read=FGetGuardBandTop, 
    write=FSetGuardBandTop, nodefault }; 

    // ----------------------------------------------------------------------
    // Property:    MaxVertexW
    // Description: The MaxVertexW property defines the maximum W-based depth 
    //              value supported. 
    // ----------------------------------------------------------------------
    __property D3DVALUE MaxVertexW = { read=FGetMaxVertexW, 
    write=FSetMaxVertexW, nodefault }; 

    // ----------------------------------------------------------------------
    // Property:    Size
    // Description: The Size property contains the size in bytes of the 
    //              internal D3DDEVICEDESC7 structure. 
    // ----------------------------------------------------------------------
    __property dword Size = { read=FGetSize, write=FSetSize, nodefault }; 

    // ----------------------------------------------------------------------
    // Property:    StencilCaps
    // Description: The StencilCaps property defines the stencil-buffer 
    //              capabilities of the device. 
    //              The described effect applies when the flag is set. 
    //              
    //              Stencil buffer entries are integer values between 0 
    //              through 2n-1, where n is the bit depth of the stencil 
    //              buffer. 
    //              All stencil operations are assumed valid for the 
    //              D3DRENDERSTATE_STENCILFAIL, D3DRENDERSTATE_STENCILPASS 
    //              and D3DRENDERSTATE_STENCILFAILZFAIL render states. 
    // Flags:       D3DSTENCILCAPS_DECR -
    //                The decrementing of the stencil buffer entry, with the 
    //                value wrapping to the maximum when the result is less 
    //                than 0 is supported. (D3DSTENCILOP_DECR) 
    //              D3DSTENCILCAPS_DECRSAT -
    //                The decrementing of the stencil buffer entry, with the 
    //                value clamped to 0 when the result is less than 0 is 
    //                supported.(D3DSTENCILOP_DECR) 
    //              D3DSTENCILCAPS_INCRSAT -
    //                The incrementing of the stencil buffer entry, with the 
    //                value clamped to the maximum when the result exceeds 
    //                the maximum is supported. (D3DSTENCILOP_INCR) 
    //              D3DSTENCILCAPS_INVERT -
    //                The inversion of the stencil buffer bits is supported. 
    //                (D3DSTENCILOP_INVERT) 
    //              D3DSTENCILCAPS_KEEP -
    //                Keeping the entry in the stencil buffer without 
    //                updating is supported. (D3DSTENCILOP_KEEP) 
    //                This is the default value for stencil operations. 
    //              D3DSTENCILCAPS_REPLACE -
    //                Replacing the stencil-buffer entry with a reference 
    //                value is supported. (D3DSTENCILOP_REPLACE) 
    //              D3DSTENCILCAPS_ZERO -
    //                Setting the stencil buffer entry to 0 is supported. 
    //                (D3DSTENCILOP_ZERO) 
    //              D3DSTENCILOP_INCR -
    //                The incrementing of the stencil buffer entry, with the 
    //                value wrapping to 0 when the result exceeds the maximum 
    //                is supported. 
    // ----------------------------------------------------------------------
    __property dword StencilCaps = { read=FGetStencilCaps, 
    write=FSetStencilCaps, default=0 }; 

    // ----------------------------------------------------------------------
    // Property:    TextureOpCaps
    // Description: The TextureOpCaps property defines the texture operation 
    //              capabilities supported by the device. 
    //              The described effect applies when the flag is set. 
    // Flags:       D3DTEXOPCAPS_ADD -
    //                Support for the D3DTOP_ADD texture blending operation 
    //                is available. 
    //              D3DTEXOPCAPS_ADDSIGNED -
    //                Support for the D3DTOP_ADDSIGNED texture blending 
    //                operation is available. 
    //              D3DTEXOPCAPS_ADDSIGNED2X -
    //                Support for the D3DTOP_ADDSIGNED2X texture blending 
    //                operation is available. 
    //              D3DTEXOPCAPS_ADDSMOOTH -
    //                Support for the D3DTOP_ADDSMOOTH texture blending 
    //                operation is available. 
    //              D3DTEXOPCAPS_BLENDCURRENTALPHA -
    //                Support for the D3DTOP_BLENDCURRENTALPHA texture 
    //                blending operation is available. 
    //              D3DTEXOPCAPS_BLENDDIFFUSEALPHA -
    //                Support for the D3DTOP_BLENDDIFFUSEALPHA texture 
    //                blending operation is available. 
    //              D3DTEXOPCAPS_BLENDFACTORALPHA -
    //                Support for the D3DTOP_BLENDFACTORALPHA texture 
    //                blending operation is available. 
    //              D3DTEXOPCAPS_BLENDTEXTUREALPHA -
    //                Support for the D3DTOP_BLENDTEXTUREALPHA texture 
    //                blending operation is available. 
    //              D3DTEXOPCAPS_BLENDTEXTUREALPHAPM -
    //                Support for the D3DTOP_BLENDTEXTUREALPHAPM texture 
    //                blending operation is available. 
    //              D3DTEXOPCAPS_BUMPENVMAP -
    //                Support for the D3DTOP_BUMPENVMAP texture blending 
    //                operation is available. 
    //              D3DTEXOPCAPS_BUMPENVMAPLUMINANCE -
    //                Support for the D3DTOP_BUMPENVMAPLUMINANCE texture 
    //                blending operation is available. 
    //              D3DTEXOPCAPS_DISABLE -
    //                Support for the D3DTOP_DISABLE texture blending 
    //                operation is available. 
    //              D3DTEXOPCAPS_DOTPRODUCT3 -
    //                Support for the D3DTOP_DOTPRODUCT3 texture blending 
    //                operation is available. 
    //              D3DTEXOPCAPS_MODULATE -
    //                Support for the D3DTOP_MODULATE texture blending 
    //                operation is available. 
    //              D3DTEXOPCAPS_MODULATE2X -
    //                Support for the D3DTOP_MODULATE2X texture blending 
    //                operation is available. 
    //              D3DTEXOPCAPS_MODULATE4X -
    //                Support for the D3DTOP_MODULATE4X texture blending 
    //                operation is available. 
    //              D3DTEXOPCAPS_MODULATEALPHA_ADDCOLOR -
    //                Support for the D3DTOP_MODULATEALPHA_ADDCOLOR texture 
    //                blending operation is available. 
    //              D3DTEXOPCAPS_MODULATECOLOR_ADDALPHA -
    //                Support for the D3DTOP_MODULATECOLOR_ADDALPHA texture 
    //                blending operation is available. 
    //              D3DTEXOPCAPS_MODULATEINVALPHA_ADDCOLOR -
    //                Support for the D3DTOP_MODULATEINVALPHA_ADDCOLOR 
    //                texture blending operation is available. 
    //              D3DTEXOPCAPS_MODULATEINVCOLOR_ADDALPHA -
    //                Support for the D3DTOP_MODULATEINVCOLOR_ADDALPHA 
    //                texture blending operation is available. 
    //              D3DTEXOPCAPS_PREMODULATE -
    //                Support for the D3DTOP_PREMODULATE texture blending 
    //                operation is available. 
    //              D3DTEXOPCAPS_SELECTARG1 -
    //                Support for the D3DTOP_SELECTARG1 texture blending 
    //                operation is available. 
    //              D3DTEXOPCAPS_SELECTARG2 -
    //                Support for the D3DTOP_SELECTARG2 texture blending 
    //                operation is available. 
    //              D3DTEXOPCAPS_SUBTRACT -
    //                Support for the D3DTOP_SUBTRACT texture blending 
    //                operation is available. 
    // ----------------------------------------------------------------------
    __property dword TextureOpCaps = { read=FGetTextureOpCaps, 
    write=FSetTextureOpCaps, default=0 }; 

    // ----------------------------------------------------------------------
    // Property:    VertexProcessingCaps
    // Description: The VertexProcessingCaps property defines the vertex 
    //              processing capabilities supported by the device. 
    //              The described effect applies when the flag is set. 
    // Flags:       D3DVTXPCAPS_DIRECTIONALLIGHTS -
    //                Support for directional lights is available. 
    //              D3DVTXPCAPS_MATERIALSOURCE7 -
    //                Support for selectable vertex color sources is 
    //                available. 
    //              D3DVTXPCAPS_POSITIONALLIGHTS -
    //                Support for positional lights, including point lights 
    //                and spotlights, is available. 
    //              D3DVTXPCAPS_TEXGEN -
    //                Support for device generated texture coordinates is 
    //                available. 
    //              D3DVTXPCAPS_VERTEXFOG -
    //                Support for vertex fog is available. 
    // ----------------------------------------------------------------------
    __property dword VertexProcessingCaps = { read=FGetVertexProcessingCaps, 
    write=FSetVertexProcessingCaps, default=0 }; 

    // ----------------------------------------------------------------------
    // Method:      Clear()
    // Description: The Clear() method can be used to clear the contents of 
    //              the TD3DDeviceDesc's internal D3DDEVICEDESC7 structure. 
    //              Note: if you have manually linked a structure member to a 
    //              chunk of memory, make sure you release this memory before 
    //              calling Clear(). 
    // ----------------------------------------------------------------------
    virtual void __fastcall Clear(); 

    // ----------------------------------------------------------------------
    // Property:    DevCaps_Strings()
    // Description: This property returns a TStringList containing current 
    //              flag values for the DevCaps property. Note: Any memory 
    //              associated with these strings is released on destruction. 
    // ----------------------------------------------------------------------
    __property TStringList* DevCaps_Strings = { read=FGetDevCaps_Strings };

    // ----------------------------------------------------------------------
    // Property:    FVFCaps_Strings()
    // Description: This property returns a TStringList containing current 
    //              flag values for the FVFCaps property. Note: Any memory 
    //              associated with these strings is released on destruction. 
    // ----------------------------------------------------------------------
    __property TStringList* FVFCaps_Strings = { read=FGetFVFCaps_Strings };

    // ----------------------------------------------------------------------
    // Property:    StencilCaps_Strings()
    // Description: This property returns a TStringList containing current 
    //              flag values for the StencilCaps property. Note: Any 
    //              memory associated with these strings is released on 
    //              destruction. 
    // ----------------------------------------------------------------------
    __property TStringList* StencilCaps_Strings = { read=FGetStencilCaps_Strings };

    // ----------------------------------------------------------------------
    // Property:    TextureOpCaps_Strings()
    // Description: This property returns a TStringList containing current 
    //              flag values for the TextureOpCaps property. Note: Any 
    //              memory associated with these strings is released on 
    //              destruction. 
    // ----------------------------------------------------------------------
    __property TStringList* TextureOpCaps_Strings = { read=FGetTextureOpCaps_Strings };

    // ----------------------------------------------------------------------
    // Property:    VertexProcessingCaps_Strings()
    // Description: This property returns a TStringList containing current 
    //              flag values for the VertexProcessingCaps property. Note: 
    //              Any memory associated with these strings is released on 
    //              destruction. 
    // ----------------------------------------------------------------------
    __property TStringList* VertexProcessingCaps_Strings = { read=FGetVertexProcessingCaps_Strings };

    // ----------------------------------------------------------------------
    // Constructor() and Destructor()
    // ----------------------------------------------------------------------
    __fastcall TD3DDeviceDesc(TComponent* Owner); 
    virtual __fastcall ~TD3DDeviceDesc(); 

    // ----------------------------------------------------------------------
    // Internal Structure Access 
    // ----------------------------------------------------------------------
    __property D3DDEVICEDESC7* Internal_D3DDEVICEDESC7_Ptr = { 
    read=FGetInternal_D3DDEVICEDESC7_Ptr, nodefault }; 

    void __fastcall Internal_D3DDEVICEDESC7_Update(); 

// ==========================================================================
protected:
// ==========================================================================

    // ----------------------------------------------------------------------
    // Object Inspector 'Flag' Access Methods
    // ----------------------------------------------------------------------
    TD3DDeviceDesc_DevCaps_Set __fastcall FGetDevCaps_(); 
    void __fastcall FSetDevCaps_( TD3DDeviceDesc_DevCaps_Set pDevCaps_ ); 
    TD3DDeviceDesc_FVFCaps_Set __fastcall FGetFVFCaps_(); 
    void __fastcall FSetFVFCaps_( TD3DDeviceDesc_FVFCaps_Set pFVFCaps_ ); 
    TD3DDeviceDesc_StencilCaps_Set __fastcall FGetStencilCaps_(); 
    void __fastcall FSetStencilCaps_( TD3DDeviceDesc_StencilCaps_Set 
    pStencilCaps_ ); 
    TD3DDeviceDesc_TextureOpCaps_Set __fastcall FGetTextureOpCaps_(); 
    void __fastcall FSetTextureOpCaps_( TD3DDeviceDesc_TextureOpCaps_Set 
    pTextureOpCaps_ ); 
    TD3DDeviceDesc_VertexProcessingCaps_Set __fastcall 
    FGetVertexProcessingCaps_(); 
    void __fastcall FSetVertexProcessingCaps_( 
    TD3DDeviceDesc_VertexProcessingCaps_Set pVertexProcessingCaps_ ); 

    // ----------------------------------------------------------------------
    // Property Access Methods
    // ----------------------------------------------------------------------
    dword __fastcall FGetDevCaps(); 
    void __fastcall FSetDevCaps( dword pDevCaps ); 
    GUID __fastcall FGetDeviceGuid(); 
    void __fastcall FSetDeviceGuid( GUID pDeviceGuid ); 
    dword __fastcall FGetDeviceRenderBitDepth(); 
    void __fastcall FSetDeviceRenderBitDepth( dword pDeviceRenderBitDepth ); 
    dword __fastcall FGetDeviceZBufferBitDepth(); 
    void __fastcall FSetDeviceZBufferBitDepth( dword pDeviceZBufferBitDepth 
    ); 
    HRESULT __fastcall FGetErrorValue(); 
    void __fastcall FSetErrorValue( HRESULT pErrorValue ); 
    D3DVALUE __fastcall FGetExtentsAdjust(); 
    void __fastcall FSetExtentsAdjust( D3DVALUE pExtentsAdjust ); 
    dword __fastcall FGetFVFCaps(); 
    void __fastcall FSetFVFCaps( dword pFVFCaps ); 
    D3DVALUE __fastcall FGetGuardBandBottom(); 
    void __fastcall FSetGuardBandBottom( D3DVALUE pGuardBandBottom ); 
    D3DVALUE __fastcall FGetGuardBandLeft(); 
    void __fastcall FSetGuardBandLeft( D3DVALUE pGuardBandLeft ); 
    D3DVALUE __fastcall FGetGuardBandRight(); 
    void __fastcall FSetGuardBandRight( D3DVALUE pGuardBandRight ); 
    D3DVALUE __fastcall FGetGuardBandTop(); 
    void __fastcall FSetGuardBandTop( D3DVALUE pGuardBandTop ); 
    TD3DPrimCaps* __fastcall FGetLineCaps(); 
    void __fastcall FSetLineCaps( TD3DPrimCaps* pLineCaps ); 
    dword __fastcall FGetMaxActiveLights(); 
    void __fastcall FSetMaxActiveLights( dword pMaxActiveLights ); 
    dword __fastcall FGetMaxAnisotropy(); 
    void __fastcall FSetMaxAnisotropy( dword pMaxAnisotropy ); 
    word __fastcall FGetMaxSimultaneousTextures(); 
    void __fastcall FSetMaxSimultaneousTextures( word 
    pMaxSimultaneousTextures ); 
    dword __fastcall FGetMaxTextureAspectRatio(); 
    void __fastcall FSetMaxTextureAspectRatio( dword pMaxTextureAspectRatio 
    ); 
    word __fastcall FGetMaxTextureBlendStages(); 
    void __fastcall FSetMaxTextureBlendStages( word pMaxTextureBlendStages ); 
    dword __fastcall FGetMaxTextureHeight(); 
    void __fastcall FSetMaxTextureHeight( dword pMaxTextureHeight ); 
    dword __fastcall FGetMaxTextureRepeat(); 
    void __fastcall FSetMaxTextureRepeat( dword pMaxTextureRepeat ); 
    dword __fastcall FGetMaxTextureWidth(); 
    void __fastcall FSetMaxTextureWidth( dword pMaxTextureWidth ); 
    word __fastcall FGetMaxUserClipPlanes(); 
    void __fastcall FSetMaxUserClipPlanes( word pMaxUserClipPlanes ); 
    word __fastcall FGetMaxVertexBlendMatrices(); 
    void __fastcall FSetMaxVertexBlendMatrices( word pMaxVertexBlendMatrices 
    ); 
    D3DVALUE __fastcall FGetMaxVertexW(); 
    void __fastcall FSetMaxVertexW( D3DVALUE pMaxVertexW ); 
    dword __fastcall FGetMinTextureHeight(); 
    void __fastcall FSetMinTextureHeight( dword pMinTextureHeight ); 
    dword __fastcall FGetMinTextureWidth(); 
    void __fastcall FSetMinTextureWidth( dword pMinTextureWidth ); 
    dword __fastcall FGetSize(); 
    void __fastcall FSetSize( dword pSize ); 
    dword __fastcall FGetStencilCaps(); 
    void __fastcall FSetStencilCaps( dword pStencilCaps ); 
    dword __fastcall FGetTextureOpCaps(); 
    void __fastcall FSetTextureOpCaps( dword pTextureOpCaps ); 
    TD3DPrimCaps* __fastcall FGetTriCaps(); 
    void __fastcall FSetTriCaps( TD3DPrimCaps* pTriCaps ); 
    dword __fastcall FGetVertexProcessingCaps(); 
    void __fastcall FSetVertexProcessingCaps( dword pVertexProcessingCaps ); 

    // ----------------------------------------------------------------------
    // Flag_Strings Access Methods
    // ----------------------------------------------------------------------
    TStringList* __fastcall FGetDevCaps_Strings();

    TStringList* __fastcall FGetFVFCaps_Strings();
    TStringList* __fastcall FGetStencilCaps_Strings();
    TStringList* __fastcall FGetTextureOpCaps_Strings();
    TStringList* __fastcall FGetVertexProcessingCaps_Strings();
// ==========================================================================
private:
// ==========================================================================

    // ----------------------------------------------------------------------
    // Internal Structure Access 
    // ----------------------------------------------------------------------
    D3DDEVICEDESC7* __fastcall FGetInternal_D3DDEVICEDESC7_Ptr(); 
    void __fastcall FSetInternal_D3DDEVICEDESC7( D3DDEVICEDESC7* 
    pD3DDEVICEDESC7 ); 

    // ----------------------------------------------------------------------
    // Property Variables 
    // ----------------------------------------------------------------------
    GUID fDeviceGuid; 
    HRESULT fErrorValue; 
    TD3DPrimCaps* fLineCaps; 
    dword fSize; 
    TD3DPrimCaps* fTriCaps; 

    // ----------------------------------------------------------------------
    // Flags_Strings Variables
    // ----------------------------------------------------------------------
    TStringList* fDevCaps_Strings;
    TStringList* fFVFCaps_Strings;
    TStringList* fStencilCaps_Strings;
    TStringList* fTextureOpCaps_Strings;
    TStringList* fVertexProcessingCaps_Strings;

    // ----------------------------------------------------------------------
    // Structure Variables 
    // ----------------------------------------------------------------------
    D3DDEVICEDESC7 fD3DDEVICEDESC7; 

    // ----------------------------------------------------------------------
    // Event Variables
    // ----------------------------------------------------------------------
    TDx_Error FOnError;

};
// --------------------------------------------------------------------------
#endif
// --------------------------------------------------------------------------
