// --------------------------------------------------------------------------

// ==========================================================================
// File:         TD3DDrawPrimitiveStridedData.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons)
// Description:  This file contains the code for the 
//               TD3DDrawPrimitiveStridedData Component 
//
// "TDx_Draw3D_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TD3DDrawPrimitiveStridedData.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Draw3D_Library_Defns"
#pragma link "TDx_Draw3D_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TD3DDrawPrimitiveStridedData*)
{
    new TD3DDrawPrimitiveStridedData(NULL);
}
// --------------------------------------------------------------------------
namespace Td3ddrawprimitivestrideddata
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TD3DDrawPrimitiveStridedData)};
        RegisterComponents("TDx_Draw3D", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TD3DDrawPrimitiveStridedData::TD3DDrawPrimitiveStridedData()
// Description: The default constructor for the TD3DDrawPrimitiveStridedData object.
// --------------------------------------------------------------------------
__fastcall TD3DDrawPrimitiveStridedData::TD3DDrawPrimitiveStridedData(TComponent* Owner)
    : TComponent(Owner)
{
fD3DDRAWPRIMITIVESTRIDEDDATA=NULL;
fArraySize=0;
ArraySize=1;
ClearAll();
}
// --------------------------------------------------------------------------
// Destructor:  TD3DDrawPrimitiveStridedData::~TD3DDrawPrimitiveStridedData()
// Description: The destructor for the TD3DDrawPrimitiveStridedData object.
// --------------------------------------------------------------------------
__fastcall TD3DDrawPrimitiveStridedData::~TD3DDrawPrimitiveStridedData()
{
// destroy internals
if (ArraySize!=0) ArraySize = 0;
}
// --------------------------------------------------------------------------
// Property:    ArraySize
// Description: The ArraySize property contains the number of internal 
//              D3DDRAWPRIMITIVESTRIDEDDATA structures wrapped inside the 
//              TD3DDrawPrimitiveStridedData component. 
//              By default the ArraySize is initialized to 1, meaning that 
//              this TD3DDrawPrimitiveStridedData component wraps a single 
//              D3DDRAWPRIMITIVESTRIDEDDATA structure. To wrap multiple 
//              structures, set the TD3DDrawPrimitiveStridedData::ArraySize 
//              to the total number of internal structures desired. 
// --------------------------------------------------------------------------
dword __fastcall TD3DDrawPrimitiveStridedData::FGetArraySize()
{
return fArraySize;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDrawPrimitiveStridedData::FSetArraySize( dword pArraySize )
{
// check for size==0
if (pArraySize==0)
    {
    // de-allocate old memory
    delete[] fD3DDRAWPRIMITIVESTRIDEDDATA;
    fD3DDRAWPRIMITIVESTRIDEDDATA = NULL;
    fArraySize = 0;
    return;
    }

// is anything allocated?
if (fArraySize==0)
    {
    // nope. need to allocate memory for pointers to internal structures
    fD3DDRAWPRIMITIVESTRIDEDDATA = new D3DDRAWPRIMITIVESTRIDEDDATA[pArraySize];
    if (fD3DDRAWPRIMITIVESTRIDEDDATA==NULL)
        {
        fArraySize = 0;
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TD3DDRAWPRIMITIVESTRIDEDDATA::FSetArraySize()", "TDX_ERROR", "Could not allocate memory for storing internal D3DDRAWPRIMITIVESTRIDEDDATA structure pointers.");
        return;
        }
    // setup defaults
    fArraySize = pArraySize;
    ClearAll();
    }
else
    // already allocated... has the size increased?
    if (pArraySize>fArraySize)
        {
        // allocate space for the new structures
        D3DDRAWPRIMITIVESTRIDEDDATA* temp_D3DDRAWPRIMITIVESTRIDEDDATA = new D3DDRAWPRIMITIVESTRIDEDDATA[pArraySize];
        if (temp_D3DDRAWPRIMITIVESTRIDEDDATA==NULL)
            {
            fErrorValue = TDX_ERROR;
            if (FOnError) FOnError(this, "TD3DDRAWPRIMITIVESTRIDEDDATA::FSetArraySize()", "TDX_ERROR", "Could not allocate extra memory for storing internal D3DDRAWPRIMITIVESTRIDEDDATA structures.");
            return;
            }
        // clear new data areas
        ZeroMemory( &temp_D3DDRAWPRIMITIVESTRIDEDDATA[fArraySize], sizeof(D3DDRAWPRIMITIVESTRIDEDDATA)*(pArraySize-fArraySize) );
        // duplicate existing data
        CopyMemory( &temp_D3DDRAWPRIMITIVESTRIDEDDATA[0], &fD3DDRAWPRIMITIVESTRIDEDDATA[0], sizeof(D3DDRAWPRIMITIVESTRIDEDDATA)*fArraySize);
        // de-allocate old memory
        delete[] fD3DDRAWPRIMITIVESTRIDEDDATA;
        // re-assign the new memory
        fD3DDRAWPRIMITIVESTRIDEDDATA = temp_D3DDRAWPRIMITIVESTRIDEDDATA;
        // store new array size
        fArraySize = pArraySize;
        }
    else
        // already allocated... has the size reduced?
        if (pArraySize<fArraySize)
            {
            // allocate space for the new structures
            D3DDRAWPRIMITIVESTRIDEDDATA* temp_D3DDRAWPRIMITIVESTRIDEDDATA = new D3DDRAWPRIMITIVESTRIDEDDATA[pArraySize];
            if (temp_D3DDRAWPRIMITIVESTRIDEDDATA==NULL)
                {
                fErrorValue = TDX_ERROR;
                if (FOnError) FOnError(this, "TD3DDRAWPRIMITIVESTRIDEDDATA::FSetArraySize()", "TDX_ERROR", "Could not allocate memory for storing internal D3DDRAWPRIMITIVESTRIDEDDATA structures.");
                return;
                }
            // duplicate existing data
            CopyMemory( &temp_D3DDRAWPRIMITIVESTRIDEDDATA[0], &fD3DDRAWPRIMITIVESTRIDEDDATA[0], sizeof(D3DDRAWPRIMITIVESTRIDEDDATA)*pArraySize);
            // de-allocate the old memory
            delete[] fD3DDRAWPRIMITIVESTRIDEDDATA;
            // re-assign the new memory
            fD3DDRAWPRIMITIVESTRIDEDDATA = temp_D3DDRAWPRIMITIVESTRIDEDDATA;
            // store new array size
            fArraySize = pArraySize;
            }
// else - size is the same.
}
// --------------------------------------------------------------------------
// Property:    Diffuse
// Description: The Diffuse property contains a TD3DDP_PtrStride component 
//              with the Diffuse color information for a collection of 
//              vertices, stored as 8-8-8-8 RGBA values. 
// --------------------------------------------------------------------------
TD3DDP_PtrStride* __fastcall TD3DDrawPrimitiveStridedData::FGetDiffuse( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DDrawPrimitiveStridedData::FGetDiffuse()", "TDX_ERROR", "Internal Array size is 0.");
     return (TD3DDP_PtrStride*) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DDrawPrimitiveStridedData::FGetDiffuse()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (TD3DDP_PtrStride*) NULL;
    }

if (ComponentState.Contains(csDesigning) &&
    (fDiffuse!=NULL) &&
    (Owner!=NULL))
    {
    bool component_exists = false;
    for (int i=0;i<Owner->ComponentCount;i++)
        if (Owner->Components[i]==fDiffuse)
            {
            component_exists = true;
            break;
            }
    if (!component_exists) fDiffuse=NULL;
    }
return fDiffuse;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDrawPrimitiveStridedData::FSetDiffuse( dword pArrayIndex, TD3DDP_PtrStride* pDiffuse )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DDrawPrimitiveStridedData::FSetDiffuse()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DDrawPrimitiveStridedData::FSetDiffuse()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDiffuse = pDiffuse;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TD3DDrawPrimitiveStridedData method 
//              or fget/fset. eg. D3D_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TD3DDrawPrimitiveStridedData::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDrawPrimitiveStridedData::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Normal
// Description: The Normal property contains a TD3DDP_PtrStride component 
//              with an array of the Normal vectors for a collection of 
//              vertices, each vector being a three element array of float 
//              values. 
// --------------------------------------------------------------------------
TD3DDP_PtrStride* __fastcall TD3DDrawPrimitiveStridedData::FGetNormal( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DDrawPrimitiveStridedData::FGetNormal()", "TDX_ERROR", "Internal Array size is 0.");
     return (TD3DDP_PtrStride*) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DDrawPrimitiveStridedData::FGetNormal()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (TD3DDP_PtrStride*) NULL;
    }

if (ComponentState.Contains(csDesigning) &&
    (fNormal!=NULL) &&
    (Owner!=NULL))
    {
    bool component_exists = false;
    for (int i=0;i<Owner->ComponentCount;i++)
        if (Owner->Components[i]==fNormal)
            {
            component_exists = true;
            break;
            }
    if (!component_exists) fNormal=NULL;
    }
return fNormal;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDrawPrimitiveStridedData::FSetNormal( dword pArrayIndex, TD3DDP_PtrStride* pNormal )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DDrawPrimitiveStridedData::FSetNormal()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DDrawPrimitiveStridedData::FSetNormal()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fNormal = pNormal;
}
// --------------------------------------------------------------------------
// Property:    Position
// Description: The Position property contains a TD3DDP_PtrStride component 
//              with an array of the position vectors for a collection of 
//              vertices, each vector being a three element array of float 
//              values. 
// --------------------------------------------------------------------------
TD3DDP_PtrStride* __fastcall TD3DDrawPrimitiveStridedData::FGetPosition( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DDrawPrimitiveStridedData::FGetPosition()", "TDX_ERROR", "Internal Array size is 0.");
     return (TD3DDP_PtrStride*) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DDrawPrimitiveStridedData::FGetPosition()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (TD3DDP_PtrStride*) NULL;
    }

if (ComponentState.Contains(csDesigning) &&
    (fPosition!=NULL) &&
    (Owner!=NULL))
    {
    bool component_exists = false;
    for (int i=0;i<Owner->ComponentCount;i++)
        if (Owner->Components[i]==fPosition)
            {
            component_exists = true;
            break;
            }
    if (!component_exists) fPosition=NULL;
    }
return fPosition;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDrawPrimitiveStridedData::FSetPosition( dword pArrayIndex, TD3DDP_PtrStride* pPosition )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DDrawPrimitiveStridedData::FSetPosition()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DDrawPrimitiveStridedData::FSetPosition()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fPosition = pPosition;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of a single 
//              internal D3DDRAWPRIMITIVESTRIDEDDATA structure. 
// --------------------------------------------------------------------------
dword __fastcall TD3DDrawPrimitiveStridedData::FGetSize()
{
return fSize;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDrawPrimitiveStridedData::FSetSize( dword pSize )
{
fSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    SizeAll
// Description: The SizeAll property contains the size in bytes of all 
//              internal D3DDRAWPRIMITIVESTRIDEDDATA structures. This result 
//              is the same as multiplying 
//              TD3DDrawPrimitiveStridedData::ArraySize and 
//              TD3DDrawPrimitiveStridedData::Size. 
// --------------------------------------------------------------------------
dword __fastcall TD3DDrawPrimitiveStridedData::FGetSizeAll()
{
return fArraySize * fSize;
}
// --------------------------------------------------------------------------
// Property:    Specular
// Description: The Specluar property contains a TD3DDP_PtrStride component 
//              with the Specular color information for a collection of 
//              vertices, stored as 8-8-8-8 RGBA values. 
// --------------------------------------------------------------------------
TD3DDP_PtrStride* __fastcall TD3DDrawPrimitiveStridedData::FGetSpecular( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DDrawPrimitiveStridedData::FGetSpecular()", "TDX_ERROR", "Internal Array size is 0.");
     return (TD3DDP_PtrStride*) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DDrawPrimitiveStridedData::FGetSpecular()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (TD3DDP_PtrStride*) NULL;
    }

if (ComponentState.Contains(csDesigning) &&
    (fSpecular!=NULL) &&
    (Owner!=NULL))
    {
    bool component_exists = false;
    for (int i=0;i<Owner->ComponentCount;i++)
        if (Owner->Components[i]==fSpecular)
            {
            component_exists = true;
            break;
            }
    if (!component_exists) fSpecular=NULL;
    }
return fSpecular;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDrawPrimitiveStridedData::FSetSpecular( dword pArrayIndex, TD3DDP_PtrStride* pSpecular )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DDrawPrimitiveStridedData::FSetSpecular()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DDrawPrimitiveStridedData::FSetSpecular()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fSpecular = pSpecular;
}
// --------------------------------------------------------------------------
// Property:    TextureCoords
// Description: The TextureCoords property contains an eight element array of 
//              TD3DDP_PtrStride components, with each element being a 
//              texture coordinate array for the vertices. 
//              
//              Which of the eight elements used for a given texture stage is 
//              determined by calling TDx_3DDevice::SetTextureStageState() 
//              with D3DTSS_TEXCOORDINDEX set. 
// --------------------------------------------------------------------------
TD3DDP_PtrStride* __fastcall TD3DDrawPrimitiveStridedData::FGetTextureCoords( dword pArrayIndex, dword pIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DDrawPrimitiveStridedData::FGetTextureCoords()", "TDX_ERROR", "Internal Array size is 0.");
     return (TD3DDP_PtrStride*) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DDrawPrimitiveStridedData::FGetTextureCoords()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (TD3DDP_PtrStride*) NULL;
    }

if (ComponentState.Contains(csDesigning) &&
    (fTextureCoords!=NULL) &&
    (Owner!=NULL))
    {
    bool component_exists = false;
    for (int i=0;i<Owner->ComponentCount;i++)
        if (Owner->Components[i]==fTextureCoords)
            {
            component_exists = true;
            break;
            }
    if (!component_exists) fTextureCoords=NULL;
    }
return fTextureCoords;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDrawPrimitiveStridedData::FSetTextureCoords( dword pArrayIndex, dword pIndex, TD3DDP_PtrStride* pTextureCoords )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DDrawPrimitiveStridedData::FSetTextureCoords()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DDrawPrimitiveStridedData::FSetTextureCoords()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fTextureCoords = pTextureCoords;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TD3DDrawPrimitiveStridedData's internal 
//              D3DDRAWPRIMITIVESTRIDEDDATA structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// Params:      pArrayIndex - 
//                The ArrayIndex parameter determines which internal structure 
//                needs to be cleared. Correct values range from 0 to 
//                TD3DDrawPrimitiveStridedData::ArraySize-1. 
// --------------------------------------------------------------------------
void __fastcall TD3DDrawPrimitiveStridedData::Clear( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DDrawPrimitiveStridedData::Clear()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DDrawPrimitiveStridedData::Clear()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

ZeroMemory( &fD3DDRAWPRIMITIVESTRIDEDDATA[pArrayIndex], sizeof(D3DDRAWPRIMITIVESTRIDEDDATA) );
}


// --------------------------------------------------------------------------
// Method:      ClearAll()
// Description: The ClearAll() method can be used to clear the contents of 
//              all the internal D3DDRAWPRIMITIVESTRIDEDDATA structures of 
//              the TD3DDrawPrimitiveStridedData component. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TD3DDrawPrimitiveStridedData::ClearAll()
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DDrawPrimitiveStridedData::Clear()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }

ZeroMemory( &fD3DDRAWPRIMITIVESTRIDEDDATA[0], sizeof(D3DDRAWPRIMITIVESTRIDEDDATA)*fArraySize );
}


// --------------------------------------------------------------------------
// Internal Structure Access 
// --------------------------------------------------------------------------
D3DDRAWPRIMITIVESTRIDEDDATA* __fastcall TD3DDrawPrimitiveStridedData::FGetInternal_D3DDRAWPRIMITIVESTRIDEDDATA_Ptr()
{
// check for errors
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TD3DDrawPrimitiveStridedData::FGetInternal_D3DDRAWPRIMITIVESTRIDEDDATA_Ptr()", "TDX_ERROR", "Internal Array size is 0." );
    return NULL;
    }
dword pArrayIndex = 0;
if (fDiffuse!=NULL) CopyMemory( &fD3DDRAWPRIMITIVESTRIDEDDATA[pArrayIndex].diffuse, fDiffuse->Internal_D3DDP_PTRSTRIDE_Ptr, sizeof(D3DDP_PTRSTRIDE) );
if (fNormal!=NULL) CopyMemory( &fD3DDRAWPRIMITIVESTRIDEDDATA[pArrayIndex].normal, fNormal->Internal_D3DDP_PTRSTRIDE_Ptr, sizeof(D3DDP_PTRSTRIDE) );
if (fPosition!=NULL) CopyMemory( &fD3DDRAWPRIMITIVESTRIDEDDATA[pArrayIndex].position, fPosition->Internal_D3DDP_PTRSTRIDE_Ptr, sizeof(D3DDP_PTRSTRIDE) );
if (fSpecular!=NULL) CopyMemory( &fD3DDRAWPRIMITIVESTRIDEDDATA[pArrayIndex].specular, fSpecular->Internal_D3DDP_PTRSTRIDE_Ptr, sizeof(D3DDP_PTRSTRIDE) );
if (fTextureCoords!=NULL)
    for (dword i=0;i<fTextureCoords->ArraySize,i<D3DDP_MAXTEXCOORD;i++)
        CopyMemory( &fD3DDRAWPRIMITIVESTRIDEDDATA[pArrayIndex].textureCoords[i], &fTextureCoords->Internal_D3DDP_PTRSTRIDE_Ptr[i], sizeof(D3DDP_PTRSTRIDE) );
return fD3DDRAWPRIMITIVESTRIDEDDATA;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDrawPrimitiveStridedData::FSetInternal_D3DDRAWPRIMITIVESTRIDEDDATA( dword pArrayIndex, D3DDRAWPRIMITIVESTRIDEDDATA* pD3DDRAWPRIMITIVESTRIDEDDATA )
{
// check for errors
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TD3DDrawPrimitiveStridedData::FSetInternal_D3DDRAWPRIMITIVESTRIDEDDATA()", "TDX_ERROR", "Internal Array size is 0." );
    return;
    }
if (pD3DDRAWPRIMITIVESTRIDEDDATA==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TD3DDrawPrimitiveStridedData::FSetInternal_D3DDRAWPRIMITIVESTRIDEDDATA()", "TDX_ERROR", "The supplied D3DDRAWPRIMITIVESTRIDEDDATA* was NULL" );
    return;
    }
CopyMemory( &fD3DDRAWPRIMITIVESTRIDEDDATA[pArrayIndex], pD3DDRAWPRIMITIVESTRIDEDDATA, sizeof(D3DDRAWPRIMITIVESTRIDEDDATA) );
Internal_D3DDRAWPRIMITIVESTRIDEDDATA_Update();
}
// --------------------------------------------------------------------------
void __fastcall TD3DDrawPrimitiveStridedData::Internal_D3DDRAWPRIMITIVESTRIDEDDATA_Update()
{
dword pArrayIndex = 0;
if (fDiffuse!=NULL) CopyMemory( fDiffuse->Internal_D3DDP_PTRSTRIDE_Ptr, &fD3DDRAWPRIMITIVESTRIDEDDATA[pArrayIndex].diffuse, sizeof(D3DDP_PTRSTRIDE) );
if (fNormal!=NULL) CopyMemory( fNormal->Internal_D3DDP_PTRSTRIDE_Ptr, &fD3DDRAWPRIMITIVESTRIDEDDATA[pArrayIndex].normal, sizeof(D3DDP_PTRSTRIDE) );
if (fPosition!=NULL) CopyMemory( fPosition->Internal_D3DDP_PTRSTRIDE_Ptr, &fD3DDRAWPRIMITIVESTRIDEDDATA[pArrayIndex].position, sizeof(D3DDP_PTRSTRIDE) );
if (fSpecular!=NULL) CopyMemory( fSpecular->Internal_D3DDP_PTRSTRIDE_Ptr, &fD3DDRAWPRIMITIVESTRIDEDDATA[pArrayIndex].specular, sizeof(D3DDP_PTRSTRIDE) );
if (fTextureCoords!=NULL)
    for (dword i=0;i<fTextureCoords->ArraySize,i<D3DDP_MAXTEXCOORD;i++)
        CopyMemory( &fTextureCoords->Internal_D3DDP_PTRSTRIDE_Ptr[i], &fD3DDRAWPRIMITIVESTRIDEDDATA[pArrayIndex].textureCoords[i], sizeof(D3DDP_PTRSTRIDE) );
}

// --------------------------------------------------------------------------
