// --------------------------------------------------------------------------

// ==========================================================================
// File:         TD3DMatrix.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons)
// Description:  This file contains the code for the TD3DMatrix Component 
//
// "TDx_Draw3D_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TD3DMatrix.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Draw3D_Library_Defns"
#pragma link "TDx_Draw3D_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TD3DMatrix*)
{
    new TD3DMatrix(NULL);
}
// --------------------------------------------------------------------------
namespace Td3dmatrix
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TD3DMatrix)};
        RegisterComponents("TDx_Draw3D", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TD3DMatrix::TD3DMatrix()
// Description: The default constructor for the TD3DMatrix object.
// --------------------------------------------------------------------------
__fastcall TD3DMatrix::TD3DMatrix(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
}
// --------------------------------------------------------------------------
// Destructor:  TD3DMatrix::~TD3DMatrix()
// Description: The destructor for the TD3DMatrix object.
// --------------------------------------------------------------------------
__fastcall TD3DMatrix::~TD3DMatrix()
{
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TD3DMatrix method or fget/fset. eg. 
//              D3D_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TD3DMatrix::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TD3DMatrix::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of the internal 
//              D3DMATRIX structure. 
// --------------------------------------------------------------------------
dword __fastcall TD3DMatrix::FGetSize()
{
return fSize;
}
// --------------------------------------------------------------------------
void __fastcall TD3DMatrix::FSetSize( dword pSize )
{
fSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    _11
// Description: The _11 property contains the (1,1) element of the matrix. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DMatrix::FGet_11()
{
return fD3DMATRIX._11;
}
// --------------------------------------------------------------------------
void __fastcall TD3DMatrix::FSet_11( D3DVALUE p_11 )
{
fD3DMATRIX._11 = p_11;
}
// --------------------------------------------------------------------------
// Property:    _12
// Description: The _12 property contains the (1,2) element of the matrix. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DMatrix::FGet_12()
{
return fD3DMATRIX._12;
}
// --------------------------------------------------------------------------
void __fastcall TD3DMatrix::FSet_12( D3DVALUE p_12 )
{
fD3DMATRIX._12 = p_12;
}
// --------------------------------------------------------------------------
// Property:    _13
// Description: The _13 property contains the (1,3) element of the matrix. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DMatrix::FGet_13()
{
return fD3DMATRIX._13;
}
// --------------------------------------------------------------------------
void __fastcall TD3DMatrix::FSet_13( D3DVALUE p_13 )
{
fD3DMATRIX._13 = p_13;
}
// --------------------------------------------------------------------------
// Property:    _14
// Description: The _14 property contains the (1,4) element of the matrix. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DMatrix::FGet_14()
{
return fD3DMATRIX._14;
}
// --------------------------------------------------------------------------
void __fastcall TD3DMatrix::FSet_14( D3DVALUE p_14 )
{
fD3DMATRIX._14 = p_14;
}
// --------------------------------------------------------------------------
// Property:    _21
// Description: The _21 property contains the (2,1) element of the matrix. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DMatrix::FGet_21()
{
return fD3DMATRIX._21;
}
// --------------------------------------------------------------------------
void __fastcall TD3DMatrix::FSet_21( D3DVALUE p_21 )
{
fD3DMATRIX._21 = p_21;
}
// --------------------------------------------------------------------------
// Property:    _22
// Description: The _22 property contains the (2,2) element of the matrix. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DMatrix::FGet_22()
{
return fD3DMATRIX._22;
}
// --------------------------------------------------------------------------
void __fastcall TD3DMatrix::FSet_22( D3DVALUE p_22 )
{
fD3DMATRIX._22 = p_22;
}
// --------------------------------------------------------------------------
// Property:    _23
// Description: The _23 property contains the (2,3) element of the matrix. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DMatrix::FGet_23()
{
return fD3DMATRIX._23;
}
// --------------------------------------------------------------------------
void __fastcall TD3DMatrix::FSet_23( D3DVALUE p_23 )
{
fD3DMATRIX._23 = p_23;
}
// --------------------------------------------------------------------------
// Property:    _24
// Description: The _24 property contains the (2,4) element of the matrix. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DMatrix::FGet_24()
{
return fD3DMATRIX._24;
}
// --------------------------------------------------------------------------
void __fastcall TD3DMatrix::FSet_24( D3DVALUE p_24 )
{
fD3DMATRIX._24 = p_24;
}
// --------------------------------------------------------------------------
// Property:    _31
// Description: The _31 property contains the (3,1) element of the matrix. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DMatrix::FGet_31()
{
return fD3DMATRIX._31;
}
// --------------------------------------------------------------------------
void __fastcall TD3DMatrix::FSet_31( D3DVALUE p_31 )
{
fD3DMATRIX._31 = p_31;
}
// --------------------------------------------------------------------------
// Property:    _32
// Description: The _32 property contains the (3,2) element of the matrix. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DMatrix::FGet_32()
{
return fD3DMATRIX._32;
}
// --------------------------------------------------------------------------
void __fastcall TD3DMatrix::FSet_32( D3DVALUE p_32 )
{
fD3DMATRIX._32 = p_32;
}
// --------------------------------------------------------------------------
// Property:    _33
// Description: The _33 property contains the (3,3) element of the matrix. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DMatrix::FGet_33()
{
return fD3DMATRIX._33;
}
// --------------------------------------------------------------------------
void __fastcall TD3DMatrix::FSet_33( D3DVALUE p_33 )
{
fD3DMATRIX._33 = p_33;
}
// --------------------------------------------------------------------------
// Property:    _34
// Description: The _34 property contains the (3,4) element of the matrix. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DMatrix::FGet_34()
{
return fD3DMATRIX._34;
}
// --------------------------------------------------------------------------
void __fastcall TD3DMatrix::FSet_34( D3DVALUE p_34 )
{
fD3DMATRIX._34 = p_34;
}
// --------------------------------------------------------------------------
// Property:    _41
// Description: The _41 property contains the (4,1) element of the matrix. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DMatrix::FGet_41()
{
return fD3DMATRIX._41;
}
// --------------------------------------------------------------------------
void __fastcall TD3DMatrix::FSet_41( D3DVALUE p_41 )
{
fD3DMATRIX._41 = p_41;
}
// --------------------------------------------------------------------------
// Property:    _42
// Description: The _42 property contains the (4,2) element of the matrix. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DMatrix::FGet_42()
{
return fD3DMATRIX._42;
}
// --------------------------------------------------------------------------
void __fastcall TD3DMatrix::FSet_42( D3DVALUE p_42 )
{
fD3DMATRIX._42 = p_42;
}
// --------------------------------------------------------------------------
// Property:    _43
// Description: The _43 property contains the (4,3) element of the matrix. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DMatrix::FGet_43()
{
return fD3DMATRIX._43;
}
// --------------------------------------------------------------------------
void __fastcall TD3DMatrix::FSet_43( D3DVALUE p_43 )
{
fD3DMATRIX._43 = p_43;
}
// --------------------------------------------------------------------------
// Property:    _44
// Description: The _44 property contains the (4,4) element of the matrix. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DMatrix::FGet_44()
{
return fD3DMATRIX._44;
}
// --------------------------------------------------------------------------
void __fastcall TD3DMatrix::FSet_44( D3DVALUE p_44 )
{
fD3DMATRIX._44 = p_44;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TD3DMatrix's internal D3DMATRIX structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TD3DMatrix::Clear()
{
fErrorValue = D3D_OK;
fSize = sizeof(D3DMATRIX);
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
D3DMATRIX* __fastcall TD3DMatrix::FGetInternal_D3DMATRIX_Ptr()
{
return &fD3DMATRIX;
}
// --------------------------------------------------------------------------
void __fastcall TD3DMatrix::FSetInternal_D3DMATRIX( D3DMATRIX* pD3DMATRIX )
{
if (pD3DMATRIX==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TD3DMatrix::FSetInternal_D3DMATRIX()", "TDX_ERROR", "The supplied D3DMATRIX* was NULL" );
    return;
    }

CopyMemory( &fD3DMATRIX, pD3DMATRIX, sizeof(D3DMATRIX) );
Internal_D3DMATRIX_Update();
}
// --------------------------------------------------------------------------
void __fastcall TD3DMatrix::Internal_D3DMATRIX_Update()
{
}

// --------------------------------------------------------------------------
