// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDDColorKey.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons)
// Description:  This file contains the code for the TDDColorKey Component 
//
// "TDx_Draw3D_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDDColorKey.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Draw3D_Library_Defns"
#pragma link "TDx_Draw3D_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDDColorKey*)
{
    new TDDColorKey(NULL);
}
// --------------------------------------------------------------------------
namespace Tddcolorkey
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDDColorKey)};
        RegisterComponents("TDx_Draw3D", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDDColorKey::TDDColorKey()
// Description: The default constructor for the TDDColorKey object.
// --------------------------------------------------------------------------
__fastcall TDDColorKey::TDDColorKey(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
}
// --------------------------------------------------------------------------
// Destructor:  TDDColorKey::~TDDColorKey()
// Description: The destructor for the TDDColorKey object.
// --------------------------------------------------------------------------
__fastcall TDDColorKey::~TDDColorKey()
{
}
// --------------------------------------------------------------------------
// Property:    ColorSpaceHighValue
// Description: The ColorSpaceHighValue property defines the upper value, 
//              inclusive, of the color range used as the color key. 
// --------------------------------------------------------------------------
dword __fastcall TDDColorKey::FGetColorSpaceHighValue()
{
return fDDCOLORKEY.dwColorSpaceHighValue;
}
// --------------------------------------------------------------------------
void __fastcall TDDColorKey::FSetColorSpaceHighValue( dword pColorSpaceHighValue )
{
fDDCOLORKEY.dwColorSpaceHighValue = pColorSpaceHighValue;
}
// --------------------------------------------------------------------------
// Property:    ColorSpaceLowValue
// Description: The ColorSpaceLowValue property defines the lower value, 
//              inclusive, of the color range used as the color key. 
// --------------------------------------------------------------------------
dword __fastcall TDDColorKey::FGetColorSpaceLowValue()
{
return fDDCOLORKEY.dwColorSpaceLowValue;
}
// --------------------------------------------------------------------------
void __fastcall TDDColorKey::FSetColorSpaceLowValue( dword pColorSpaceLowValue )
{
fDDCOLORKEY.dwColorSpaceLowValue = pColorSpaceLowValue;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDDColorKey method or fget/fset. 
//              eg. D3D_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDDColorKey::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDDColorKey::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of the internal 
//              DDCOLORKEY structure. 
// --------------------------------------------------------------------------
dword __fastcall TDDColorKey::FGetSize()
{
return fSize;
}
// --------------------------------------------------------------------------
void __fastcall TDDColorKey::FSetSize( dword pSize )
{
fSize = pSize;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDDColorKey's internal DDCOLORKEY structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDDColorKey::Clear()
{
fDDCOLORKEY.dwColorSpaceHighValue = 0;
fDDCOLORKEY.dwColorSpaceLowValue = 0;
fErrorValue = D3D_OK;
fSize = sizeof(DDCOLORKEY);
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DDCOLORKEY* __fastcall TDDColorKey::FGetInternal_DDCOLORKEY_Ptr()
{
return &fDDCOLORKEY;
}
// --------------------------------------------------------------------------
void __fastcall TDDColorKey::FSetInternal_DDCOLORKEY( DDCOLORKEY* pDDCOLORKEY )
{
if (pDDCOLORKEY==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDDColorKey::FSetInternal_DDCOLORKEY()", "TDX_ERROR", "The supplied DDCOLORKEY* was NULL" );
    return;
    }

CopyMemory( &fDDCOLORKEY, pDDCOLORKEY, sizeof(DDCOLORKEY) );
Internal_DDCOLORKEY_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDDColorKey::Internal_DDCOLORKEY_Update()
{
}

// --------------------------------------------------------------------------
