// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDDPixelFormat.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons)
// Description:  This file contains the code for the TDDPixelFormat Component 
//
// "TDx_Draw3D_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDDPixelFormat.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Draw3D_Library_Defns"
#pragma link "TDx_Draw3D_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDDPixelFormat*)
{
    new TDDPixelFormat(NULL);
}
// --------------------------------------------------------------------------
namespace Tddpixelformat
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDDPixelFormat)};
        RegisterComponents("TDx_Draw3D", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDDPixelFormat::TDDPixelFormat()
// Description: The default constructor for the TDDPixelFormat object.
// --------------------------------------------------------------------------
__fastcall TDDPixelFormat::TDDPixelFormat(TComponent* Owner)
    : TComponent(Owner)
{
fDDPIXELFORMAT=NULL;
fArraySize=0;
ArraySize=1;
ClearAll();
fFlags_Strings=NULL;
}
// --------------------------------------------------------------------------
// Destructor:  TDDPixelFormat::~TDDPixelFormat()
// Description: The destructor for the TDDPixelFormat object.
// --------------------------------------------------------------------------
__fastcall TDDPixelFormat::~TDDPixelFormat()
{
// destroy internals
if (ArraySize!=0) ArraySize = 0;
if (fFlags_Strings!=NULL) delete fFlags_Strings;
}
// --------------------------------------------------------------------------
// Property:    AlphaBitDepth
// Description: The AlphaBitDepth property defines a value of 1, 2, 4 or 8 
//              representing the bit depth of an alpha only surface. 
// --------------------------------------------------------------------------
dword __fastcall TDDPixelFormat::FGetAlphaBitDepth( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetAlphaBitDepth()", "TDX_ERROR", "Internal Array size is 0.");
     return (dword) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetAlphaBitDepth()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (dword) NULL;
    }

return fDDPIXELFORMAT[pArrayIndex].dwAlphaBitDepth;
}
// --------------------------------------------------------------------------
void __fastcall TDDPixelFormat::FSetAlphaBitDepth( dword pArrayIndex, dword pAlphaBitDepth )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetAlphaBitDepth()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetAlphaBitDepth()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDDPIXELFORMAT[pArrayIndex].dwAlphaBitDepth = pAlphaBitDepth;
}
// --------------------------------------------------------------------------
// Property:    ArraySize
// Description: The ArraySize property contains the number of internal 
//              DDPIXELFORMAT structures wrapped inside the TDDPixelFormat 
//              component. 
//              By default the ArraySize is initialized to 1, meaning that 
//              this TDDPixelFormat component wraps a single DDPIXELFORMAT 
//              structure. To wrap multiple structures, set the 
//              TDDPixelFormat::ArraySize to the total number of internal 
//              structures desired. 
// --------------------------------------------------------------------------
dword __fastcall TDDPixelFormat::FGetArraySize()
{
return fArraySize;
}
// --------------------------------------------------------------------------
void __fastcall TDDPixelFormat::FSetArraySize( dword pArraySize )
{
// check for size==0
if (pArraySize==0)
    {
    // de-allocate old memory
    delete[] fDDPIXELFORMAT;
    fDDPIXELFORMAT = NULL;
    fArraySize = 0;
    return;
    }

// is anything allocated?
if (fArraySize==0)
    {
    // nope. need to allocate memory for pointers to internal structures
    fDDPIXELFORMAT = new DDPIXELFORMAT[pArraySize];
    if (fDDPIXELFORMAT==NULL)
        {
        fArraySize = 0;
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TDDPIXELFORMAT::FSetArraySize()", "TDX_ERROR", "Could not allocate memory for storing internal DDPIXELFORMAT structure pointers.");
        return;
        }
    // setup defaults
    fArraySize = pArraySize;
    ClearAll();
    }
else
    // already allocated... has the size increased?
    if (pArraySize>fArraySize)
        {
        // allocate space for the new structures
        DDPIXELFORMAT* temp_DDPIXELFORMAT = new DDPIXELFORMAT[pArraySize];
        if (temp_DDPIXELFORMAT==NULL)
            {
            fErrorValue = TDX_ERROR;
            if (FOnError) FOnError(this, "TDDPIXELFORMAT::FSetArraySize()", "TDX_ERROR", "Could not allocate extra memory for storing internal DDPIXELFORMAT structures.");
            return;
            }
        // clear new data areas
        ZeroMemory( &temp_DDPIXELFORMAT[fArraySize], sizeof(DDPIXELFORMAT)*(pArraySize-fArraySize) );
        // duplicate existing data
        CopyMemory( &temp_DDPIXELFORMAT[0], &fDDPIXELFORMAT[0], sizeof(DDPIXELFORMAT)*fArraySize);
        // de-allocate old memory
        delete[] fDDPIXELFORMAT;
        // re-assign the new memory
        fDDPIXELFORMAT = temp_DDPIXELFORMAT;
        // store new array size
        fArraySize = pArraySize;
        }
    else
        // already allocated... has the size reduced?
        if (pArraySize<fArraySize)
            {
            // allocate space for the new structures
            DDPIXELFORMAT* temp_DDPIXELFORMAT = new DDPIXELFORMAT[pArraySize];
            if (temp_DDPIXELFORMAT==NULL)
                {
                fErrorValue = TDX_ERROR;
                if (FOnError) FOnError(this, "TDDPIXELFORMAT::FSetArraySize()", "TDX_ERROR", "Could not allocate memory for storing internal DDPIXELFORMAT structures.");
                return;
                }
            // duplicate existing data
            CopyMemory( &temp_DDPIXELFORMAT[0], &fDDPIXELFORMAT[0], sizeof(DDPIXELFORMAT)*pArraySize);
            // de-allocate the old memory
            delete[] fDDPIXELFORMAT;
            // re-assign the new memory
            fDDPIXELFORMAT = temp_DDPIXELFORMAT;
            // store new array size
            fArraySize = pArraySize;
            }
// else - size is the same.
}
// --------------------------------------------------------------------------
// Property:    BBitMask
// Description: The BBitMask property defines the mask for handling the blue 
//              component of a RGB surface. 
// --------------------------------------------------------------------------
dword __fastcall TDDPixelFormat::FGetBBitMask( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetBBitMask()", "TDX_ERROR", "Internal Array size is 0.");
     return (dword) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetBBitMask()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (dword) NULL;
    }

return fDDPIXELFORMAT[pArrayIndex].dwBBitMask;
}
// --------------------------------------------------------------------------
void __fastcall TDDPixelFormat::FSetBBitMask( dword pArrayIndex, dword pBBitMask )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetBBitMask()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetBBitMask()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDDPIXELFORMAT[pArrayIndex].dwBBitMask = pBBitMask;
}
// --------------------------------------------------------------------------
// Property:    BumpBitCount
// Description: The BumpBitCount property defines the number of bump map bits 
//              per pixel in a bump map surface. 
// --------------------------------------------------------------------------
dword __fastcall TDDPixelFormat::FGetBumpBitCount( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetBumpBitCount()", "TDX_ERROR", "Internal Array size is 0.");
     return (dword) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetBumpBitCount()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (dword) NULL;
    }

return fDDPIXELFORMAT[pArrayIndex].dwBumpBitCount;
}
// --------------------------------------------------------------------------
void __fastcall TDDPixelFormat::FSetBumpBitCount( dword pArrayIndex, dword pBumpBitCount )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetBumpBitCount()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetBumpBitCount()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDDPIXELFORMAT[pArrayIndex].dwBumpBitCount = pBumpBitCount;
}
// --------------------------------------------------------------------------
// Property:    BumpDuBitMask
// Description: The BumpDuBitMask property defines the bit mask for handling 
//              the bump map delta U component of a pixel. 
// --------------------------------------------------------------------------
dword __fastcall TDDPixelFormat::FGetBumpDuBitMask( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetBumpDuBitMask()", "TDX_ERROR", "Internal Array size is 0.");
     return (dword) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetBumpDuBitMask()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (dword) NULL;
    }

return fDDPIXELFORMAT[pArrayIndex].dwBumpDuBitMask;
}
// --------------------------------------------------------------------------
void __fastcall TDDPixelFormat::FSetBumpDuBitMask( dword pArrayIndex, dword pBumpDuBitMask )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetBumpDuBitMask()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetBumpDuBitMask()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDDPIXELFORMAT[pArrayIndex].dwBumpDuBitMask = pBumpDuBitMask;
}
// --------------------------------------------------------------------------
// Property:    BumpDvBitMask
// Description: The BumpDvBitMask property defines the bit mask for handling 
//              the bump map delta V component of a pixel. 
// --------------------------------------------------------------------------
dword __fastcall TDDPixelFormat::FGetBumpDvBitMask( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetBumpDvBitMask()", "TDX_ERROR", "Internal Array size is 0.");
     return (dword) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetBumpDvBitMask()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (dword) NULL;
    }

return fDDPIXELFORMAT[pArrayIndex].dwBumpDvBitMask;
}
// --------------------------------------------------------------------------
void __fastcall TDDPixelFormat::FSetBumpDvBitMask( dword pArrayIndex, dword pBumpDvBitMask )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetBumpDvBitMask()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetBumpDvBitMask()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDDPIXELFORMAT[pArrayIndex].dwBumpDvBitMask = pBumpDvBitMask;
}
// --------------------------------------------------------------------------
// Property:    BumpLuminanceBitMask
// Description: The BumpLuminanceBitMask property defines the bit mask for 
//              handling the bump map luminance component of a pixel. 
// --------------------------------------------------------------------------
dword __fastcall TDDPixelFormat::FGetBumpLuminanceBitMask( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetBumpLuminanceBitMask()", "TDX_ERROR", "Internal Array size is 0.");
     return (dword) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetBumpLuminanceBitMask()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (dword) NULL;
    }

return fDDPIXELFORMAT[pArrayIndex].dwBumpLuminanceBitMask;
}
// --------------------------------------------------------------------------
void __fastcall TDDPixelFormat::FSetBumpLuminanceBitMask( dword pArrayIndex, dword pBumpLuminanceBitMask )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetBumpLuminanceBitMask()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetBumpLuminanceBitMask()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDDPIXELFORMAT[pArrayIndex].dwBumpLuminanceBitMask = pBumpLuminanceBitMask;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDDPixelFormat method or fget/fset. 
//              eg. D3D_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDDPixelFormat::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDDPixelFormat::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Flags
// Description: The Flags property defines flags indicating various control 
//              options and which properties of this component contain valid 
//              data. 
//              The described effect applies when the flag is set. 
// Flags:       DDPF_ALPHA -
//                This component is describing the pixel format of an alpha 
//                only surface. 
//              DDPF_ALPHAPIXELS -
//                This component is describing the pixel format of a surface 
//                with interleaved alpha channel information. 
//              DDPF_ALPHAPREMULT -
//                This component is describing the pixel format of a surface 
//                using a premultiplied alpha format. 
//                The alpha component is premultiplied with the color 
//                components for each pixel. 
//              DDPF_BUMPDUDV -
//                The bump map related properties of this component contain 
//                valid data. 
//              DDPF_BUMPLUMINANCE -
//                The luminance related properties of this component contain 
//                valid data. 
//              DDPF_COMPRESSED -
//                The surface this component describes will accept pixel data 
//                in a specified format and compress it during write 
//                operations. 
//              DDPF_FOURCC -
//                The FourCC property of this component contains valid data. 
//              DDPF_LUMINANCE -
//                This component is describing the pixel format of a 
//                luminance or luminance alpha surface. 
//              DDPF_PALETTEINDEXED1 -
//                This component is describing the pixel format of a 1 bit 
//                color palette indexed surface. 
//              DDPF_PALETTEINDEXED2 -
//                This component is describing the pixel format of a 2 bit 
//                color palette indexed surface. 
//              DDPF_PALETTEINDEXED4 -
//                This component is describing the pixel format of a 4 bit 
//                color palette indexed surface. 
//              DDPF_PALETTEINDEXED8 -
//                This component is describing the pixel format of a 8 bit 
//                color palette indexed surface. 
//              DDPF_PALETTEINDEXEDTO8 -
//                This component is describing the pixel format of a surface 
//                that uses a 1, 2 or 4 bit index to an 8 bit color palette. 
//              DDPF_RGB -
//                The RGB properties of this component contain valid data. 
//              DDPF_RGBTOYUV -
//                The surface this component is describing will accept RGB 
//                data and translate it to YUV data during the write 
//                operation. 
//                The format of the data being written is contained in the 
//                pixel format. 
//                DDPF_RGB will also be set. 
//              DDPF_STENCILBUFFER -
//                This component is describing the pixel format of a z-buffer 
//                surface which also encodes stencil information. 
//                This flag may only be utilized when DDPF_ZBUFFER is also 
//                set. 
//              DDPF_YUV -
//                The YUV properties in this component contain valid data.. 
//              DDPF_ZBUFFER -
//                This component is describing the pixel format of a z-buffer 
//                only surface. 
//              DDPF_ZPIXELS -
//                This component is describing the pixel format of a surface 
//                with interleaved z-buffer information. 
// --------------------------------------------------------------------------
dword __fastcall TDDPixelFormat::FGetFlags( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetFlags()", "TDX_ERROR", "Internal Array size is 0.");
     return (dword) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetFlags()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (dword) NULL;
    }

return fDDPIXELFORMAT[pArrayIndex].dwFlags;
}
// --------------------------------------------------------------------------
void __fastcall TDDPixelFormat::FSetFlags( dword pArrayIndex, dword pFlags )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetFlags()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetFlags()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDDPIXELFORMAT[pArrayIndex].dwFlags = pFlags;
}
// --------------------------------------------------------------------------
// Property:    FourCC
// Description: The FourCC property defines a FourCC code describing the data 
//              format of the surface this component is describing. 
// --------------------------------------------------------------------------
dword __fastcall TDDPixelFormat::FGetFourCC( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetFourCC()", "TDX_ERROR", "Internal Array size is 0.");
     return (dword) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetFourCC()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (dword) NULL;
    }

return fDDPIXELFORMAT[pArrayIndex].dwFourCC;
}
// --------------------------------------------------------------------------
void __fastcall TDDPixelFormat::FSetFourCC( dword pArrayIndex, dword pFourCC )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetFourCC()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetFourCC()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDDPIXELFORMAT[pArrayIndex].dwFourCC = pFourCC;
}
// --------------------------------------------------------------------------
// Property:    GBitMask
// Description: The GBitMask property defines the mask for handling the green 
//              component of a RGB surface. 
// --------------------------------------------------------------------------
dword __fastcall TDDPixelFormat::FGetGBitMask( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetGBitMask()", "TDX_ERROR", "Internal Array size is 0.");
     return (dword) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetGBitMask()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (dword) NULL;
    }

return fDDPIXELFORMAT[pArrayIndex].dwGBitMask;
}
// --------------------------------------------------------------------------
void __fastcall TDDPixelFormat::FSetGBitMask( dword pArrayIndex, dword pGBitMask )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetGBitMask()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetGBitMask()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDDPIXELFORMAT[pArrayIndex].dwGBitMask = pGBitMask;
}
// --------------------------------------------------------------------------
// Property:    LuminanceAlphaBitMask
// Description: The LuminanceAlphaBitMask property defines the bit mask for 
//              handling the luminance alpha component of a pixel. 
// --------------------------------------------------------------------------
dword __fastcall TDDPixelFormat::FGetLuminanceAlphaBitMask( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetLuminanceAlphaBitMask()", "TDX_ERROR", "Internal Array size is 0.");
     return (dword) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetLuminanceAlphaBitMask()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (dword) NULL;
    }

return fDDPIXELFORMAT[pArrayIndex].dwLuminanceAlphaBitMask;
}
// --------------------------------------------------------------------------
void __fastcall TDDPixelFormat::FSetLuminanceAlphaBitMask( dword pArrayIndex, dword pLuminanceAlphaBitMask )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetLuminanceAlphaBitMask()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetLuminanceAlphaBitMask()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDDPIXELFORMAT[pArrayIndex].dwLuminanceAlphaBitMask = pLuminanceAlphaBitMask;
}
// --------------------------------------------------------------------------
// Property:    LuminanceBitCount
// Description: The LuminanceBitCount property defines the number of 
//              luminance bits per pixel in a luminance or luminance alpha 
//              surface. 
// --------------------------------------------------------------------------
dword __fastcall TDDPixelFormat::FGetLuminanceBitCount( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetLuminanceBitCount()", "TDX_ERROR", "Internal Array size is 0.");
     return (dword) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetLuminanceBitCount()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (dword) NULL;
    }

return fDDPIXELFORMAT[pArrayIndex].dwLuminanceBitCount;
}
// --------------------------------------------------------------------------
void __fastcall TDDPixelFormat::FSetLuminanceBitCount( dword pArrayIndex, dword pLuminanceBitCount )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetLuminanceBitCount()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetLuminanceBitCount()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDDPIXELFORMAT[pArrayIndex].dwLuminanceBitCount = pLuminanceBitCount;
}
// --------------------------------------------------------------------------
// Property:    LuminanceBitMask
// Description: The LuminanceBitMask property defines the mask for handling 
//              the luminance component of a pixel. 
// --------------------------------------------------------------------------
dword __fastcall TDDPixelFormat::FGetLuminanceBitMask( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetLuminanceBitMask()", "TDX_ERROR", "Internal Array size is 0.");
     return (dword) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetLuminanceBitMask()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (dword) NULL;
    }

return fDDPIXELFORMAT[pArrayIndex].dwLuminanceBitMask;
}
// --------------------------------------------------------------------------
void __fastcall TDDPixelFormat::FSetLuminanceBitMask( dword pArrayIndex, dword pLuminanceBitMask )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetLuminanceBitMask()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetLuminanceBitMask()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDDPIXELFORMAT[pArrayIndex].dwLuminanceBitMask = pLuminanceBitMask;
}
// --------------------------------------------------------------------------
// Property:    RBitMask
// Description: The RBitMask property defines the mask for handling the red 
//              component of a RGB surface. 
// --------------------------------------------------------------------------
dword __fastcall TDDPixelFormat::FGetRBitMask( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetRBitMask()", "TDX_ERROR", "Internal Array size is 0.");
     return (dword) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetRBitMask()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (dword) NULL;
    }

return fDDPIXELFORMAT[pArrayIndex].dwRBitMask;
}
// --------------------------------------------------------------------------
void __fastcall TDDPixelFormat::FSetRBitMask( dword pArrayIndex, dword pRBitMask )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetRBitMask()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetRBitMask()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDDPIXELFORMAT[pArrayIndex].dwRBitMask = pRBitMask;
}
// --------------------------------------------------------------------------
// Property:    RGBAlphaBitMask
// Description: The RGBAlphaBitMask property defines the mask for handling 
//              the alpha channel of a RGBA surface. 
// --------------------------------------------------------------------------
dword __fastcall TDDPixelFormat::FGetRGBAlphaBitMask( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetRGBAlphaBitMask()", "TDX_ERROR", "Internal Array size is 0.");
     return (dword) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetRGBAlphaBitMask()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (dword) NULL;
    }

return fDDPIXELFORMAT[pArrayIndex].dwRGBAlphaBitMask;
}
// --------------------------------------------------------------------------
void __fastcall TDDPixelFormat::FSetRGBAlphaBitMask( dword pArrayIndex, dword pRGBAlphaBitMask )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetRGBAlphaBitMask()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetRGBAlphaBitMask()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDDPIXELFORMAT[pArrayIndex].dwRGBAlphaBitMask = pRGBAlphaBitMask;
}
// --------------------------------------------------------------------------
// Property:    RGBBitCount
// Description: The RGBBitCount property defines a value of 4, 8, 16, 24 or 
//              32 representing the number of bits per pixel for a RGB 
//              surface. 
// --------------------------------------------------------------------------
dword __fastcall TDDPixelFormat::FGetRGBBitCount( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetRGBBitCount()", "TDX_ERROR", "Internal Array size is 0.");
     return (dword) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetRGBBitCount()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (dword) NULL;
    }

return fDDPIXELFORMAT[pArrayIndex].dwRGBBitCount;
}
// --------------------------------------------------------------------------
void __fastcall TDDPixelFormat::FSetRGBBitCount( dword pArrayIndex, dword pRGBBitCount )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetRGBBitCount()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetRGBBitCount()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDDPIXELFORMAT[pArrayIndex].dwRGBBitCount = pRGBBitCount;
}
// --------------------------------------------------------------------------
// Property:    RGBZBitMask
// Description: The RGBZBitMask property defines the mask for handling the 
//              z-buffer component of a RGBZ surface. 
// --------------------------------------------------------------------------
dword __fastcall TDDPixelFormat::FGetRGBZBitMask( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetRGBZBitMask()", "TDX_ERROR", "Internal Array size is 0.");
     return (dword) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetRGBZBitMask()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (dword) NULL;
    }

return fDDPIXELFORMAT[pArrayIndex].dwRGBZBitMask;
}
// --------------------------------------------------------------------------
void __fastcall TDDPixelFormat::FSetRGBZBitMask( dword pArrayIndex, dword pRGBZBitMask )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetRGBZBitMask()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetRGBZBitMask()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDDPIXELFORMAT[pArrayIndex].dwRGBZBitMask = pRGBZBitMask;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property defines the size, in bytes, of the internal 
//              structure used by this component. 
// --------------------------------------------------------------------------
dword __fastcall TDDPixelFormat::FGetSize( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetSize()", "TDX_ERROR", "Internal Array size is 0.");
     return (dword) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetSize()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (dword) NULL;
    }

return fDDPIXELFORMAT[pArrayIndex].dwSize;
}
// --------------------------------------------------------------------------
void __fastcall TDDPixelFormat::FSetSize( dword pArrayIndex, dword pSize )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetSize()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetSize()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDDPIXELFORMAT[pArrayIndex].dwSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    SizeAll
// Description: The SizeAll property contains the size in bytes of all 
//              internal DDPIXELFORMAT structures. This result is the same as 
//              multiplying TDDPixelFormat::ArraySize and 
//              TDDPixelFormat::Size. 
// --------------------------------------------------------------------------
dword __fastcall TDDPixelFormat::FGetSizeAll()
{
dword temp = 0;
for (dword i=0;i<fArraySize;i++) temp += fDDPIXELFORMAT[i].dwSize;
return temp;
}
// --------------------------------------------------------------------------
// Property:    StencilBitDepth
// Description: The StencilBitCount property defines the number of stencil 
//              bits per pixel in a z-buffer surface. 
//              The actual z-buffer bit depth can be determined by 
//              subtracting this property from 
//              TDDPixelFormat::ZBufferBitDepth. 
// --------------------------------------------------------------------------
dword __fastcall TDDPixelFormat::FGetStencilBitDepth( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetStencilBitDepth()", "TDX_ERROR", "Internal Array size is 0.");
     return (dword) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetStencilBitDepth()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (dword) NULL;
    }

return fDDPIXELFORMAT[pArrayIndex].dwStencilBitDepth;
}
// --------------------------------------------------------------------------
void __fastcall TDDPixelFormat::FSetStencilBitDepth( dword pArrayIndex, dword pStencilBitDepth )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetStencilBitDepth()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetStencilBitDepth()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDDPIXELFORMAT[pArrayIndex].dwStencilBitDepth = pStencilBitDepth;
}
// --------------------------------------------------------------------------
// Property:    StencilBitMask
// Description: The StencilBitMask property defines the bit mask for handling 
//              the stencil component of a z-buffer. 
// --------------------------------------------------------------------------
dword __fastcall TDDPixelFormat::FGetStencilBitMask( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetStencilBitMask()", "TDX_ERROR", "Internal Array size is 0.");
     return (dword) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetStencilBitMask()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (dword) NULL;
    }

return fDDPIXELFORMAT[pArrayIndex].dwStencilBitMask;
}
// --------------------------------------------------------------------------
void __fastcall TDDPixelFormat::FSetStencilBitMask( dword pArrayIndex, dword pStencilBitMask )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetStencilBitMask()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetStencilBitMask()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDDPIXELFORMAT[pArrayIndex].dwStencilBitMask = pStencilBitMask;
}
// --------------------------------------------------------------------------
// Property:    UBitMask
// Description: The UBitMask property defines the mask for handling the U 
//              component of a YUV surface. 
// --------------------------------------------------------------------------
dword __fastcall TDDPixelFormat::FGetUBitMask( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetUBitMask()", "TDX_ERROR", "Internal Array size is 0.");
     return (dword) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetUBitMask()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (dword) NULL;
    }

return fDDPIXELFORMAT[pArrayIndex].dwUBitMask;
}
// --------------------------------------------------------------------------
void __fastcall TDDPixelFormat::FSetUBitMask( dword pArrayIndex, dword pUBitMask )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetUBitMask()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetUBitMask()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDDPIXELFORMAT[pArrayIndex].dwUBitMask = pUBitMask;
}
// --------------------------------------------------------------------------
// Property:    VBitMask
// Description: The VBitMask property defines the mask for handling the V 
//              component of a YUV surface. 
// --------------------------------------------------------------------------
dword __fastcall TDDPixelFormat::FGetVBitMask( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetVBitMask()", "TDX_ERROR", "Internal Array size is 0.");
     return (dword) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetVBitMask()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (dword) NULL;
    }

return fDDPIXELFORMAT[pArrayIndex].dwVBitMask;
}
// --------------------------------------------------------------------------
void __fastcall TDDPixelFormat::FSetVBitMask( dword pArrayIndex, dword pVBitMask )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetVBitMask()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetVBitMask()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDDPIXELFORMAT[pArrayIndex].dwVBitMask = pVBitMask;
}
// --------------------------------------------------------------------------
// Property:    YBitMask
// Description: The YBitMask property defines the mask for handling the Y 
//              component of a YUV surface. 
// --------------------------------------------------------------------------
dword __fastcall TDDPixelFormat::FGetYBitMask( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetYBitMask()", "TDX_ERROR", "Internal Array size is 0.");
     return (dword) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetYBitMask()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (dword) NULL;
    }

return fDDPIXELFORMAT[pArrayIndex].dwYBitMask;
}
// --------------------------------------------------------------------------
void __fastcall TDDPixelFormat::FSetYBitMask( dword pArrayIndex, dword pYBitMask )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetYBitMask()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetYBitMask()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDDPIXELFORMAT[pArrayIndex].dwYBitMask = pYBitMask;
}
// --------------------------------------------------------------------------
// Property:    YUVAlphaBitMask
// Description: The YUVAlphaBitMask property defines the mask for handling 
//              the alpha channel component of a YUVA surface. 
// --------------------------------------------------------------------------
dword __fastcall TDDPixelFormat::FGetYUVAlphaBitMask( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetYUVAlphaBitMask()", "TDX_ERROR", "Internal Array size is 0.");
     return (dword) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetYUVAlphaBitMask()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (dword) NULL;
    }

return fDDPIXELFORMAT[pArrayIndex].dwYUVAlphaBitMask;
}
// --------------------------------------------------------------------------
void __fastcall TDDPixelFormat::FSetYUVAlphaBitMask( dword pArrayIndex, dword pYUVAlphaBitMask )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetYUVAlphaBitMask()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetYUVAlphaBitMask()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDDPIXELFORMAT[pArrayIndex].dwYUVAlphaBitMask = pYUVAlphaBitMask;
}
// --------------------------------------------------------------------------
// Property:    YUVBitCount
// Description: The YUVBitCount property defines a value of 4, 8, 16, 24 or 
//              32 representing the number of bits per pixel for a YUV 
//              surface. 
// --------------------------------------------------------------------------
dword __fastcall TDDPixelFormat::FGetYUVBitCount( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetYUVBitCount()", "TDX_ERROR", "Internal Array size is 0.");
     return (dword) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetYUVBitCount()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (dword) NULL;
    }

return fDDPIXELFORMAT[pArrayIndex].dwYUVBitCount;
}
// --------------------------------------------------------------------------
void __fastcall TDDPixelFormat::FSetYUVBitCount( dword pArrayIndex, dword pYUVBitCount )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetYUVBitCount()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetYUVBitCount()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDDPIXELFORMAT[pArrayIndex].dwYUVBitCount = pYUVBitCount;
}
// --------------------------------------------------------------------------
// Property:    YUVZBitMask
// Description: The YUVZBitMask property defines the mask for handling the 
//              z-buffer component of a YUVZ surface. 
// --------------------------------------------------------------------------
dword __fastcall TDDPixelFormat::FGetYUVZBitMask( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetYUVZBitMask()", "TDX_ERROR", "Internal Array size is 0.");
     return (dword) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetYUVZBitMask()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (dword) NULL;
    }

return fDDPIXELFORMAT[pArrayIndex].dwYUVZBitMask;
}
// --------------------------------------------------------------------------
void __fastcall TDDPixelFormat::FSetYUVZBitMask( dword pArrayIndex, dword pYUVZBitMask )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetYUVZBitMask()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetYUVZBitMask()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDDPIXELFORMAT[pArrayIndex].dwYUVZBitMask = pYUVZBitMask;
}
// --------------------------------------------------------------------------
// Property:    ZBitMask
// Description: The ZBitMask property defines the bit mask for handling the 
//              z-value component of a z-buffer. 
// --------------------------------------------------------------------------
dword __fastcall TDDPixelFormat::FGetZBitMask( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetZBitMask()", "TDX_ERROR", "Internal Array size is 0.");
     return (dword) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetZBitMask()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (dword) NULL;
    }

return fDDPIXELFORMAT[pArrayIndex].dwZBitMask;
}
// --------------------------------------------------------------------------
void __fastcall TDDPixelFormat::FSetZBitMask( dword pArrayIndex, dword pZBitMask )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetZBitMask()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetZBitMask()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDDPIXELFORMAT[pArrayIndex].dwZBitMask = pZBitMask;
}
// --------------------------------------------------------------------------
// Property:    ZBufferBitDepth
// Description: The ZBufferBitDepth property defines a value of 8, 16, 24 or 
//              32 representing the bit depth of the z-buffer. 
// --------------------------------------------------------------------------
dword __fastcall TDDPixelFormat::FGetZBufferBitDepth( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetZBufferBitDepth()", "TDX_ERROR", "Internal Array size is 0.");
     return (dword) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FGetZBufferBitDepth()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (dword) NULL;
    }

return fDDPIXELFORMAT[pArrayIndex].dwZBufferBitDepth;
}
// --------------------------------------------------------------------------
void __fastcall TDDPixelFormat::FSetZBufferBitDepth( dword pArrayIndex, dword pZBufferBitDepth )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetZBufferBitDepth()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::FSetZBufferBitDepth()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDDPIXELFORMAT[pArrayIndex].dwZBufferBitDepth = pZBufferBitDepth;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDDPixelFormat's internal DDPIXELFORMAT structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// Params:      pArrayIndex - 
//                The ArrayIndex parameter determines which internal structure 
//                needs to be cleared. Correct values range from 0 to 
//                TDDPixelFormat::ArraySize-1. 
// --------------------------------------------------------------------------
void __fastcall TDDPixelFormat::Clear( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::Clear()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::Clear()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

ZeroMemory( &fDDPIXELFORMAT[pArrayIndex], sizeof(DDPIXELFORMAT) );
fDDPIXELFORMAT[pArrayIndex].dwSize = sizeof(DDPIXELFORMAT);
}


// --------------------------------------------------------------------------
// Method:      ClearAll()
// Description: The ClearAll() method can be used to clear the contents of 
//              all the internal DDPIXELFORMAT structures of the 
//              TDDPixelFormat component. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDDPixelFormat::ClearAll()
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDPixelFormat::Clear()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }

ZeroMemory( &fDDPIXELFORMAT[0], sizeof(DDPIXELFORMAT)*fArraySize );
for (dword i=0;i<fArraySize;i++) fDDPIXELFORMAT[i].dwSize = sizeof(DDPIXELFORMAT);
}


// --------------------------------------------------------------------------
// Internal Structure Access 
// --------------------------------------------------------------------------
DDPIXELFORMAT* __fastcall TDDPixelFormat::FGetInternal_DDPIXELFORMAT_Ptr()
{
// check for errors
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDDPixelFormat::FGetInternal_DDPIXELFORMAT_Ptr()", "TDX_ERROR", "Internal Array size is 0." );
    return NULL;
    }
return fDDPIXELFORMAT;
}
// --------------------------------------------------------------------------
void __fastcall TDDPixelFormat::FSetInternal_DDPIXELFORMAT( dword pArrayIndex, DDPIXELFORMAT* pDDPIXELFORMAT )
{
// check for errors
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDDPixelFormat::FSetInternal_DDPIXELFORMAT()", "TDX_ERROR", "Internal Array size is 0." );
    return;
    }
if (pDDPIXELFORMAT==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDDPixelFormat::FSetInternal_DDPIXELFORMAT()", "TDX_ERROR", "The supplied DDPIXELFORMAT* was NULL" );
    return;
    }
CopyMemory( &fDDPIXELFORMAT[pArrayIndex], pDDPIXELFORMAT, sizeof(DDPIXELFORMAT) );
Internal_DDPIXELFORMAT_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDDPixelFormat::Internal_DDPIXELFORMAT_Update()
{
}

// --------------------------------------------------------------------------
// Method:      FGetFlags_
// Description: This method returns a TDDPixelFormat_Flags_Set<> of the flags 
//              in the current fDDPIXELFORMAT[pArrayIndex].dwFlags. 
// Note:        Multi-Wrapper components do not yet have the capability to 
//              allow modification of flags via the BCB Object Inspector. 
// --------------------------------------------------------------------------
TDDPixelFormat_Flags_Set __fastcall TDDPixelFormat::FGetFlags_( dword pArrayIndex )
{
TDDPixelFormat_Flags_Set TempFlags_;
TempFlags_.Clear();
if (fDDPIXELFORMAT[pArrayIndex].dwFlags & DDPF_ALPHA) TempFlags_ = TempFlags_ << ddpf_alpha;
if (fDDPIXELFORMAT[pArrayIndex].dwFlags & DDPF_ALPHAPIXELS) TempFlags_ = TempFlags_ << ddpf_alphapixels;
if (fDDPIXELFORMAT[pArrayIndex].dwFlags & DDPF_ALPHAPREMULT) TempFlags_ = TempFlags_ << ddpf_alphapremult;
if (fDDPIXELFORMAT[pArrayIndex].dwFlags & DDPF_BUMPDUDV) TempFlags_ = TempFlags_ << ddpf_bumpdudv;
if (fDDPIXELFORMAT[pArrayIndex].dwFlags & DDPF_BUMPLUMINANCE) TempFlags_ = TempFlags_ << ddpf_bumpluminance;
if (fDDPIXELFORMAT[pArrayIndex].dwFlags & DDPF_COMPRESSED) TempFlags_ = TempFlags_ << ddpf_compressed;
if (fDDPIXELFORMAT[pArrayIndex].dwFlags & DDPF_FOURCC) TempFlags_ = TempFlags_ << ddpf_fourcc;
if (fDDPIXELFORMAT[pArrayIndex].dwFlags & DDPF_LUMINANCE) TempFlags_ = TempFlags_ << ddpf_luminance;
if (fDDPIXELFORMAT[pArrayIndex].dwFlags & DDPF_PALETTEINDEXED1) TempFlags_ = TempFlags_ << ddpf_paletteindexed1;
if (fDDPIXELFORMAT[pArrayIndex].dwFlags & DDPF_PALETTEINDEXED2) TempFlags_ = TempFlags_ << ddpf_paletteindexed2;
if (fDDPIXELFORMAT[pArrayIndex].dwFlags & DDPF_PALETTEINDEXED4) TempFlags_ = TempFlags_ << ddpf_paletteindexed4;
if (fDDPIXELFORMAT[pArrayIndex].dwFlags & DDPF_PALETTEINDEXED8) TempFlags_ = TempFlags_ << ddpf_paletteindexed8;
if (fDDPIXELFORMAT[pArrayIndex].dwFlags & DDPF_PALETTEINDEXEDTO8) TempFlags_ = TempFlags_ << ddpf_paletteindexedto8;
if (fDDPIXELFORMAT[pArrayIndex].dwFlags & DDPF_RGB) TempFlags_ = TempFlags_ << ddpf_rgb;
if (fDDPIXELFORMAT[pArrayIndex].dwFlags & DDPF_RGBTOYUV) TempFlags_ = TempFlags_ << ddpf_rgbtoyuv;
if (fDDPIXELFORMAT[pArrayIndex].dwFlags & DDPF_STENCILBUFFER) TempFlags_ = TempFlags_ << ddpf_stencilbuffer;
if (fDDPIXELFORMAT[pArrayIndex].dwFlags & DDPF_YUV) TempFlags_ = TempFlags_ << ddpf_yuv;
if (fDDPIXELFORMAT[pArrayIndex].dwFlags & DDPF_ZBUFFER) TempFlags_ = TempFlags_ << ddpf_zbuffer;
if (fDDPIXELFORMAT[pArrayIndex].dwFlags & DDPF_ZPIXELS) TempFlags_ = TempFlags_ << ddpf_zpixels;
return TempFlags_;
}
// --------------------------------------------------------------------------
// Method:      FGetFlags_Strings()
//              This method creates and then returns a TStringList containing 
//              the current set of 'Flags' flags. 
// Note:        You must manually delete the retrieved TStringList after use 
//              to avoid memory corruption. 
// --------------------------------------------------------------------------
TStringList* __fastcall TDDPixelFormat::FGetFlags_Strings( dword pArrayIndex )
{
// if the strings have not been allocated
if (fFlags_Strings==NULL)
    {
    // attempt to allocate the strings
    fFlags_Strings = new TStringList();
    // if the allocation failed
    if (fFlags_Strings==NULL)
        {
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TDDPixelFormat::FGetFlags_Strings()", "TDX_ERROR", "Could not allocate memory used to retrieve various Flags_Strings" );
        return NULL;
        }
    }
fFlags_Strings->Clear();
if (fDDPIXELFORMAT[pArrayIndex].dwFlags & DDPF_ALPHA) fFlags_Strings->Add("DDPF_ALPHA");
if (fDDPIXELFORMAT[pArrayIndex].dwFlags & DDPF_ALPHAPIXELS) fFlags_Strings->Add("DDPF_ALPHAPIXELS");
if (fDDPIXELFORMAT[pArrayIndex].dwFlags & DDPF_ALPHAPREMULT) fFlags_Strings->Add("DDPF_ALPHAPREMULT");
if (fDDPIXELFORMAT[pArrayIndex].dwFlags & DDPF_BUMPDUDV) fFlags_Strings->Add("DDPF_BUMPDUDV");
if (fDDPIXELFORMAT[pArrayIndex].dwFlags & DDPF_BUMPLUMINANCE) fFlags_Strings->Add("DDPF_BUMPLUMINANCE");
if (fDDPIXELFORMAT[pArrayIndex].dwFlags & DDPF_COMPRESSED) fFlags_Strings->Add("DDPF_COMPRESSED");
if (fDDPIXELFORMAT[pArrayIndex].dwFlags & DDPF_FOURCC) fFlags_Strings->Add("DDPF_FOURCC");
if (fDDPIXELFORMAT[pArrayIndex].dwFlags & DDPF_LUMINANCE) fFlags_Strings->Add("DDPF_LUMINANCE");
if (fDDPIXELFORMAT[pArrayIndex].dwFlags & DDPF_PALETTEINDEXED1) fFlags_Strings->Add("DDPF_PALETTEINDEXED1");
if (fDDPIXELFORMAT[pArrayIndex].dwFlags & DDPF_PALETTEINDEXED2) fFlags_Strings->Add("DDPF_PALETTEINDEXED2");
if (fDDPIXELFORMAT[pArrayIndex].dwFlags & DDPF_PALETTEINDEXED4) fFlags_Strings->Add("DDPF_PALETTEINDEXED4");
if (fDDPIXELFORMAT[pArrayIndex].dwFlags & DDPF_PALETTEINDEXED8) fFlags_Strings->Add("DDPF_PALETTEINDEXED8");
if (fDDPIXELFORMAT[pArrayIndex].dwFlags & DDPF_PALETTEINDEXEDTO8) fFlags_Strings->Add("DDPF_PALETTEINDEXEDTO8");
if (fDDPIXELFORMAT[pArrayIndex].dwFlags & DDPF_RGB) fFlags_Strings->Add("DDPF_RGB");
if (fDDPIXELFORMAT[pArrayIndex].dwFlags & DDPF_RGBTOYUV) fFlags_Strings->Add("DDPF_RGBTOYUV");
if (fDDPIXELFORMAT[pArrayIndex].dwFlags & DDPF_STENCILBUFFER) fFlags_Strings->Add("DDPF_STENCILBUFFER");
if (fDDPIXELFORMAT[pArrayIndex].dwFlags & DDPF_YUV) fFlags_Strings->Add("DDPF_YUV");
if (fDDPIXELFORMAT[pArrayIndex].dwFlags & DDPF_ZBUFFER) fFlags_Strings->Add("DDPF_ZBUFFER");
if (fDDPIXELFORMAT[pArrayIndex].dwFlags & DDPF_ZPIXELS) fFlags_Strings->Add("DDPF_ZPIXELS");
return fFlags_Strings;
}
// --------------------------------------------------------------------------
