// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDDSCaps.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons)
// Description:  This file contains the code for the TDDSCaps Component 
//
// "TDx_Draw3D_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDDSCaps.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Draw3D_Library_Defns"
#pragma link "TDx_Draw3D_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDDSCaps*)
{
    new TDDSCaps(NULL);
}
// --------------------------------------------------------------------------
namespace Tddscaps
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDDSCaps)};
        RegisterComponents("TDx_Draw3D", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDDSCaps::TDDSCaps()
// Description: The default constructor for the TDDSCaps object.
// --------------------------------------------------------------------------
__fastcall TDDSCaps::TDDSCaps(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
fCaps_Strings=NULL;
fCaps2_Strings=NULL;
}
// --------------------------------------------------------------------------
// Destructor:  TDDSCaps::~TDDSCaps()
// Description: The destructor for the TDDSCaps object.
// --------------------------------------------------------------------------
__fastcall TDDSCaps::~TDDSCaps()
{
if (fCaps_Strings!=NULL) delete fCaps_Strings;
if (fCaps2_Strings!=NULL) delete fCaps2_Strings;
}
// --------------------------------------------------------------------------
// Property:    Caps
// Description: The Caps property defines flags indicating the capabilities 
//              of a surface. 
//              The described effect applies when the flag is set. 
// Flags:       DDSCAPS_3DDEVICE -
//                The surface this component describes can be used for 3D 
//                rendering. 
//                
//                This flag can be used to ensure devices capable of only 
//                rendering to a certain heap will have off screen surfaces 
//                allocated from the appropriate heap. 
//                
//                Setting this flag for a heap will make sure the surface is 
//                not allocated from it. 
//              DDSCAPS_ALPHA -
//                The surface this component describes is an alpha only 
//                surface. 
//              DDSCAPS_BACKBUFFER -
//                The surface this component describes is the back buffer of 
//                a flipping construct. 
//                
//                TDx_Draw::CreateSurface() usually sets this flag when 
//                called with DDSCAPS_FLIP set. 
//                This flag will only be set on the surface immediately 
//                following a DDSCAPS_FRONTBUFFER surface in a flip chain. 
//                Other back buffers can be identified by having a 
//                DDSCAPS_FLIP flag, their attachment order and the absence 
//                of the DDSCAPS_FRONTBUFFER or DDSCAPS_BACKBUFFER flags. 
//                
//                Using TDx_Draw::CreateSurface() with this flag set creates 
//                a stand alone back buffer which may then be attached with 
//                TDx_DrawSurface::AddAttachedSurface() to front, back or 
//                both buffers to form a flipping construct. 
//                An arbitrary number of flipping chain surfaces are 
//                supported. 
//              DDSCAPS_COMPLEX -
//                The surface this component describes is a complex surface. 
//              DDSCAPS_FLIP -
//                The surface this component describes is a part of a 
//                flipping construct. 
//                
//                Pass this flag to TDx_Draw::CreateSurface() to create a 
//                front buffer and one or more back buffers. 
//                The DDSCAPS_FRONTBUFFER and DDSCAPS_BACKBUFFER flags will 
//                be set on the frontbuffer surface and the next surface in 
//                the chain respectively. 
//                The TDDSurfaceDesc::BackBufferCount used in the creation 
//                call must be at least 1 in order for the call to succeed. 
//                
//                DDSCAPS_COMPLEX must always be set when creating multiple 
//                surfaces using TDx_Draw::CreateSurface(). 
//              DDSCAPS_FRONTBUFFER -
//                The surface this component describes is the front buffer of 
//                a flipping construct. 
//                
//                This flag is usually set by TDx_Draw::CreateSurface() when 
//                called using the DDSCAPS_FLIP flag. 
//                
//                When TDx_Draw::CreateSurface() is called with this flag 
//                set, a stand-alone front buffer is created. It will not 
//                have DDSCAPS_FLIP set and it can be attached to other back 
//                buffers to form a flipping construct by using 
//                TDx_DrawSurface::AddAttachedSurface(). 
//              DDSCAPS_HWCODEC -
//                The surface this component describes can have a data stream 
//                decompressed to it by the hardware. 
//                
//                This would generally be a stream from a video port to an 
//                overlay surface but other uses are possible. 
//              DDSCAPS_LIVEVIDEO -
//                The surface this component describes is capable of 
//                receiving live video. 
//              DDSCAPS_LOCALVIDMEM -
//                The surface this component describes exists in local video 
//                memory. 
//                DDSCAPS_VIDEOMEMORY must also be set. 
//                This flag cannot be used with DDSCAPS_NONLOCALVIDMEM. 
//              DDSCAPS_MIPMAP -
//                The surface this component describes is a mipmap level. 
//                
//                Other DDSCAPS_MIPMAP surfaces can be attached to form the 
//                mipmap by either creating a number of surfaces and 
//                attaching them using TDx_DrawSurface::AddAttachedSurface() 
//                or all at once using TDx_Draw::CreateSurface() to create a 
//                complex mipmap surface chain. 
//                
//                DDSCAPS_TEXTURE must also be set. 
//              DDSCAPS_MODEX -
//                The surface this component describes is a 320 by 200 or 320 
//                by 240 Mode X surface. 
//              DDSCAPS_NONLOCALVIDMEM -
//                The surface this component describes exists in nonlocal 
//                video memory. 
//                DDSCAPS_VIDEOMEMORY must also be set. 
//                This flag cannot be used with DDSCAPS_LOCALVIDMEM. 
//              DDSCAPS_OFFSCREENPLAIN -
//                The surface this component describes is an ordinary off 
//                screen surface. 
//                Not an overlay, texture, z-buffer, front-buffer, 
//                back-buffer or alpha surface. 
//              DDSCAPS_OVERLAY -
//                The surface this component describes is an overlay. 
//                DDSCAPS_VISIBLE can be used to determine if the overlay is 
//                visible. 
//              DDSCAPS_OWNDC -
//                The surface this component describes has a device context 
//                assigned to it. 
//              DDSCAPS_PALETTE -
//                The device driver allows unique palettes to be created and 
//                attached to the surface this component describes. 
//              DDSCAPS_PRIMARYSURFACE -
//                The surface this component describes is the primary 
//                surface. 
//              DDSCAPS_STANDARDVGAMODE -
//                The surface this component describes is a standard VGA mode 
//                surface. 
//                This flag cannot be used with DDSCAPS_MODEX. 
//              DDSCAPS_SYSTEMMEMORY -
//                The surface this component describes exists in system 
//                memory. 
//              DDSCAPS_TEXTURE -
//                The surface this component describes can be used as a 3D 
//                texture. 
//                This flag being set does not neccessarily mean the surface 
//                is being used as a 3D texture. 
//              DDSCAPS_VIDEOMEMORY -
//                The surface this component describes exists in display 
//                memory. 
//              DDSCAPS_VIDEOPORT -
//                The surface this component describes can receive data from 
//                a video port. 
//              DDSCAPS_VISIBLE -
//                Changes made to the surface this component describes will 
//                immediately be visible. 
//                This flag is always set for the primary surface, for 
//                overlays when they are being overlaid and texture maps 
//                while they are being textured. 
//              DDSCAPS_WRITEONLY -
//                Write access only is permitted for the surface this 
//                component describes. 
//                Trying to read this surface may generate general protection 
//                faults and the read results will not be meaningful. 
//              DDSCAPS_ZBUFFER -
//                The surface this component describes is a z-buffer. 
// --------------------------------------------------------------------------
dword __fastcall TDDSCaps::FGetCaps()
{
return fDDSCAPS2.dwCaps;
}
// --------------------------------------------------------------------------
void __fastcall TDDSCaps::FSetCaps( dword pCaps )
{
fDDSCAPS2.dwCaps = pCaps;
}
// --------------------------------------------------------------------------
// Property:    Caps2
// Description: The Caps2 property defines flags indicating more surface 
//              capabilities as well as some usage hints for the driver. 
//              The described effect applies when the flag is set. 
// Flags:       DDSCAPS2_CUBEMAP -
//                The surface is a cubic environment map. 
//                The various DDSCAPS2_CUBEMAP_???? flags can be used to 
//                indicate which face or faces of the cubemap to create or 
//                access. 
//              DDSCAPS2_CUBEMAP_ALLFACES -
//                Create or access all the faces of a cubic environment map. 
//                DDSCAPS2_CUBEMAP must also be set. 
//              DDSCAPS2_CUBEMAP_NEGATIVEX -
//                Create or access the negative X face of a cubic environment 
//                map. 
//                DDSCAPS2_CUBEMAP must also be set. 
//              DDSCAPS2_CUBEMAP_NEGATIVEY -
//                Create or access the negative Y face of a cubic environment 
//                map. 
//                DDSCAPS2_CUBEMAP must also be set. 
//              DDSCAPS2_CUBEMAP_NEGATIVEZ -
//                Create or access the negative Z face of a cubic environment 
//                map. 
//                DDSCAPS2_CUBEMAP must also be set. 
//              DDSCAPS2_CUBEMAP_POSITIVEX -
//                Create or access the positive X face of a cubic environment 
//                map. 
//                DDSCAPS2_CUBEMAP must also be set. 
//              DDSCAPS2_CUBEMAP_POSITIVEY -
//                Create or access the positive Y face of a cubic environment 
//                map. 
//                DDSCAPS2_CUBEMAP must also be set. 
//              DDSCAPS2_CUBEMAP_POSITIVEZ -
//                Create or access the positive Z face of a cubic environment 
//                map. 
//                DDSCAPS2_CUBEMAP must also be set. 
//              DDSCAPS2_D3DTEXTUREMANAGE -
//                The surface this component describes will be automatically 
//                managed by the driver or the TDx_3D texture manager. 
//                This setting will only be valid if DDSCAPS_TEXTURE is set 
//                in TDDSCaps::Caps. 
//                This flag should not be set when using TDx_3DR. 
//              DDSCAPS2_DONOTPERSIST -
//                Indicates that the managed surface can be lost without 
//                causing problems. 
//              DDSCAPS2_HARDWAREDEINTERLACE -
//                The surface this component describes will receive 
//                de-interlaced video port data. 
//                To utilize this capability DDSCAPS_VIDEOPORT and 
//                DDSCAPS_OVERLAY must be set in TDDSCaps::Caps. 
//              DDSCAPS2_HINTANTIALIASING -
//                The surface this component describes will use antialiasing. 
//                This setting will only be valid if DDSCAPS_3DDEVICE is set 
//                in TDDSCaps::Caps. 
//              DDSCAPS2_HINTDYNAMIC -
//                The surface this component describes will be be locked 
//                frequently. 
//                This setting will only be valid if DDSCAPS_TEXTURE is set 
//                in TDDSCaps::Caps. 
//                The DDSCAPS2_HINTSTATIC and DDSCAPS2_OPAQUE flags must not 
//                be set. 
//              DDSCAPS2_HINTSTATIC -
//                The surface this component describes can be retiled or 
//                reordered when loading. 
//                This setting will only be valid if DDSCAPS_TEXTURE is set 
//                in TDDSCaps::Caps. 
//                The DDSCAPS2_HINTDYNAMIC and DDSCAPS2_OPAQUE flags must not 
//                be set. 
//              DDSCAPS2_MIPMAPSUBLEVEL -
//                All sub level surfaces of a complex construct such as a 
//                mipmapped cube map should have this flag set. 
//                This allows TDx_DrawSurface::GetAttachedSurface() to 
//                distinguish between the top level faces and the attached 
//                mipmap levels, allowing retrieval via that method rather 
//                than relying on TDx_DrawSurface::EnumAttachedSurfaces(). 
//              DDSCAPS2_OPAQUE -
//                The surface this component describes will never be locked 
//                again. 
//                This setting will only be valid if DDSCAPS_TEXTURE flag is 
//                set in TDDSCaps::Caps. 
//                The DDSCAPS2_HINTDYNAMIC and DDSCAPS2_HINTSTATIC flags must 
//                not be set. 
//                The driver may optimize this surface as desired. 
//                Any attempts to lock or blit a surface with this flag set 
//                will fail. 
//              DDSCAPS2_STEREOSURFACELEFT -
//                The surface is part of a stereo flipping chain. 
//                Creating surfaces using this flag will result in a pair of 
//                stereo surfaces to be created for each buffer in the 
//                primary flipping chain. 
//                Since TDx_DrawSurface::Flip() requires back buffers, this 
//                means that at least four surfaces must be created. 
//                If this flag is set in the TDDSurfaceDesc component 
//                returned by TDx_Draw::EnumDisplayModes() or 
//                TDx_Draw::GetDisplayMode(), it indicates that stereo is 
//                supported for that mode. 
//              DDSCAPS2_TEXTUREMANAGE -
//                The surface this component describes is to be automatically 
//                managed by the TDx_3D texture manager. 
//                This setting will only be valid if DDSCAPS_TEXTURE is set 
//                in DDSCaps::Caps. 
// --------------------------------------------------------------------------
dword __fastcall TDDSCaps::FGetCaps2()
{
return fDDSCAPS2.dwCaps2;
}
// --------------------------------------------------------------------------
void __fastcall TDDSCaps::FSetCaps2( dword pCaps2 )
{
fDDSCAPS2.dwCaps2 = pCaps2;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDDSCaps method or fget/fset. eg. 
//              D3D_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDDSCaps::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDDSCaps::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of the internal 
//              DDSCAPS2 structure. 
// --------------------------------------------------------------------------
dword __fastcall TDDSCaps::FGetSize()
{
return fSize;
}
// --------------------------------------------------------------------------
void __fastcall TDDSCaps::FSetSize( dword pSize )
{
fSize = pSize;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDDSCaps's internal DDSCAPS2 structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDDSCaps::Clear()
{
fDDSCAPS2.dwCaps = 0;
fDDSCAPS2.dwCaps2 = 0;
fErrorValue = D3D_OK;
fSize = sizeof(DDSCAPS2);
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DDSCAPS2* __fastcall TDDSCaps::FGetInternal_DDSCAPS2_Ptr()
{
return &fDDSCAPS2;
}
// --------------------------------------------------------------------------
void __fastcall TDDSCaps::FSetInternal_DDSCAPS2( DDSCAPS2* pDDSCAPS2 )
{
if (pDDSCAPS2==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDDSCaps::FSetInternal_DDSCAPS2()", "TDX_ERROR", "The supplied DDSCAPS2* was NULL" );
    return;
    }

CopyMemory( &fDDSCAPS2, pDDSCAPS2, sizeof(DDSCAPS2) );
Internal_DDSCAPS2_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDDSCaps::Internal_DDSCAPS2_Update()
{
}

// --------------------------------------------------------------------------
// Method:      FGetCaps_
// Description: This method returns a TDDSCaps_Caps_Set<> of the flags in the 
//              current fDDSCAPS2.dwCaps. 
// Note:        Wrapper components use the following method to modify flags 
//              via the BCB Object Inspector. 
// --------------------------------------------------------------------------
TDDSCaps_Caps_Set __fastcall TDDSCaps::FGetCaps_()
{
TDDSCaps_Caps_Set TempCaps_;
TempCaps_.Clear();
if (fDDSCAPS2.dwCaps & DDSCAPS_3DDEVICE) TempCaps_ = TempCaps_ << ddscaps_3ddevice;
if (fDDSCAPS2.dwCaps & DDSCAPS_ALPHA) TempCaps_ = TempCaps_ << ddscaps_alpha;
if (fDDSCAPS2.dwCaps & DDSCAPS_BACKBUFFER) TempCaps_ = TempCaps_ << ddscaps_backbuffer;
if (fDDSCAPS2.dwCaps & DDSCAPS_COMPLEX) TempCaps_ = TempCaps_ << ddscaps_complex;
if (fDDSCAPS2.dwCaps & DDSCAPS_FLIP) TempCaps_ = TempCaps_ << ddscaps_flip;
if (fDDSCAPS2.dwCaps & DDSCAPS_FRONTBUFFER) TempCaps_ = TempCaps_ << ddscaps_frontbuffer;
if (fDDSCAPS2.dwCaps & DDSCAPS_HWCODEC) TempCaps_ = TempCaps_ << ddscaps_hwcodec;
if (fDDSCAPS2.dwCaps & DDSCAPS_LIVEVIDEO) TempCaps_ = TempCaps_ << ddscaps_livevideo;
if (fDDSCAPS2.dwCaps & DDSCAPS_LOCALVIDMEM) TempCaps_ = TempCaps_ << ddscaps_localvidmem;
if (fDDSCAPS2.dwCaps & DDSCAPS_MIPMAP) TempCaps_ = TempCaps_ << ddscaps_mipmap;
if (fDDSCAPS2.dwCaps & DDSCAPS_MODEX) TempCaps_ = TempCaps_ << ddscaps_modex;
if (fDDSCAPS2.dwCaps & DDSCAPS_NONLOCALVIDMEM) TempCaps_ = TempCaps_ << ddscaps_nonlocalvidmem;
if (fDDSCAPS2.dwCaps & DDSCAPS_OFFSCREENPLAIN) TempCaps_ = TempCaps_ << ddscaps_offscreenplain;
if (fDDSCAPS2.dwCaps & DDSCAPS_OVERLAY) TempCaps_ = TempCaps_ << ddscaps_overlay;
if (fDDSCAPS2.dwCaps & DDSCAPS_OWNDC) TempCaps_ = TempCaps_ << ddscaps_owndc;
if (fDDSCAPS2.dwCaps & DDSCAPS_PALETTE) TempCaps_ = TempCaps_ << ddscaps_palette;
if (fDDSCAPS2.dwCaps & DDSCAPS_PRIMARYSURFACE) TempCaps_ = TempCaps_ << ddscaps_primarysurface;
if (fDDSCAPS2.dwCaps & DDSCAPS_STANDARDVGAMODE) TempCaps_ = TempCaps_ << ddscaps_standardvgamode;
if (fDDSCAPS2.dwCaps & DDSCAPS_SYSTEMMEMORY) TempCaps_ = TempCaps_ << ddscaps_systemmemory;
if (fDDSCAPS2.dwCaps & DDSCAPS_TEXTURE) TempCaps_ = TempCaps_ << ddscaps_texture;
if (fDDSCAPS2.dwCaps & DDSCAPS_VIDEOMEMORY) TempCaps_ = TempCaps_ << ddscaps_videomemory;
if (fDDSCAPS2.dwCaps & DDSCAPS_VIDEOPORT) TempCaps_ = TempCaps_ << ddscaps_videoport;
if (fDDSCAPS2.dwCaps & DDSCAPS_VISIBLE) TempCaps_ = TempCaps_ << ddscaps_visible;
if (fDDSCAPS2.dwCaps & DDSCAPS_WRITEONLY) TempCaps_ = TempCaps_ << ddscaps_writeonly;
if (fDDSCAPS2.dwCaps & DDSCAPS_ZBUFFER) TempCaps_ = TempCaps_ << ddscaps_zbuffer;
return TempCaps_;
}
// --------------------------------------------------------------------------
void __fastcall TDDSCaps::FSetCaps_( TDDSCaps_Caps_Set pCaps_ )
{
fDDSCAPS2.dwCaps = 0;
if (pCaps_.Contains(ddscaps_3ddevice)) fDDSCAPS2.dwCaps |= DDSCAPS_3DDEVICE;
if (pCaps_.Contains(ddscaps_alpha)) fDDSCAPS2.dwCaps |= DDSCAPS_ALPHA;
if (pCaps_.Contains(ddscaps_backbuffer)) fDDSCAPS2.dwCaps |= DDSCAPS_BACKBUFFER;
if (pCaps_.Contains(ddscaps_complex)) fDDSCAPS2.dwCaps |= DDSCAPS_COMPLEX;
if (pCaps_.Contains(ddscaps_flip)) fDDSCAPS2.dwCaps |= DDSCAPS_FLIP;
if (pCaps_.Contains(ddscaps_frontbuffer)) fDDSCAPS2.dwCaps |= DDSCAPS_FRONTBUFFER;
if (pCaps_.Contains(ddscaps_hwcodec)) fDDSCAPS2.dwCaps |= DDSCAPS_HWCODEC;
if (pCaps_.Contains(ddscaps_livevideo)) fDDSCAPS2.dwCaps |= DDSCAPS_LIVEVIDEO;
if (pCaps_.Contains(ddscaps_localvidmem)) fDDSCAPS2.dwCaps |= DDSCAPS_LOCALVIDMEM;
if (pCaps_.Contains(ddscaps_mipmap)) fDDSCAPS2.dwCaps |= DDSCAPS_MIPMAP;
if (pCaps_.Contains(ddscaps_modex)) fDDSCAPS2.dwCaps |= DDSCAPS_MODEX;
if (pCaps_.Contains(ddscaps_nonlocalvidmem)) fDDSCAPS2.dwCaps |= DDSCAPS_NONLOCALVIDMEM;
if (pCaps_.Contains(ddscaps_offscreenplain)) fDDSCAPS2.dwCaps |= DDSCAPS_OFFSCREENPLAIN;
if (pCaps_.Contains(ddscaps_overlay)) fDDSCAPS2.dwCaps |= DDSCAPS_OVERLAY;
if (pCaps_.Contains(ddscaps_owndc)) fDDSCAPS2.dwCaps |= DDSCAPS_OWNDC;
if (pCaps_.Contains(ddscaps_palette)) fDDSCAPS2.dwCaps |= DDSCAPS_PALETTE;
if (pCaps_.Contains(ddscaps_primarysurface)) fDDSCAPS2.dwCaps |= DDSCAPS_PRIMARYSURFACE;
if (pCaps_.Contains(ddscaps_standardvgamode)) fDDSCAPS2.dwCaps |= DDSCAPS_STANDARDVGAMODE;
if (pCaps_.Contains(ddscaps_systemmemory)) fDDSCAPS2.dwCaps |= DDSCAPS_SYSTEMMEMORY;
if (pCaps_.Contains(ddscaps_texture)) fDDSCAPS2.dwCaps |= DDSCAPS_TEXTURE;
if (pCaps_.Contains(ddscaps_videomemory)) fDDSCAPS2.dwCaps |= DDSCAPS_VIDEOMEMORY;
if (pCaps_.Contains(ddscaps_videoport)) fDDSCAPS2.dwCaps |= DDSCAPS_VIDEOPORT;
if (pCaps_.Contains(ddscaps_visible)) fDDSCAPS2.dwCaps |= DDSCAPS_VISIBLE;
if (pCaps_.Contains(ddscaps_writeonly)) fDDSCAPS2.dwCaps |= DDSCAPS_WRITEONLY;
if (pCaps_.Contains(ddscaps_zbuffer)) fDDSCAPS2.dwCaps |= DDSCAPS_ZBUFFER;
}
// --------------------------------------------------------------------------
// Method:      FGetCaps_Strings()
//              This method creates and then returns a TStringList containing 
//              the current set of 'Caps' flags. 
// Note:        You must manually delete the retrieved TStringList after use 
//              to avoid memory corruption. 
// --------------------------------------------------------------------------
TStringList* __fastcall TDDSCaps::FGetCaps_Strings()
{
// if the strings have not been allocated
if (fCaps_Strings==NULL)
    {
    // attempt to allocate the strings
    fCaps_Strings = new TStringList();
    // if the allocation failed
    if (fCaps_Strings==NULL)
        {
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TDDSCaps::FGetCaps_Strings()", "TDX_ERROR", "Could not allocate memory used to retrieve various Caps_Strings" );
        return NULL;
        }
    }
fCaps_Strings->Clear();
if (fDDSCAPS2.dwCaps & DDSCAPS_3DDEVICE) fCaps_Strings->Add("DDSCAPS_3DDEVICE");
if (fDDSCAPS2.dwCaps & DDSCAPS_ALPHA) fCaps_Strings->Add("DDSCAPS_ALPHA");
if (fDDSCAPS2.dwCaps & DDSCAPS_BACKBUFFER) fCaps_Strings->Add("DDSCAPS_BACKBUFFER");
if (fDDSCAPS2.dwCaps & DDSCAPS_COMPLEX) fCaps_Strings->Add("DDSCAPS_COMPLEX");
if (fDDSCAPS2.dwCaps & DDSCAPS_FLIP) fCaps_Strings->Add("DDSCAPS_FLIP");
if (fDDSCAPS2.dwCaps & DDSCAPS_FRONTBUFFER) fCaps_Strings->Add("DDSCAPS_FRONTBUFFER");
if (fDDSCAPS2.dwCaps & DDSCAPS_HWCODEC) fCaps_Strings->Add("DDSCAPS_HWCODEC");
if (fDDSCAPS2.dwCaps & DDSCAPS_LIVEVIDEO) fCaps_Strings->Add("DDSCAPS_LIVEVIDEO");
if (fDDSCAPS2.dwCaps & DDSCAPS_LOCALVIDMEM) fCaps_Strings->Add("DDSCAPS_LOCALVIDMEM");
if (fDDSCAPS2.dwCaps & DDSCAPS_MIPMAP) fCaps_Strings->Add("DDSCAPS_MIPMAP");
if (fDDSCAPS2.dwCaps & DDSCAPS_MODEX) fCaps_Strings->Add("DDSCAPS_MODEX");
if (fDDSCAPS2.dwCaps & DDSCAPS_NONLOCALVIDMEM) fCaps_Strings->Add("DDSCAPS_NONLOCALVIDMEM");
if (fDDSCAPS2.dwCaps & DDSCAPS_OFFSCREENPLAIN) fCaps_Strings->Add("DDSCAPS_OFFSCREENPLAIN");
if (fDDSCAPS2.dwCaps & DDSCAPS_OVERLAY) fCaps_Strings->Add("DDSCAPS_OVERLAY");
if (fDDSCAPS2.dwCaps & DDSCAPS_OWNDC) fCaps_Strings->Add("DDSCAPS_OWNDC");
if (fDDSCAPS2.dwCaps & DDSCAPS_PALETTE) fCaps_Strings->Add("DDSCAPS_PALETTE");
if (fDDSCAPS2.dwCaps & DDSCAPS_PRIMARYSURFACE) fCaps_Strings->Add("DDSCAPS_PRIMARYSURFACE");
if (fDDSCAPS2.dwCaps & DDSCAPS_STANDARDVGAMODE) fCaps_Strings->Add("DDSCAPS_STANDARDVGAMODE");
if (fDDSCAPS2.dwCaps & DDSCAPS_SYSTEMMEMORY) fCaps_Strings->Add("DDSCAPS_SYSTEMMEMORY");
if (fDDSCAPS2.dwCaps & DDSCAPS_TEXTURE) fCaps_Strings->Add("DDSCAPS_TEXTURE");
if (fDDSCAPS2.dwCaps & DDSCAPS_VIDEOMEMORY) fCaps_Strings->Add("DDSCAPS_VIDEOMEMORY");
if (fDDSCAPS2.dwCaps & DDSCAPS_VIDEOPORT) fCaps_Strings->Add("DDSCAPS_VIDEOPORT");
if (fDDSCAPS2.dwCaps & DDSCAPS_VISIBLE) fCaps_Strings->Add("DDSCAPS_VISIBLE");
if (fDDSCAPS2.dwCaps & DDSCAPS_WRITEONLY) fCaps_Strings->Add("DDSCAPS_WRITEONLY");
if (fDDSCAPS2.dwCaps & DDSCAPS_ZBUFFER) fCaps_Strings->Add("DDSCAPS_ZBUFFER");
return fCaps_Strings;
}
// --------------------------------------------------------------------------
// Method:      FGetCaps2_
// Description: This method returns a TDDSCaps_Caps2_Set<> of the flags in 
//              the current fDDSCAPS2.dwCaps2. 
// Note:        Wrapper components use the following method to modify flags 
//              via the BCB Object Inspector. 
// --------------------------------------------------------------------------
TDDSCaps_Caps2_Set __fastcall TDDSCaps::FGetCaps2_()
{
TDDSCaps_Caps2_Set TempCaps2_;
TempCaps2_.Clear();
if (fDDSCAPS2.dwCaps2 & DDSCAPS2_CUBEMAP) TempCaps2_ = TempCaps2_ << ddscaps2_cubemap;
if (fDDSCAPS2.dwCaps2 & DDSCAPS2_CUBEMAP_ALLFACES) TempCaps2_ = TempCaps2_ << ddscaps2_cubemap_allfaces;
if (fDDSCAPS2.dwCaps2 & DDSCAPS2_CUBEMAP_NEGATIVEX) TempCaps2_ = TempCaps2_ << ddscaps2_cubemap_negativex;
if (fDDSCAPS2.dwCaps2 & DDSCAPS2_CUBEMAP_NEGATIVEY) TempCaps2_ = TempCaps2_ << ddscaps2_cubemap_negativey;
if (fDDSCAPS2.dwCaps2 & DDSCAPS2_CUBEMAP_NEGATIVEZ) TempCaps2_ = TempCaps2_ << ddscaps2_cubemap_negativez;
if (fDDSCAPS2.dwCaps2 & DDSCAPS2_CUBEMAP_POSITIVEX) TempCaps2_ = TempCaps2_ << ddscaps2_cubemap_positivex;
if (fDDSCAPS2.dwCaps2 & DDSCAPS2_CUBEMAP_POSITIVEY) TempCaps2_ = TempCaps2_ << ddscaps2_cubemap_positivey;
if (fDDSCAPS2.dwCaps2 & DDSCAPS2_CUBEMAP_POSITIVEZ) TempCaps2_ = TempCaps2_ << ddscaps2_cubemap_positivez;
if (fDDSCAPS2.dwCaps2 & DDSCAPS2_D3DTEXTUREMANAGE) TempCaps2_ = TempCaps2_ << ddscaps2_d3dtexturemanage;
if (fDDSCAPS2.dwCaps2 & DDSCAPS2_DONOTPERSIST) TempCaps2_ = TempCaps2_ << ddscaps2_donotpersist;
if (fDDSCAPS2.dwCaps2 & DDSCAPS2_HARDWAREDEINTERLACE) TempCaps2_ = TempCaps2_ << ddscaps2_hardwaredeinterlace;
if (fDDSCAPS2.dwCaps2 & DDSCAPS2_HINTANTIALIASING) TempCaps2_ = TempCaps2_ << ddscaps2_hintantialiasing;
if (fDDSCAPS2.dwCaps2 & DDSCAPS2_HINTDYNAMIC) TempCaps2_ = TempCaps2_ << ddscaps2_hintdynamic;
if (fDDSCAPS2.dwCaps2 & DDSCAPS2_HINTSTATIC) TempCaps2_ = TempCaps2_ << ddscaps2_hintstatic;
if (fDDSCAPS2.dwCaps2 & DDSCAPS2_MIPMAPSUBLEVEL) TempCaps2_ = TempCaps2_ << ddscaps2_mipmapsublevel;
if (fDDSCAPS2.dwCaps2 & DDSCAPS2_OPAQUE) TempCaps2_ = TempCaps2_ << ddscaps2_opaque;
if (fDDSCAPS2.dwCaps2 & DDSCAPS2_STEREOSURFACELEFT) TempCaps2_ = TempCaps2_ << ddscaps2_stereosurfaceleft;
if (fDDSCAPS2.dwCaps2 & DDSCAPS2_TEXTUREMANAGE) TempCaps2_ = TempCaps2_ << ddscaps2_texturemanage;
return TempCaps2_;
}
// --------------------------------------------------------------------------
void __fastcall TDDSCaps::FSetCaps2_( TDDSCaps_Caps2_Set pCaps2_ )
{
fDDSCAPS2.dwCaps2 = 0;
if (pCaps2_.Contains(ddscaps2_cubemap)) fDDSCAPS2.dwCaps2 |= DDSCAPS2_CUBEMAP;
if (pCaps2_.Contains(ddscaps2_cubemap_allfaces)) fDDSCAPS2.dwCaps2 |= DDSCAPS2_CUBEMAP_ALLFACES;
if (pCaps2_.Contains(ddscaps2_cubemap_negativex)) fDDSCAPS2.dwCaps2 |= DDSCAPS2_CUBEMAP_NEGATIVEX;
if (pCaps2_.Contains(ddscaps2_cubemap_negativey)) fDDSCAPS2.dwCaps2 |= DDSCAPS2_CUBEMAP_NEGATIVEY;
if (pCaps2_.Contains(ddscaps2_cubemap_negativez)) fDDSCAPS2.dwCaps2 |= DDSCAPS2_CUBEMAP_NEGATIVEZ;
if (pCaps2_.Contains(ddscaps2_cubemap_positivex)) fDDSCAPS2.dwCaps2 |= DDSCAPS2_CUBEMAP_POSITIVEX;
if (pCaps2_.Contains(ddscaps2_cubemap_positivey)) fDDSCAPS2.dwCaps2 |= DDSCAPS2_CUBEMAP_POSITIVEY;
if (pCaps2_.Contains(ddscaps2_cubemap_positivez)) fDDSCAPS2.dwCaps2 |= DDSCAPS2_CUBEMAP_POSITIVEZ;
if (pCaps2_.Contains(ddscaps2_d3dtexturemanage)) fDDSCAPS2.dwCaps2 |= DDSCAPS2_D3DTEXTUREMANAGE;
if (pCaps2_.Contains(ddscaps2_donotpersist)) fDDSCAPS2.dwCaps2 |= DDSCAPS2_DONOTPERSIST;
if (pCaps2_.Contains(ddscaps2_hardwaredeinterlace)) fDDSCAPS2.dwCaps2 |= DDSCAPS2_HARDWAREDEINTERLACE;
if (pCaps2_.Contains(ddscaps2_hintantialiasing)) fDDSCAPS2.dwCaps2 |= DDSCAPS2_HINTANTIALIASING;
if (pCaps2_.Contains(ddscaps2_hintdynamic)) fDDSCAPS2.dwCaps2 |= DDSCAPS2_HINTDYNAMIC;
if (pCaps2_.Contains(ddscaps2_hintstatic)) fDDSCAPS2.dwCaps2 |= DDSCAPS2_HINTSTATIC;
if (pCaps2_.Contains(ddscaps2_mipmapsublevel)) fDDSCAPS2.dwCaps2 |= DDSCAPS2_MIPMAPSUBLEVEL;
if (pCaps2_.Contains(ddscaps2_opaque)) fDDSCAPS2.dwCaps2 |= DDSCAPS2_OPAQUE;
if (pCaps2_.Contains(ddscaps2_stereosurfaceleft)) fDDSCAPS2.dwCaps2 |= DDSCAPS2_STEREOSURFACELEFT;
if (pCaps2_.Contains(ddscaps2_texturemanage)) fDDSCAPS2.dwCaps2 |= DDSCAPS2_TEXTUREMANAGE;
}
// --------------------------------------------------------------------------
// Method:      FGetCaps2_Strings()
//              This method creates and then returns a TStringList containing 
//              the current set of 'Caps2' flags. 
// Note:        You must manually delete the retrieved TStringList after use 
//              to avoid memory corruption. 
// --------------------------------------------------------------------------
TStringList* __fastcall TDDSCaps::FGetCaps2_Strings()
{
// if the strings have not been allocated
if (fCaps2_Strings==NULL)
    {
    // attempt to allocate the strings
    fCaps2_Strings = new TStringList();
    // if the allocation failed
    if (fCaps2_Strings==NULL)
        {
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TDDSCaps::FGetCaps2_Strings()", "TDX_ERROR", "Could not allocate memory used to retrieve various Caps2_Strings" );
        return NULL;
        }
    }
fCaps2_Strings->Clear();
if (fDDSCAPS2.dwCaps2 & DDSCAPS2_CUBEMAP) fCaps2_Strings->Add("DDSCAPS2_CUBEMAP");
if (fDDSCAPS2.dwCaps2 & DDSCAPS2_CUBEMAP_ALLFACES) fCaps2_Strings->Add("DDSCAPS2_CUBEMAP_ALLFACES");
if (fDDSCAPS2.dwCaps2 & DDSCAPS2_CUBEMAP_NEGATIVEX) fCaps2_Strings->Add("DDSCAPS2_CUBEMAP_NEGATIVEX");
if (fDDSCAPS2.dwCaps2 & DDSCAPS2_CUBEMAP_NEGATIVEY) fCaps2_Strings->Add("DDSCAPS2_CUBEMAP_NEGATIVEY");
if (fDDSCAPS2.dwCaps2 & DDSCAPS2_CUBEMAP_NEGATIVEZ) fCaps2_Strings->Add("DDSCAPS2_CUBEMAP_NEGATIVEZ");
if (fDDSCAPS2.dwCaps2 & DDSCAPS2_CUBEMAP_POSITIVEX) fCaps2_Strings->Add("DDSCAPS2_CUBEMAP_POSITIVEX");
if (fDDSCAPS2.dwCaps2 & DDSCAPS2_CUBEMAP_POSITIVEY) fCaps2_Strings->Add("DDSCAPS2_CUBEMAP_POSITIVEY");
if (fDDSCAPS2.dwCaps2 & DDSCAPS2_CUBEMAP_POSITIVEZ) fCaps2_Strings->Add("DDSCAPS2_CUBEMAP_POSITIVEZ");
if (fDDSCAPS2.dwCaps2 & DDSCAPS2_D3DTEXTUREMANAGE) fCaps2_Strings->Add("DDSCAPS2_D3DTEXTUREMANAGE");
if (fDDSCAPS2.dwCaps2 & DDSCAPS2_DONOTPERSIST) fCaps2_Strings->Add("DDSCAPS2_DONOTPERSIST");
if (fDDSCAPS2.dwCaps2 & DDSCAPS2_HARDWAREDEINTERLACE) fCaps2_Strings->Add("DDSCAPS2_HARDWAREDEINTERLACE");
if (fDDSCAPS2.dwCaps2 & DDSCAPS2_HINTANTIALIASING) fCaps2_Strings->Add("DDSCAPS2_HINTANTIALIASING");
if (fDDSCAPS2.dwCaps2 & DDSCAPS2_HINTDYNAMIC) fCaps2_Strings->Add("DDSCAPS2_HINTDYNAMIC");
if (fDDSCAPS2.dwCaps2 & DDSCAPS2_HINTSTATIC) fCaps2_Strings->Add("DDSCAPS2_HINTSTATIC");
if (fDDSCAPS2.dwCaps2 & DDSCAPS2_MIPMAPSUBLEVEL) fCaps2_Strings->Add("DDSCAPS2_MIPMAPSUBLEVEL");
if (fDDSCAPS2.dwCaps2 & DDSCAPS2_OPAQUE) fCaps2_Strings->Add("DDSCAPS2_OPAQUE");
if (fDDSCAPS2.dwCaps2 & DDSCAPS2_STEREOSURFACELEFT) fCaps2_Strings->Add("DDSCAPS2_STEREOSURFACELEFT");
if (fDDSCAPS2.dwCaps2 & DDSCAPS2_TEXTUREMANAGE) fCaps2_Strings->Add("DDSCAPS2_TEXTUREMANAGE");
return fCaps2_Strings;
}
// --------------------------------------------------------------------------
