// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDDVideoPortDesc.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons)
// Description:  This file contains the code for the TDDVideoPortDesc 
//               Component 
//
// "TDx_Draw3D_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDDVideoPortDesc.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Draw3D_Library_Defns"
#pragma link "TDx_Draw3D_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDDVideoPortDesc*)
{
    new TDDVideoPortDesc(NULL);
}
// --------------------------------------------------------------------------
namespace Tddvideoportdesc
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDDVideoPortDesc)};
        RegisterComponents("TDx_Draw3D", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDDVideoPortDesc::TDDVideoPortDesc()
// Description: The default constructor for the TDDVideoPortDesc object.
// --------------------------------------------------------------------------
__fastcall TDDVideoPortDesc::TDDVideoPortDesc(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
}
// --------------------------------------------------------------------------
// Destructor:  TDDVideoPortDesc::~TDDVideoPortDesc()
// Description: The destructor for the TDDVideoPortDesc object.
// --------------------------------------------------------------------------
__fastcall TDDVideoPortDesc::~TDDVideoPortDesc()
{
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDDVideoPortDesc method or 
//              fget/fset. eg. D3D_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDDVideoPortDesc::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortDesc::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    FieldHeight
// Description: The FieldHeight property defines the field height, in scan 
//              lines, of the odd and even fields of the incoming video 
//              stream. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortDesc::FGetFieldHeight()
{
return fDDVIDEOPORTDESC.dwFieldHeight;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortDesc::FSetFieldHeight( dword pFieldHeight )
{
fDDVIDEOPORTDESC.dwFieldHeight = pFieldHeight;
}
// --------------------------------------------------------------------------
// Property:    FieldWidth
// Description: The FieldWidth property defines the width, in pixels, of the 
//              incoming video stream. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortDesc::FGetFieldWidth()
{
return fDDVIDEOPORTDESC.dwFieldWidth;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortDesc::FSetFieldWidth( dword pFieldWidth )
{
fDDVIDEOPORTDESC.dwFieldWidth = pFieldWidth;
}
// --------------------------------------------------------------------------
// Property:    MaxPixelsPerSecond
// Description: The MaxPixelsPerSecond property defines the maximum number of 
//              pixels per second the video port will allow. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortDesc::FGetMaxPixelsPerSecond()
{
return fDDVIDEOPORTDESC.dwMaxPixelsPerSecond;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortDesc::FSetMaxPixelsPerSecond( dword pMaxPixelsPerSecond )
{
fDDVIDEOPORTDESC.dwMaxPixelsPerSecond = pMaxPixelsPerSecond;
}
// --------------------------------------------------------------------------
// Property:    MicrosecondsPerField
// Description: The MicrosecondsPerField property defines the time interval, 
//              in microseconds, between live video VREF's. 
//              This value should be rounded up to the nearest microsecond. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortDesc::FGetMicrosecondsPerField()
{
return fDDVIDEOPORTDESC.dwMicrosecondsPerField;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortDesc::FSetMicrosecondsPerField( dword pMicrosecondsPerField )
{
fDDVIDEOPORTDESC.dwMicrosecondsPerField = pMicrosecondsPerField;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property defines the size, in bytes, of the internal 
//              structure used by this component. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortDesc::FGetSize()
{
return fDDVIDEOPORTDESC.dwSize;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortDesc::FSetSize( dword pSize )
{
fDDVIDEOPORTDESC.dwSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    VBIWidth
// Description: The VBIWidth property defines the width, in pixels, of the 
//              VBI data contained in the incoming video stream. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortDesc::FGetVBIWidth()
{
return fDDVIDEOPORTDESC.dwVBIWidth;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortDesc::FSetVBIWidth( dword pVBIWidth )
{
fDDVIDEOPORTDESC.dwVBIWidth = pVBIWidth;
}
// --------------------------------------------------------------------------
// Property:    VideoPortID
// Description: The VideoPortID property defines the ID of the video port 
//              that is to be used. 
//              This is the zero based reference to the physical video port. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortDesc::FGetVideoPortID()
{
return fDDVIDEOPORTDESC.dwVideoPortID;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortDesc::FSetVideoPortID( dword pVideoPortID )
{
fDDVIDEOPORTDESC.dwVideoPortID = pVideoPortID;
}
// --------------------------------------------------------------------------
// Property:    VideoPortType
// Description: The VideoPortType property references a TDDVideoPortConnect 
//              component describing the connection characteristics of the 
//              video port. 
// --------------------------------------------------------------------------
TDDVideoPortConnect* __fastcall TDDVideoPortDesc::FGetVideoPortType()
{
if (ComponentState.Contains(csDesigning) &&
    (fVideoPortType!=NULL) &&
    (Owner!=NULL))
    {
    bool component_exists = false;
    for (int i=0;i<Owner->ComponentCount;i++)
        if (Owner->Components[i]==fVideoPortType)
            {
            component_exists = true;
            break;
            }
    if (!component_exists) fVideoPortType=NULL;
    }
return fVideoPortType;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortDesc::FSetVideoPortType( TDDVideoPortConnect* pVideoPortType )
{
fVideoPortType = pVideoPortType;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDDVideoPortDesc's internal DDVIDEOPORTDESC structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortDesc::Clear()
{
fErrorValue = D3D_OK;
fDDVIDEOPORTDESC.dwFieldHeight = 0;
fDDVIDEOPORTDESC.dwFieldWidth = 0;
fDDVIDEOPORTDESC.dwMaxPixelsPerSecond = 0;
fDDVIDEOPORTDESC.dwMicrosecondsPerField = 0;
fDDVIDEOPORTDESC.dwSize = sizeof(DDVIDEOPORTDESC);
fDDVIDEOPORTDESC.dwVBIWidth = 0;
fDDVIDEOPORTDESC.dwVideoPortID = 0;
fVideoPortType = NULL;
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DDVIDEOPORTDESC* __fastcall TDDVideoPortDesc::FGetInternal_DDVIDEOPORTDESC_Ptr()
{
if (fVideoPortType!=NULL)
    if (fVideoPortType->ArraySize>0) CopyMemory( &fDDVIDEOPORTDESC.VideoPortType, fVideoPortType->Internal_DDVIDEOPORTCONNECT_Ptr, sizeof(DDVIDEOPORTCONNECT) );
    else ZeroMemory( &fDDVIDEOPORTDESC.VideoPortType, sizeof(DDVIDEOPORTCONNECT) );
return &fDDVIDEOPORTDESC;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortDesc::FSetInternal_DDVIDEOPORTDESC( DDVIDEOPORTDESC* pDDVIDEOPORTDESC )
{
if (pDDVIDEOPORTDESC==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDDVideoPortDesc::FSetInternal_DDVIDEOPORTDESC()", "TDX_ERROR", "The supplied DDVIDEOPORTDESC* was NULL" );
    return;
    }

CopyMemory( &fDDVIDEOPORTDESC, pDDVIDEOPORTDESC, sizeof(DDVIDEOPORTDESC) );
Internal_DDVIDEOPORTDESC_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortDesc::Internal_DDVIDEOPORTDESC_Update()
{
if (fVideoPortType!=NULL)
    if (fVideoPortType->ArraySize>0) CopyMemory( fVideoPortType->Internal_DDVIDEOPORTCONNECT_Ptr, &fDDVIDEOPORTDESC.VideoPortType, sizeof(DDVIDEOPORTCONNECT) );
}

// --------------------------------------------------------------------------
