// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDDVideoPortStatus.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons)
// Description:  This file contains the code for the TDDVideoPortStatus 
//               Component 
//
// "TDx_Draw3D_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDDVideoPortStatus.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Draw3D_Library_Defns"
#pragma link "TDx_Draw3D_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDDVideoPortStatus*)
{
    new TDDVideoPortStatus(NULL);
}
// --------------------------------------------------------------------------
namespace Tddvideoportstatus
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDDVideoPortStatus)};
        RegisterComponents("TDx_Draw3D", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDDVideoPortStatus::TDDVideoPortStatus()
// Description: The default constructor for the TDDVideoPortStatus object.
// --------------------------------------------------------------------------
__fastcall TDDVideoPortStatus::TDDVideoPortStatus(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
fFlags_Strings=NULL;
}
// --------------------------------------------------------------------------
// Destructor:  TDDVideoPortStatus::~TDDVideoPortStatus()
// Description: The destructor for the TDDVideoPortStatus object.
// --------------------------------------------------------------------------
__fastcall TDDVideoPortStatus::~TDDVideoPortStatus()
{
if (fFlags_Strings!=NULL) delete fFlags_Strings;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDDVideoPortStatus method or 
//              fget/fset. eg. D3D_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDDVideoPortStatus::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortStatus::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Flags
// Description: The Flags property defines flags indicating which portion of 
//              the video stream is being controlled by the video port. 
//              The described effect applies when the flag is set. 
// Flags:       DDVPSTATUS_VBIONLY -
//                The VBI portion of the video stream is being controlled by 
//                the video port. 
//              DDVPSTATUS_VIDEOONLY -
//                The normal portion of the video stream is being controlled 
//                by the video port. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortStatus::FGetFlags()
{
return fDDVIDEOPORTSTATUS.dwFlags;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortStatus::FSetFlags( dword pFlags )
{
fDDVIDEOPORTSTATUS.dwFlags = pFlags;
}
// --------------------------------------------------------------------------
// Property:    InUse
// Description: The InUse property will be set to true if the video port is 
//              currently in use. 
// --------------------------------------------------------------------------
bool __fastcall TDDVideoPortStatus::FGetInUse()
{
return fDDVIDEOPORTSTATUS.bInUse;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortStatus::FSetInUse( bool pInUse )
{
fDDVIDEOPORTSTATUS.bInUse = pInUse;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property defines the size, in bytes, of this 
//              component. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortStatus::FGetSize()
{
return fDDVIDEOPORTSTATUS.dwSize;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortStatus::FSetSize( dword pSize )
{
fDDVIDEOPORTSTATUS.dwSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    VideoPortType
// Description: The VideoPortType property references a TDDVideoPortConnect 
//              component describing the video port connection information. 
// --------------------------------------------------------------------------
TDDVideoPortConnect* __fastcall TDDVideoPortStatus::FGetVideoPortType()
{
if (ComponentState.Contains(csDesigning) &&
    (fVideoPortType!=NULL) &&
    (Owner!=NULL))
    {
    bool component_exists = false;
    for (int i=0;i<Owner->ComponentCount;i++)
        if (Owner->Components[i]==fVideoPortType)
            {
            component_exists = true;
            break;
            }
    if (!component_exists) fVideoPortType=NULL;
    }
return fVideoPortType;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortStatus::FSetVideoPortType( TDDVideoPortConnect* pVideoPortType )
{
fVideoPortType = pVideoPortType;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDDVideoPortStatus's internal DDVIDEOPORTSTATUS structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortStatus::Clear()
{
fErrorValue = D3D_OK;
fDDVIDEOPORTSTATUS.dwFlags = 0;
fDDVIDEOPORTSTATUS.bInUse = false;
fDDVIDEOPORTSTATUS.dwSize = sizeof(DDVIDEOPORTSTATUS);
fVideoPortType = NULL;
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DDVIDEOPORTSTATUS* __fastcall TDDVideoPortStatus::FGetInternal_DDVIDEOPORTSTATUS_Ptr()
{
if (fVideoPortType!=NULL)
    if (fVideoPortType->ArraySize>0) CopyMemory( &fDDVIDEOPORTSTATUS.VideoPortType, fVideoPortType->Internal_DDVIDEOPORTCONNECT_Ptr, sizeof(DDVIDEOPORTCONNECT) );
    else ZeroMemory( &fDDVIDEOPORTSTATUS.VideoPortType, sizeof(DDVIDEOPORTCONNECT) );
return &fDDVIDEOPORTSTATUS;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortStatus::FSetInternal_DDVIDEOPORTSTATUS( DDVIDEOPORTSTATUS* pDDVIDEOPORTSTATUS )
{
if (pDDVIDEOPORTSTATUS==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDDVideoPortStatus::FSetInternal_DDVIDEOPORTSTATUS()", "TDX_ERROR", "The supplied DDVIDEOPORTSTATUS* was NULL" );
    return;
    }

CopyMemory( &fDDVIDEOPORTSTATUS, pDDVIDEOPORTSTATUS, sizeof(DDVIDEOPORTSTATUS) );
Internal_DDVIDEOPORTSTATUS_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortStatus::Internal_DDVIDEOPORTSTATUS_Update()
{
if (fVideoPortType!=NULL)
    if (fVideoPortType->ArraySize>0) CopyMemory( fVideoPortType->Internal_DDVIDEOPORTCONNECT_Ptr, &fDDVIDEOPORTSTATUS.VideoPortType, sizeof(DDVIDEOPORTCONNECT) );
}

// --------------------------------------------------------------------------
// Method:      FGetFlags_
// Description: This method returns a TDDVideoPortStatus_Flags_Set<> of the 
//              flags in the current fDDVIDEOPORTSTATUS.dwFlags. 
// Note:        Wrapper components use the following method to modify flags 
//              via the BCB Object Inspector. 
// --------------------------------------------------------------------------
TDDVideoPortStatus_Flags_Set __fastcall TDDVideoPortStatus::FGetFlags_()
{
TDDVideoPortStatus_Flags_Set TempFlags_;
TempFlags_.Clear();
if (fDDVIDEOPORTSTATUS.dwFlags & DDVPSTATUS_VBIONLY) TempFlags_ = TempFlags_ << ddvpstatus_vbionly;
if (fDDVIDEOPORTSTATUS.dwFlags & DDVPSTATUS_VIDEOONLY) TempFlags_ = TempFlags_ << ddvpstatus_videoonly;
return TempFlags_;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortStatus::FSetFlags_( TDDVideoPortStatus_Flags_Set pFlags_ )
{
fDDVIDEOPORTSTATUS.dwFlags = 0;
if (pFlags_.Contains(ddvpstatus_vbionly)) fDDVIDEOPORTSTATUS.dwFlags |= DDVPSTATUS_VBIONLY;
if (pFlags_.Contains(ddvpstatus_videoonly)) fDDVIDEOPORTSTATUS.dwFlags |= DDVPSTATUS_VIDEOONLY;
}
// --------------------------------------------------------------------------
// Method:      FGetFlags_Strings()
//              This method creates and then returns a TStringList containing 
//              the current set of 'Flags' flags. 
// Note:        You must manually delete the retrieved TStringList after use 
//              to avoid memory corruption. 
// --------------------------------------------------------------------------
TStringList* __fastcall TDDVideoPortStatus::FGetFlags_Strings()
{
// if the strings have not been allocated
if (fFlags_Strings==NULL)
    {
    // attempt to allocate the strings
    fFlags_Strings = new TStringList();
    // if the allocation failed
    if (fFlags_Strings==NULL)
        {
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TDDVideoPortStatus::FGetFlags_Strings()", "TDX_ERROR", "Could not allocate memory used to retrieve various Flags_Strings" );
        return NULL;
        }
    }
fFlags_Strings->Clear();
if (fDDVIDEOPORTSTATUS.dwFlags & DDVPSTATUS_VBIONLY) fFlags_Strings->Add("DDVPSTATUS_VBIONLY");
if (fDDVIDEOPORTSTATUS.dwFlags & DDVPSTATUS_VIDEOONLY) fFlags_Strings->Add("DDVPSTATUS_VIDEOONLY");
return fFlags_Strings;
}
// --------------------------------------------------------------------------
